SystemOrganization addCategory: #'SqSquare-Client'!
SystemOrganization addCategory: #'SqSquare-Client-UI'!
SystemOrganization addCategory: #'SqSquare-Client-UI-ToolBar'!
SystemOrganization addCategory: #'SqSquare-Client-AudioChat'!
SystemOrganization addCategory: #'SqSquare-Client-Discovery'!
SystemOrganization addCategory: #'SqSquare-Client-Tests'!

CScrollPaneCostume subclass: #SqScrollPaneCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqScrollPaneCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="commandRegion" toSet="commandRegion:" changeEvent="commandRegionChanged">commandRegion</field>
	<field toGet="map" toSet="map:" changeEvent="mapChanged">map</field>
</fields>'!

!SqScrollPaneCostume methodsFor: 'initialize' stamp: 'mu 4/5/2006 14:46'!
close
	super close.
	commandRegion ifNotNilDo: [:c | c close].
	map ifNotNilDo: [:c | c close].! !

!SqScrollPaneCostume methodsFor: 'accessing' stamp: 'minami 3/9/2006 16:30'!
commandRegion
	"Answer the commandRegion of the receiver"
	<bewareOf: #commandRegionChanged>
	^self propertyValueAt: #commandRegion! !

!SqScrollPaneCostume methodsFor: 'accessing' stamp: 'minami 3/9/2006 16:30'!
commandRegion: aValue
	"Modify the receiver's commandRegion"
	^self propertyValueAt: #commandRegion put: aValue with: #commandRegionChanged! !

!SqScrollPaneCostume methodsFor: 'initialize' stamp: 'mu 4/5/2006 14:37'!
initialize
	super initialize.

	self define: #commandRegion as: CPlayer new.
	self startScript: #onMouseEnterCommandRegion when: {commandRegion. #mouseEnter}! !

!SqScrollPaneCostume methodsFor: 'accessing' stamp: 'minami 3/9/2006 16:54'!
map
	"Answer the map of the receiver"
	<bewareOf: #mapChanged>
	^self propertyValueAt: #map! !

!SqScrollPaneCostume methodsFor: 'accessing' stamp: 'minami 3/9/2006 16:54'!
map: aValue
	"Modify the receiver's map"
	^self propertyValueAt: #map put: aValue with: #mapChanged! !

!SqScrollPaneCostume methodsFor: 'events' stamp: 'minami 4/12/2006 14:00'!
onMouseEnterCommandRegion
	| board |
	board := self container board.
	self container board ifNil: [^ self].

	map ifNil: [
		map := SqBoardMap for: board.
		map 
			startScript: [map 
							releaseFromHalo;
							hide]
			when: {map. #mouseLeave}.
	].
	map openAt: (self hand position - map extent).
	map show.

! !

!SqScrollPaneCostume methodsFor: 'events' stamp: 'minami 4/12/2006 13:41'!
onUpdateLayout
	"update the position of all the elements"
	| inset box |
	<on: layoutChanged>
	box := self costume innerBounds.
	inset := 0@0.
	hScrollBar visible ifTrue:[inset := inset x @ hScrollBar height].
	vScrollBar visible ifTrue:[inset := vScrollBar width @ inset y].
	self positionTarget: inset in: box.
	hScrollBar visible ifTrue:[self positionHScrollBar: inset in: box].
	vScrollBar visible ifTrue:[self positionVScrollBar: inset in: box].
	
	self positionCommandRegion: inset in: box! !

!SqScrollPaneCostume methodsFor: 'layout' stamp: 'minami 3/9/2006 16:35'!
positionCommandRegion: inset in: box
	commandRegion left: box right - inset x.
	commandRegion top: box bottom - inset y.
	commandRegion width: inset x.
	commandRegion height: inset y.! !

!SqScrollPaneCostume methodsFor: 'initialize' stamp: 'minami 3/10/2006 12:24'!
setupCostume
	super setupCostume.
	
	self commandRegion 
			extent: 18@18; 
			color: Color red;
			text: 'v';
			textFont: (TextStyle named: 'HaloFont') defaultFont.
	self add: self commandRegion.! !

Object subclass: #SqClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-Tests'!

!SqClientTest class methodsFor: 'examples' stamp: 'mu 4/26/2006 11:58'!
makeCustomCursor01
"
	SqClientTest makeCustomCursor01
"
	| p h profile |
	profile _ SqUser new
				userId: 'GUEST'  ;
				initials: 'guest-' , (99 atRandom asString);
				color: Color random;
				icon: nil;
				yourself.


	p _ CPlayer new project.
	p addHand: (h _ CHandPlayer new).
	h setUserProfile: profile.
	h position: (600 atRandom@480 atRandom) .
	h inspect.
! !

!SqClientTest class methodsFor: 'examples' stamp: 'mu 4/26/2006 11:58'!
makeCustomCursor02
"
	SqClientTest makeCustomCursor02
"
	| p h profile |
	profile _ SqUser new
				userId: 'OWNER' ;
				initials: 'owner';
				color: Color red;
				icon: nil;
				yourself.


	p _ CPlayer new project.
	h _ p primaryHand.
	h setUserProfile: profile.
! !

Object subclass: #SqRpcClient
	instanceVariableNames: 'rpcConnector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client'!

SqRpcClient subclass: #SqBoardClient
	instanceVariableNames: 'eventsHolder connection isLoggedIn boardDescription authentication accessId eventPlayer eventSender'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client'!

!SqBoardClient class methodsFor: 'instance creation' stamp: 'mu 4/26/2006 13:58'!
of: aSqBoardDescription from: sqFacadeClient 
	| inst |
	inst := self new 
				 boardDescription: aSqBoardDescription;
				 authentication: sqFacadeClient authentication;
				 yourself.
	^ inst! !

!SqBoardClient methodsFor: 'accessing' stamp: 'mu 5/10/2006 12:40'!
accessId
	accessId ifNil: [accessId _ SqAccessId
								userId: self authentication userId
								imageId: SqImageId current
								boardId: self boardDescription boardId].
	^accessId! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 12:17'!
authentication
	^authentication! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 12:18'!
authentication: aSqAuthentication 
	authentication := aSqAuthentication! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 16:24'!
boardDescription
	^ boardDescription! !

!SqBoardClient methodsFor: 'accessing' stamp: 'mu 3/17/2006 14:16'!
boardDescription: bd
	boardDescription := bd! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 1/26/2006 17:53'!
boardId
	^ self accessId boardId! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 2/8/2006 14:38'!
boardName
	^ self boardDescription boardName! !

!SqBoardClient methodsFor: 'initialize' stamp: 'mu 4/4/2006 12:13'!
close
	super close.
	self closeConnection! !

!SqBoardClient methodsFor: 'actions-connection' stamp: 'MU 3/1/2006 10:26'!
closeConnection
	self stopEventSender.
	connection
		ifNotNilDo: [:con | con close].
	connection := nil.
	
	! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 15:19'!
connection
	connection ifNil: [self ensureConnection].
	^ connection! !

!SqBoardClient methodsFor: 'defaults' stamp: 'MU 1/20/2006 15:19'!
connectionClass
	^ SqExternalConnection! !

!SqBoardClient methodsFor: 'factory' stamp: 'mu 4/6/2006 16:12'!
ensureConnection
	"self isLoggedIn ifFalse: [^self]."

	[connection := self connectionClass
				connect: SqSettings serverHost
				to: SqSettings eventListenPort
				returnDo: [:msg | self receiveEvent: msg]
				accessId: self accessId]
		on: RmtNetworkError
		do: [:ex | ex log]! !

!SqBoardClient methodsFor: 'factory' stamp: 'mu 4/27/2006 17:06'!
ensureEventSender

	(eventSender notNil and: [eventSender isRunning]) ifTrue: [^self].
	eventSender _ SqEventSender on: self connection! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 1/29/2006 02:36'!
eventPlayer
	^eventPlayer! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 1/29/2006 02:36'!
eventPlayer: ep 
	eventPlayer := ep! !

!SqBoardClient methodsFor: 'accessing' stamp: 'mu 4/27/2006 17:04'!
eventSender
	eventSender ifNil: [self ensureEventSender].
	^eventSender! !

!SqBoardClient methodsFor: 'accessing' stamp: 'MU 3/1/2006 10:35'!
eventSender: anEventSender
	eventSender _ anEventSender! !

!SqBoardClient methodsFor: 'accessing' stamp: 'mu 4/28/2006 14:53'!
eventsHolder
	eventsHolder ifNil: [eventsHolder := SqClientEventRecordHolder new].
	^ eventsHolder! !

!SqBoardClient methodsFor: 'actions' stamp: 'mu 4/28/2006 14:31'!
firstEventVersion
	| events detected |
	events _ self eventsHolder events.
	events isEmptyOrNil ifTrue: [^0].
	detected _ events detect: [:each | each eventId notNil] ifNone: [^0].
	^detected eventId! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/8/2006 14:01'!
getAllEvents
	^self rpcGetAllEventsOf: self boardId! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/23/2006 19:01'!
getEventsFrom: startIndex to: endIndex 
	^ [self
		rpcGetEventsOf: self boardId
		from: startIndex
		to: endIndex]
		on: SqOutOfRange
		do: [:ex | ex return: #()]! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/23/2006 19:01'!
getLatestEventsFrom: startIndex 
	^ [self rpcGetLatestEventsOf: self boardId from: startIndex] on: SqOutOfRange
		do: [:ex | ex return: #()]! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/8/2006 12:07'!
getLatestSnapshot
	^self rpcGetLatestSnapshotOf: self boardId! !

!SqBoardClient methodsFor: 'actions' stamp: 'mu 3/7/2006 14:50'!
getLatestUpdateSeeds
	| latestSnap snapVersion startVersion alreadyHereVersion paddedEvents  |
	self isLoggedIn ifFalse: [^ nil].

	snapVersion := 0.
	latestSnap := self getLatestSnapshot.
	latestSnap notNil
		ifTrue: [snapVersion := latestSnap second asInteger].
	startVersion _ snapVersion + 1.
	alreadyHereVersion := self firstEventVersion.
	paddedEvents := alreadyHereVersion = 0
				ifTrue: [self getLatestEventsFrom: startVersion]
				ifFalse: [self getEventsFrom: startVersion to: alreadyHereVersion - 1].
	^{latestSnap. paddedEvents}! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 3/9/2006 14:28'!
imageId
	^ self accessId imageId! !

!SqBoardClient methodsFor: 'initialize' stamp: 'mu 4/6/2006 10:29'!
initialize
	super initialize.
	eventsHolder  _ connection _ nil.

	isLoggedIn _ false.! !

!SqBoardClient methodsFor: 'testing' stamp: 'MU 1/20/2006 15:19'!
isLoggedIn
	^ isLoggedIn == true
! !

!SqBoardClient methodsFor: 'actions-connection' stamp: 'MU 1/20/2006 15:19'!
keepConnection
	self isLoggedIn ifTrue: [
		self connection ifNotNilDo: [:con |
			con isValid ifFalse: [self openConnection].
		].
	]! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/7/2006 18:47'!
loggedIn
	isLoggedIn _ true! !

!SqBoardClient methodsFor: 'actions' stamp: 'MU 2/7/2006 18:47'!
loggedOut
	isLoggedIn _ true! !

!SqBoardClient methodsFor: 'actions-connection' stamp: 'MU 3/1/2006 10:26'!
openConnection
	self closeConnection.
	self ensureConnection.
	self startEventSender.
! !

!SqBoardClient methodsFor: 'event record mgmt' stamp: 'mu 4/28/2006 14:15'!
receiveEvent: eventRecord
	self eventsHolder add: eventRecord! !

!SqBoardClient methodsFor: 'event record mgmt' stamp: 'mu 3/2/2006 10:49'!
recordEvent: event
	event displayForDebug: 1.
	self eventSender add: event.
	! !

!SqBoardClient methodsFor: 'event record mgmt' stamp: 'mu 4/5/2006 16:52'!
registerEventPlayer: aEventPlayer
	self eventPlayer: aEventPlayer.
	self eventsHolder addDependent: aEventPlayer.
	! !

!SqBoardClient methodsFor: 'initialize' stamp: 'mu 4/6/2006 10:29'!
release
	super release.
	
	eventPlayer ifNotNilDo: [:p | p destroy].
	eventsHolder ifNotNilDo: [:p | p release].	
	
	eventPlayer _ eventsHolder _ connection _ isLoggedIn _ boardDescription _ authentication _ accessId _ nil! !

!SqBoardClient methodsFor: 'rpc' stamp: 'mu 4/26/2006 12:34'!
rpcGetAllEventsOf: boardId
	^self 
		invoke: #boardService
		selector: #getAllEventsOf:
		arguments: {boardId}! !

!SqBoardClient methodsFor: 'rpc' stamp: 'mu 4/26/2006 12:34'!
rpcGetEventsOf: boardId from: startIndex to: endIndex
	^self 
		invoke: #boardService
		selector: #getEventsOf:from:to:
		arguments: {boardId. startIndex. endIndex}! !

!SqBoardClient methodsFor: 'rpc' stamp: 'mu 4/26/2006 12:34'!
rpcGetLatestEventsOf: boardId from: startIndex
	^self 
		invoke: #boardService
		selector: #getLatestEventsOf:from:
		arguments: {boardId. startIndex}! !

!SqBoardClient methodsFor: 'rpc' stamp: 'mu 4/26/2006 12:34'!
rpcGetLatestSnapshotOf: boardId
	^self 
		invoke: #boardService
		selector: #getLatestSnapshotOf:
		arguments: {boardId}! !

!SqBoardClient methodsFor: 'actions' stamp: 'mu 5/8/2006 10:47'!
sendCursorPointChanged: point

	| event  |
	event :=  SqCursorPointChangedCommand accessId: self accessId point: point.
	self recordEvent: event.! !

!SqBoardClient methodsFor: 'actions' stamp: 'minami 5/10/2006 15:01'!
sendMouseCursorStyleChanged: style

	| event  |
	event :=  SqMouseCursorStyleChangedCommand accessId: self accessId style: style.
	self recordEvent: event.! !

!SqBoardClient methodsFor: 'actions' stamp: 'mu 3/17/2006 13:02'!
setExtent: extent

	| event  |
	event := SqGenericCommand accessId: self accessId selector: #extent: arguments: {extent}.
	self recordEvent: event.! !

!SqBoardClient methodsFor: 'sending process' stamp: 'mu 4/27/2006 17:07'!
startEventSender
	self stopEventSender.

	self eventSender start.
! !

!SqBoardClient methodsFor: 'sending process' stamp: 'mu 4/27/2006 17:12'!
stopEventSender
	eventSender ifNotNilDo: [:sender | sender stop].
	self eventSender: nil! !

!SqBoardClient methodsFor: 'event record mgmt' stamp: 'mu 4/5/2006 16:52'!
unregisterEventPlayer: aEventPlayer
	self eventsHolder removeDependent: aEventPlayer! !

!SqBoardClient methodsFor: 'accessing' stamp: 'minami 1/27/2006 17:26'!
userId
	^ self accessId userId! !

SqRpcClient subclass: #SqClient
	instanceVariableNames: 'boardClients userId authentication profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client'!

SqClient class
	instanceVariableNames: 'clients'!

!SqClient class methodsFor: 'actions' stamp: 'MU 1/24/2006 12:44'!
addClient: client
	self clients add: client.
	^client! !

!SqClient class methodsFor: 'accessing' stamp: 'MU 1/24/2006 13:00'!
clients
	clients
		ifNil: [clients := Set new].
	^ clients! !

!SqClient class methodsFor: 'actions' stamp: 'MU 2/23/2006 18:33'!
closeAll
	self allInstancesDo: [:e | e close].
	clients := nil! !

!SqClient class methodsFor: 'testing' stamp: 'minami 4/12/2006 14:28'!
hasOtherLoggedInClient: idStr
	self clients 
		reject: [:e | e userId = idStr]
		thenDo: [:e | e isLoggedIn ifTrue: [^ true]]. 
	^ false! !

!SqClient class methodsFor: 'class initialization' stamp: 'MU 2/23/2006 18:33'!
initialize
	"SqClient initialize"
	self closeAll.
	! !

!SqClient class methodsFor: 'utilities' stamp: 'mu 3/2/2006 10:52'!
playAll
	"SqClient playAll"
	self flag: #toBeDeleted.
	SqUIBuilder default playAll! !

!SqClient class methodsFor: 'actions' stamp: 'mu 4/4/2006 17:51'!
removeClient: client
	self clients remove: client.
	^client! !

!SqClient class methodsFor: 'instance creation' stamp: 'MU 1/24/2006 13:01'!
userId: idStr 
	| inst detected |
	detected _ self clients detect: [:e | e userId = idStr] ifNone: [].
	detected ifNotNil: [^ detected].

	inst _ self new userId: idStr.
	self clients add: inst.
	^ inst! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 13:06'!
authentication
	^ authentication! !

!SqClient methodsFor: 'accessing' stamp: 'mu 4/20/2006 17:33'!
boardAt: boardIdOrString
	^ self boards
		detect: [:e | e boardId asString = boardIdOrString asString]
		ifNone: []! !

!SqClient methodsFor: 'accessing' stamp: 'minami 1/23/2006 13:40'!
boardClientAt: boardId
	^ self boardClients at: boardId ifAbsent: []! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 10:23'!
boardClients
	boardClients ifNil: [boardClients _ Dictionary new].
	^ boardClients! !

!SqClient methodsFor: 'accessing' stamp: 'MU 2/22/2006 12:31'!
boardNamed: boardName 
	^ self boards
		detect: [:e | e boardName = boardName]
		ifNone: []! !

!SqClient methodsFor: 'actions' stamp: 'MU 2/22/2006 12:29'!
boards
	^ self rpcBoards! !

!SqClient methodsFor: 'initialize' stamp: 'mu 4/4/2006 18:19'!
close
	super close.
	self closeConnections.
! !

!SqClient methodsFor: 'actions' stamp: 'mu 4/4/2006 12:22'!
closeConnections
	self boardClients valuesDo: [:bc |
		bc close
	].! !

!SqClient methodsFor: 'actions' stamp: 'MU 2/22/2006 12:26'!
createNewBoard: boardName
	^ self rpcCreateNewBoard: boardName.

! !

!SqClient methodsFor: 'actions' stamp: 'mu 4/26/2006 13:56'!
enterIn: boardDescription
	| boardClient |
	boardClient _ SqBoardClient of: boardDescription from: self.
	boardClient openConnection.
	self boardClients at: boardClient boardId put: boardClient.
	
	boardClient loggedIn.

	^boardClient! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 19:00'!
imageId
	^ SqImageId current! !

!SqClient methodsFor: 'initialize' stamp: 'MU 2/8/2006 11:36'!
initialize
	super initialize.
	boardClients _ nil.
	authentication _ nil! !

!SqClient methodsFor: 'testing' stamp: 'mu 4/4/2006 17:50'!
isLoggedIn
	^self authentication notNil! !

!SqClient methodsFor: 'actions' stamp: 'MU 1/20/2006 17:11'!
keepConnections
	self boardClients valuesDo: [:bc | bc keepConnection].! !

!SqClient methodsFor: 'private' stamp: 'mu 4/26/2006 14:41'!
loggedIn
	
	profile _ self rpcUserProfileOf: userId	

	! !

!SqClient methodsFor: 'private' stamp: 'mu 4/26/2006 13:50'!
loggedOut
	authentication _ profile _ nil! !

!SqClient methodsFor: 'actions' stamp: 'mu 4/26/2006 12:12'!
login: userId password: passStr
	authentication _ self rpcLogin: userId password: passStr.
	authentication notNil ifTrue: [self loggedIn].
	^ authentication notNil! !

!SqClient methodsFor: 'actions' stamp: 'mu 4/27/2006 15:02'!
logout
	authentication
		ifNil: [^ nil].
	^ [self rpcLogout]
		ensure: [self loggedOut]! !

!SqClient methodsFor: 'accessing' stamp: 'mu 4/26/2006 13:51'!
profile
	^profile! !

!SqClient methodsFor: 'rpc' stamp: 'mu 4/26/2006 12:34'!
rpcBoards
	^self 
		invoke: #boardService
		selector: #boards
		arguments: {}! !

!SqClient methodsFor: 'rpc' stamp: 'mu 4/26/2006 12:34'!
rpcCreateNewBoard: boardName 
	^self 
		invoke: #boardService
		selector: #createNewBoard:
		arguments: {boardName}! !

!SqClient methodsFor: 'rpc' stamp: 'mu 4/26/2006 12:34'!
rpcLogin: userId password: passStr
	^self 
		invoke: #loginService
		selector: #login:password:
		arguments: {userId. passStr}! !

!SqClient methodsFor: 'rpc' stamp: 'mu 4/26/2006 12:34'!
rpcLogout
	^self 
		invoke: #loginService
		selector: #logout:
		arguments: {authentication}! !

!SqClient methodsFor: 'rpc' stamp: 'mu 4/26/2006 14:05'!
rpcUpdateUserProfileOf: useId
	self flag: #NotYet! !

!SqClient methodsFor: 'rpc' stamp: 'mu 4/26/2006 13:49'!
rpcUserProfileOf: useId
	^self 
		invoke: #userService
		selector: #userProfileOf:
		arguments: {useId}! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 12:41'!
userId
	^userId! !

!SqClient methodsFor: 'accessing' stamp: 'MU 1/24/2006 12:41'!
userId: idStr 
	userId := idStr! !

!SqRpcClient methodsFor: 'actions' stamp: 'mu 4/4/2006 12:23'!
close
	"rpcConnector ifNotNilDo: [:con | con closeIfOnlyNotPooled]."
	rpcConnector ifNotNilDo: [:con | con close].
	rpcConnector _ nil! !

!SqRpcClient methodsFor: 'initialize-release' stamp: 'MU 1/20/2006 15:59'!
initialize
	rpcConnector _ nil! !

!SqRpcClient methodsFor: 'invoking' stamp: 'mu 4/27/2006 15:05'!
invoke: serviceSymbol selector: selector arguments: args 
	"Needs error handling when RPC fails"
	^ [self rpcConnector
		invoke: serviceSymbol
		selector: selector
		arguments: args]
		on: RmtNetworkError
		do: [:ex | 
			ex log.
			self close.
			nil]! !

!SqRpcClient methodsFor: 'printing' stamp: 'MU 2/9/2006 14:41'!
printOn: aStream
	aStream nextPutAll: 'a ', self className, '('.
	rpcConnector ifNotNilDo: [:con | rpcConnector printOn: aStream].
	aStream nextPutAll: ')'.! !

!SqRpcClient methodsFor: 'initialize-release' stamp: 'mu 4/4/2006 12:20'!
release
	self close! !

!SqRpcClient methodsFor: 'accessing' stamp: 'MU 1/20/2006 16:41'!
rpcConnector
	rpcConnector := RmtRpcConnector pooling connect: SqSettings serverHost port: SqSettings rpcListenPort.
	^ rpcConnector! !

Object subclass: #SqUIBuilder
	instanceVariableNames: 'boards projectParams projectBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqUIBuilder class
	instanceVariableNames: 'default'!

!SqUIBuilder class methodsFor: 'instance creation' stamp: 'MU 2/8/2006 11:18'!
default
	default ifNil: [default _ self new].
	^default! !

!SqUIBuilder methodsFor: 'accessing project parameters' stamp: 'mu 4/19/2006 16:57'!
boardIdStirng
	^self projectParams at: #boardId ifAbsent:[].! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'minami 4/21/2006 18:12'!
boardPanelFor: boardClient
	"PRE: boardClient is already connected"

	| board boardPanel seeds |
	seeds := boardClient getLatestUpdateSeeds.

	Cursor wait showWhile: [
		board := self buildBoardFor: boardClient withSeeds: seeds.
	].

	boardPanel := SqBoardPanel on: board.
	boardPanel startAudioChat.

	^ boardPanel
! !

!SqUIBuilder methodsFor: 'accesing' stamp: 'MU 2/9/2006 15:33'!
boards
	boards ifNil: [boards _ WeakSet new].
	^boards! !

!SqUIBuilder methodsFor: 'builder' stamp: 'mu 4/28/2006 14:06'!
buildBoardFor: boardClient withSeeds: seeds 
	| snapshot events rawBoard |

	snapshot := seeds first.
	events := seeds second.
	rawBoard := snapshot
				ifNil: [SqEventRecordBoard new]
				ifNotNil: [self buildBoardFromSnapshot: snapshot].
	rawBoard boardClient: boardClient.

	rawBoard elements do: [:each | 
		each eventRecordBehavior ifNotNilDo: [:b |
			each detachEventRecordBehavior.
			each playerId: b targetId.
			rawBoard attachEventRecordBehavior: each.
			each eventRecordBehavior board: rawBoard.
			each eventRecordBehavior targetId: b targetId.
		].
	].

	rawBoard eventPlayer addAllFirst: events.

	rawBoard isRecovering: true. 
	rawBoard play.
	events notEmpty ifTrue: [rawBoard eventPlayer waitUntil: #allEventsExecuted].
	rawBoard isRecovering: false.
	
	self boards add: rawBoard.
	^ rawBoard! !

!SqUIBuilder methodsFor: 'builder' stamp: 'MU 2/24/2006 16:40'!
buildBoardFromSnapshot: snapshot
	| board |
	board _ CPlayer readSnapshotByteArray: snapshot last.
	board ifNil: [^nil].
	board isHeadless: false.
	board eventPlayer: nil.
	^board! !

!SqUIBuilder methodsFor: 'initialize-release' stamp: 'mu 4/20/2006 16:10'!
initialize
	boards _ nil.
	projectParams _ nil.
	projectBuilder _ nil! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'minami 4/21/2006 18:12'!
openBoardPanelFor: boardClient
	"PRE: boardClient is already connected"

	| board boardPanel seeds |
	seeds := boardClient getLatestUpdateSeeds.

	Cursor wait showWhile: [
		board := self buildBoardFor: boardClient withSeeds: seeds.
	].

	boardPanel := SqBoardPanel on: board.
	boardPanel open.

	boardPanel waitTick.
	boardPanel startAudioChat.
! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'minami 4/21/2006 18:15'!
openBoardTrayFor: boardClient in: aTray
	"PRE: boardClient is already connected"

	| board seeds |
	seeds := boardClient getLatestUpdateSeeds.

	Cursor wait showWhile: [
		board := self buildBoardFor: boardClient withSeeds: seeds.
	].

	aTray setBoard: board.

	aTray waitTick.
	aTray startAudioChat.
! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'mu 3/10/2006 15:40'!
openBoardWindowFor: boardClient
	"PRE: boardClient is already connected"

	| board win seeds |
	seeds := boardClient getLatestUpdateSeeds.

	Cursor wait showWhile: [
		board := self buildBoardFor: boardClient withSeeds: seeds.
	].

	win := SqBoardWindow on: board.
	win open.
! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'MU 2/8/2006 14:40'!
openBoardWindow: boardDescription userId: userId 
	"PRE: client has been authenticated"
	| client bc |
	client := SqClient userId: userId.
	client
		ifNil: [^ self].
	bc := client boardClientAt: boardDescription boardId.
	bc
		ifNil: [^ self].
	^ self openBoardWindowFor: bc! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'mu 4/21/2006 16:59'!
openProject
	| window |
	self projectIsOpen
		ifTrue: [self projectBuilder compositePanel loginAndSelectBoard]
		ifFalse: [window := CProjectMorph open: SqProjectBuilder.
			window world doOneCycle.
			window extent: ActiveWorld extent - 10.
			window center: ActiveWorld center]! !

!SqUIBuilder methodsFor: 'interface opening' stamp: 'mu 4/20/2006 11:57'!
openProjectWith: entryParams
	projectParams _ entryParams.
	self openProject! !

!SqUIBuilder methodsFor: 'utilities' stamp: 'MU 2/9/2006 15:33'!
playAll
	"just workaround"
	"SqUIBuilder default boards"
	"SqUIBuilder default playAll"

	self boards do: [:each | each play]

	
	! !

!SqUIBuilder methodsFor: 'accesing' stamp: 'mu 4/20/2006 16:09'!
projectBuilder
	projectBuilder ifNil: [projectBuilder _ WeakArray new: 1].
	^projectBuilder at: 1! !

!SqUIBuilder methodsFor: 'accesing' stamp: 'mu 4/20/2006 16:08'!
projectBuilder: aProjectBuilder
	projectBuilder at: 1 put: aProjectBuilder! !

!SqUIBuilder methodsFor: 'testing' stamp: 'mu 4/20/2006 16:10'!
projectIsOpen
	^self projectBuilder notNil! !

!SqUIBuilder methodsFor: 'accesing' stamp: 'mu 4/19/2006 16:56'!
projectParams
	projectParams ifNil: [projectParams _ IdentityDictionary new].
	^projectParams! !

!SqUIBuilder methodsFor: 'accessing project parameters' stamp: 'mu 4/19/2006 16:57'!
sessionKey
	^self projectParams at: #sessionKey ifAbsent:[].! !

!SqUIBuilder methodsFor: 'accessing project parameters' stamp: 'mu 4/19/2006 16:57'!
userIdString
	^self projectParams at: #userId ifAbsent:[].! !

SqToolBar subclass: #SqAccessToolBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI-ToolBar'!

SqAccessToolBar defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="toolList" toSet="toolList:" changeEvent="toolListChanged">toolList</field>
</fields>'!

!SqAccessToolBar class methodsFor: 'accessing' stamp: 'minami 4/17/2006 15:27'!
handImage
	^ self imageAt: #handImage ifAbsentPut: [Form fromCompactBytes: self handImageArray].! !

!SqAccessToolBar class methodsFor: 'private' stamp: 'minami 4/17/2006 15:37'!
handImageArray
	^  #(2 8 0 32 0 32 0 0 0 0 4 2 4 255 252 254 252 255 0 0 0 0 119 0 0 255 68 0 123 255 228 0 35 255 18 0 0 255 1 0 0 255 47 0 7 255 0 0 32 255 1 0 0 255 1 0 0 255 5 0 0 255 1 0 0 255 0 0 21 255 1 0 0 255 0 0 14 255 1 0 0 255 1 0 0 255 1 0 0 255 64 0 0 255 95 0 2 255 129 0 0 255 1 0 0 255 2 0 0 255 0 0 5 255 1 0 0 255 1 0 0 255 23 190 136 255 0 148 226 255 0 207 18 255 0 119 0 255 74 45 121 255 0 180 8 255 0 207 130 255 0 119 124 255 255 146 0 255 1 2 0 255 0 188 1 255 1 0 0 255 157 32 86 255 1 0 0 255 1 0 0 255 1 0 0 255 23 194 144 255 0 3 225 255 0 77 18 255 1 0 0 255 74 1 71 255 1 0 0 255 1 0 0 255 0 2 0 255 255 0 176 255 1 0 226 255 0 0 18 255 1 0 0 255 157 158 24 255 0 2 238 255 0 0 148 255 0 0 124 255 23 1 112 255 0 0 5 255 0 0 149 255 0 0 124 255 55 216 255 255 0 241 255 255 0 18 255 255 0 0 255 255 255 16 109 255 1 247 5 255 0 69 149 255 0 0 124 255 157 32 21 255 0 0 10 255 0 0 130 255 0 0 124 255 47 0 0 255 1 0 0 255 0 0 21 255 1 0 0 255 67 0 176 255 0 0 3 255 1 0 0 255 1 0 0 255 152 0 144 255 228 0 236 255 18 0 25 255 1 0 0 255 219 0 8 255 191 0 98 255 207 0 21 255 119 0 0 255 64 0 0 255 95 0 0 255 129 0 0 255 1 0 0 255 47 0 126 255 1 0 0 255 67 0 0 255 0 0 192 255 252 0 0 255 242 0 0 255 18 0 0 255 1 0 0 255 16 0 255 255 247 0 255 255 69 0 255 255 0 0 255 255 132 144 255 255 0 227 255 255 0 18 255 255 0 0 255 255 0 152 0 255 0 213 0 255 0 207 0 255 0 119 0 255 0 146 0 255 0 2 0 255 0 188 0 255 1 0 0 255 0 32 0 255 1 0 0 255 0 0 21 255 1 0 0 255 18 194 148 255 159 3 40 255 128 77 0 255 124 0 0 255 24 1 192 255 44 0 226 255 22 0 18 255 0 2 0 255 0 1 47 255 0 0 14 255 0 0 130 255 0 0 124 255 7 216 219 255 0 227 5 255 0 18 130 255 0 0 124 255 0 69 192 255 0 213 118 255 0 207 80 255 0 119 0 255 0 146 8 255 32 2 98 255 22 188 1 255 1 0 0 255 0 32 118 255 1 0 0 255 1 0 0 255 1 0 0 255 0 148 252 255 0 40 225 255 0 0 18 255 1 0 0 255 0 216 52 255 0 227 0 255 0 18 0 255 0 0 192 255 0 131 248 255 0 42 247 255 0 130 18 255 0 124 0 255 24 0 24 255 159 0 238 255 128 0 148 255 124 0 124 255 255 0 112 255 255 0 5 255 255 0 149 255 255 0 124 255 18 0 255 255 159 0 255 255 128 0 255 255 124 0 255 255 67 0 109 255 0 1 5 255 0 0 149 255 0 0 124 255 67 231 74 255 0 42 246 255 0 130 128 255 0 124 124 255 72 252 0 255 235 227 0 255 18 18 21 255 1 0 0 255 255 194 0 255 255 42 0 255 255 130 0 255 255 124 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 4 24 0 255 229 44 1 255 18 22 0 255 1 0 0 255 190 190 0 255 59 62 0 255 76 130 0 255 0 124 0 255 228 255 87 255 228 255 246 255 18 255 128 255 0 255 124 255 119 0 232 255 16 229 227 255 79 18 18 255 1 0 0 255 24 247 8 255 229 62 98 255 18 130 21 255 0 124 0 255 190 12 0 255 62 20 0 255 130 79 0 255 124 0 0 255 203 212 0 255 229 50 0 255 18 79 0 255 1 0 0 255 187 0 0 255 255 1 0 255 255 0 0 255 127 0 0 255 136 252 0 255 229 227 0 255 18 18 0 255 1 0 0 255 24 0 0 255 44 1 0 255 22 0 0 255 1 0 0 255 190 22 0 255 62 63 0 255 130 130 0 255 124 124 0 255 24 1 0 255 44 0 0 255 22 0 0 255 1 0 0 255 148 0 0 255 40 48 0 255 1 0 0 255 0 118 0 255 0 92 0 255 0 105 0 255 0 99 0 255 0 111 0 255 233 110 0 255 206 115 0 255 71 0 0 255 1 0 0 255 128 225 28 225 0 224 237 2 7 2 0 0 0 25 2 15 2 0 0 0 2 0 1 1 0 0 0 0 21 2 15 2 0 1 1 0 0 1 1 0 1 1 0 21 2 19 2 0 1 1 0 0 1 1 0 1 1 0 2 0 2 2 17 2 19 2 0 0 1 1 0 1 1 0 1 1 0 0 1 0 2 17 2 19 2 2 0 1 1 0 1 1 0 1 1 0 1 1 0 2 13 2 23 2 2 2 0 0 0 2 0 1 1 1 1 1 1 1 0 1 1 0 2 13 2 11 2 2 2 0 1 1 0 0 9 1 7 1 1 0 2 13 2 11 2 2 2 0 1 1 1 0 9 1 7 1 0 2 2 17 2 7 0 1 1 1 9 1 7 1 0 2 2 17 2 7 2 0 1 1 9 1 7 1 0 2 2 17 2 7 2 0 1 1 9 1 7 0 2 2 2 17 2 7 2 2 0 1 9 1 7 0 2 2 2 17 2 19 2 2 2 0 1 1 1 1 1 1 1 0 0 2 2 2 21 2 11 0 1 1 1 1 1 1 0 25 2 11 0 1 1 1 1 1 1 0 21 2 7 2 2 2 0 9 1 7 0 2 2 2 17 2 7 2 2 2 0 9 0 7 0 2 2 2 224 233 2) asByteArray! !

!SqAccessToolBar class methodsFor: 'accessing' stamp: 'minami 5/12/2006 11:24'!
penImage
	^ self imageAt: #penImage ifAbsentPut: [Form fromCompactBytes: self penImageArray].! !

!SqAccessToolBar class methodsFor: 'private' stamp: 'minami 5/12/2006 11:23'!
penImageArray
	^  #(2 8 0 32 0 32 0 0 0 0 1 0 0 255 0 0 128 255 0 128 0 255 0 128 128 255 128 0 0 255 128 0 128 255 128 128 0 255 192 192 192 255 192 220 192 255 240 202 166 255 0 32 64 255 0 32 96 255 0 32 128 255 0 32 160 255 0 32 192 255 0 32 224 255 0 64 0 255 0 64 32 255 0 64 64 255 0 64 96 255 0 64 128 255 0 64 160 255 0 64 192 255 0 64 224 255 0 96 0 255 0 96 32 255 0 96 64 255 0 96 96 255 0 96 128 255 0 96 160 255 0 96 192 255 0 96 224 255 0 128 0 255 0 128 32 255 0 128 64 255 0 128 96 255 0 128 128 255 0 128 160 255 0 128 192 255 0 128 224 255 0 160 0 255 0 160 32 255 0 160 64 255 0 160 96 255 0 160 128 255 0 160 160 255 0 160 192 255 0 160 224 255 0 192 0 255 0 192 32 255 0 192 64 255 0 192 96 255 0 192 128 255 0 192 160 255 0 192 192 255 0 192 224 255 0 224 0 255 0 224 32 255 0 224 64 255 0 224 96 255 0 224 128 255 0 224 160 255 0 224 192 255 0 224 224 255 64 0 0 255 64 0 32 255 64 0 64 255 64 0 96 255 64 0 128 255 64 0 160 255 64 0 192 255 64 0 224 255 64 32 0 255 64 32 32 255 64 32 64 255 64 32 96 255 64 32 128 255 64 32 160 255 64 32 192 255 64 32 224 255 64 64 0 255 64 64 32 255 64 64 64 255 64 64 96 255 64 64 128 255 64 64 160 255 64 64 192 255 64 64 224 255 64 96 0 255 64 96 32 255 64 96 64 255 64 96 96 255 64 96 128 255 64 96 160 255 64 96 192 255 64 96 224 255 64 128 0 255 64 128 32 255 64 128 64 255 64 128 96 255 64 128 128 255 64 128 160 255 64 128 192 255 64 128 224 255 64 160 0 255 64 160 32 255 64 160 64 255 64 160 96 255 64 160 128 255 64 160 160 255 64 160 192 255 64 160 224 255 64 192 0 255 64 192 32 255 64 192 64 255 64 192 96 255 64 192 128 255 64 192 160 255 64 192 192 255 64 192 224 255 64 224 0 255 64 224 32 255 64 224 64 255 64 224 96 255 64 224 128 255 64 224 160 255 64 224 192 255 64 224 224 255 128 0 0 255 128 0 32 255 128 0 64 255 128 0 96 255 128 0 128 255 128 0 160 255 128 0 192 255 128 0 224 255 128 32 0 255 128 32 32 255 128 32 64 255 128 32 96 255 128 32 128 255 128 32 160 255 128 32 192 255 128 32 224 255 128 64 0 255 128 64 32 255 128 64 64 255 128 64 96 255 128 64 128 255 128 64 160 255 128 64 192 255 128 64 224 255 128 96 0 255 128 96 32 255 128 96 64 255 128 96 96 255 128 96 128 255 128 96 160 255 128 96 192 255 128 96 224 255 128 128 0 255 128 128 32 255 128 128 64 255 128 128 96 255 128 128 128 255 128 128 160 255 128 128 192 255 128 128 224 255 128 160 0 255 128 160 32 255 128 160 64 255 128 160 96 255 128 160 128 255 128 160 160 255 128 160 192 255 128 160 224 255 128 192 0 255 128 192 32 255 128 192 64 255 128 192 96 255 128 192 128 255 128 192 160 255 128 192 192 255 128 192 224 255 128 224 0 255 128 224 32 255 128 224 64 255 128 224 96 255 128 224 128 255 128 224 160 255 128 224 192 255 128 224 224 255 192 0 0 255 192 0 32 255 192 0 64 255 192 0 96 255 192 0 128 255 192 0 160 255 192 0 192 255 192 0 224 255 192 32 0 255 192 32 32 255 192 32 64 255 192 32 96 255 192 32 128 255 192 32 160 255 192 32 192 255 192 32 224 255 192 64 0 255 192 64 32 255 192 64 64 255 192 64 96 255 192 64 128 255 192 64 160 255 192 64 192 255 192 64 224 255 192 96 0 255 192 96 32 255 192 96 64 255 192 96 96 255 192 96 128 255 192 96 160 255 192 96 192 255 192 96 224 255 192 128 0 255 192 128 32 255 192 128 64 255 192 128 96 255 192 128 128 255 192 128 160 255 192 128 192 255 192 128 224 255 192 160 0 255 192 160 32 255 192 160 64 255 192 160 96 255 192 160 128 255 192 160 160 255 192 160 192 255 192 160 224 255 192 192 0 255 192 192 32 255 192 192 64 255 192 192 96 255 192 192 128 255 192 192 160 255 240 251 255 255 164 160 160 255 128 128 128 255 0 0 255 255 0 255 0 255 0 255 255 255 255 0 0 255 255 0 255 255 255 255 0 255 255 255 255 255 128 204 225 0 224 245 249 7 249 0 73 249 29 249 7 0 82 82 73 25 249 15 249 249 249 73 82 155 247 155 73 249 249 249 21 249 15 249 249 249 82 91 247 7 7 73 249 249 249 21 249 11 249 249 82 91 247 7 7 73 25 249 11 249 82 91 247 7 7 73 249 25 249 11 0 91 164 7 7 164 249 249 21 249 15 249 249 249 0 82 164 247 7 164 249 249 249 21 249 11 249 249 73 82 164 247 7 164 25 249 11 249 73 73 82 247 7 164 249 25 249 5 0 7 73 164 249 249 21 249 15 249 249 82 91 82 0 0 0 82 249 249 249 21 249 15 249 82 73 73 73 82 0 82 73 249 249 249 17 249 15 249 249 249 73 0 0 0 82 164 155 82 249 21 249 15 249 249 249 82 73 0 0 73 82 82 249 249 21 249 15 249 249 249 164 82 73 0 0 73 249 249 249 225 49 249) asByteArray! !

!SqAccessToolBar class methodsFor: 'accessing' stamp: 'minami 4/17/2006 15:28'!
pointerImage
	^ self imageAt: #pointerImage ifAbsentPut: [Form fromCompactBytes: self pointerImageArray].! !

!SqAccessToolBar class methodsFor: 'private' stamp: 'minami 4/17/2006 15:27'!
pointerImageArray
	^  #(2 8 0 32 0 32 0 0 0 0 4 2 4 255 0 0 0 0 1 0 0 255 1 0 0 255 0 0 123 255 0 0 35 255 1 0 0 255 1 0 0 255 0 0 7 255 0 0 32 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 21 255 1 0 0 255 0 0 14 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 2 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 5 255 1 0 0 255 1 0 0 255 0 190 136 255 0 148 226 255 0 207 18 255 0 119 0 255 0 45 121 255 0 180 8 255 0 207 130 255 0 119 124 255 0 146 0 255 0 2 0 255 0 159 1 255 1 0 0 255 0 32 86 255 1 0 0 255 1 0 0 255 1 0 0 255 0 232 144 255 0 3 225 255 0 66 18 255 1 0 0 255 0 1 71 255 1 0 0 255 1 0 0 255 0 2 0 255 0 0 176 255 0 0 226 255 0 0 18 255 1 0 0 255 0 158 24 255 0 2 238 255 0 0 148 255 0 0 124 255 0 1 112 255 0 0 5 255 0 0 149 255 0 0 124 255 0 216 255 255 0 241 255 255 0 18 255 255 0 0 255 255 0 16 109 255 0 247 5 255 0 69 149 255 0 0 124 255 0 32 21 255 0 0 10 255 0 0 130 255 0 0 124 255 1 0 0 255 1 0 0 255 0 0 21 255 1 0 0 255 0 0 176 255 0 0 3 255 1 0 0 255 1 0 0 255 0 0 192 255 0 0 237 255 0 0 24 255 1 0 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 126 255 1 0 0 255 1 0 0 255 0 0 192 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 255 255 0 0 255 255 0 0 255 255 0 0 255 255 0 144 255 255 0 227 255 255 0 18 255 255 0 0 255 255 0 152 0 255 0 213 0 255 0 207 0 255 0 119 0 255 0 146 0 255 0 2 0 255 0 159 0 255 1 0 0 255 0 32 0 255 1 0 0 255 0 0 21 255 1 0 0 255 18 232 156 255 159 3 229 255 128 66 0 255 124 0 0 255 8 1 192 255 208 0 226 255 22 0 18 255 0 2 0 255 0 1 47 255 0 0 14 255 0 0 130 255 0 0 124 255 7 216 219 255 0 227 5 255 0 18 130 255 0 0 124 255 0 69 192 255 0 213 118 255 0 207 80 255 0 119 0 255 0 146 8 255 208 2 98 255 22 159 1 255 1 0 0 255 0 32 118 255 1 0 0 255 1 0 0 255 1 0 0 255 0 156 252 255 0 229 225 255 0 0 18 255 1 0 0 255 0 216 52 255 0 227 0 255 0 18 0 255 0 0 192 255 0 131 248 255 0 42 247 255 0 130 18 255 0 124 0 255 24 0 24 255 159 0 238 255 128 0 148 255 124 0 124 255 255 0 112 255 255 0 5 255 255 0 149 255 255 0 124 255 18 0 255 255 159 0 255 255 128 0 255 255 124 0 255 255 70 0 109 255 0 1 5 255 0 0 149 255 0 0 124 255 70 231 74 255 0 42 246 255 0 130 128 255 0 124 124 255 72 252 0 255 235 227 0 255 18 18 21 255 1 0 0 255 255 194 0 255 255 42 0 255 255 130 0 255 255 124 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 4 8 0 255 229 208 1 255 18 22 0 255 1 0 0 255 190 190 0 255 59 62 0 255 76 130 0 255 0 124 0 255 228 255 87 255 228 255 246 255 18 255 128 255 0 255 124 255 119 0 232 255 16 229 227 255 79 18 18 255 1 0 0 255 24 247 8 255 229 62 98 255 18 130 21 255 0 124 0 255 190 12 0 255 62 20 0 255 130 79 0 255 124 0 0 255 206 212 0 255 229 50 0 255 18 79 0 255 1 0 0 255 184 0 0 255 255 1 0 255 255 0 0 255 127 0 0 255 136 252 0 255 229 227 0 255 18 18 0 255 1 0 0 255 8 0 0 255 208 1 0 255 22 0 0 255 1 0 0 255 190 22 0 255 62 63 0 255 130 130 0 255 124 124 0 255 8 1 0 255 208 0 0 255 22 0 0 255 1 0 0 255 156 0 0 255 229 48 0 255 1 0 0 255 0 118 0 255 0 92 0 255 0 105 0 255 0 99 0 255 0 111 0 255 233 110 0 255 206 115 0 255 71 0 0 255 1 0 0 255 128 186 225 0 225 9 1 7 0 0 0 1 29 1 5 0 7 0 0 1 1 25 1 9 0 25 1 15 1 0 0 0 0 0 0 0 0 0 0 1 21 1 7 1 0 0 0 9 0 21 1 15 1 0 0 0 0 0 0 0 0 0 0 1 21 1 15 1 1 0 0 0 0 0 0 0 0 1 1 21 1 15 1 1 0 0 0 0 0 0 0 0 1 1 21 1 15 1 1 1 0 0 0 0 0 0 0 0 1 21 1 7 1 1 1 0 9 0 21 1 19 1 1 1 0 0 0 1 1 0 0 0 0 0 1 1 1 21 1 15 0 1 1 1 1 0 0 0 0 0 1 1 25 1 11 1 1 0 0 0 0 0 1 25 1 11 1 1 1 0 0 0 0 0 29 1 5 0 29 1 7 1 0 0 1 225 9 1) asByteArray! !

!SqAccessToolBar methodsFor: 'intialize' stamp: 'minami 4/17/2006 15:29'!
buildToolButtons

	| symbols labelsImages buttons button |
	symbols _ #(#handTrail #normal ).
	labelsImages _ {self class handImage. self class pointerImage}.
	buttons _ OrderedCollection new.
	symbols
		keysAndValuesDo: [:index :symbol | 
			button _ CRadioButton new.
			button costume: CToolBarButtonCostume new.
			button value: symbol.
			button
				image: (labelsImages at: index).
"			button font: (TextStyle named: #WindowFont) defaultFont."
			button extent: self defaultButtonExtent.
			buttons add: button].
	^ buttons! !

!SqAccessToolBar methodsFor: 'intialize' stamp: 'minami 4/13/2006 14:35'!
buildToolList
	toolList := CButtonList new.
	toolList layout: CTableLayout new.
	toolList layout listDirection: #leftToRight.
	toolList hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	toolList layout cellInset: 2.
	toolList addAll: self buildToolButtons.

	self add: toolList! !

!SqAccessToolBar methodsFor: 'intialize' stamp: 'minami 4/13/2006 14:05'!
initialize
	super initialize.
! !

!SqAccessToolBar methodsFor: 'events' stamp: 'minami 4/14/2006 15:06'!
onToolListValueChanged: aSymbol
	<on: valueChanged in: toolList>

	self target ifNil: [^ self].
	self target setSelectionMode: aSymbol! !

!SqAccessToolBar methodsFor: 'actions' stamp: 'minami 4/14/2006 11:57'!
setButtonState: aSymbol
	aSymbol == #normal ifTrue: [self halt].
	aSymbol == #handTrail ifTrue: [self halt].! !

!SqAccessToolBar methodsFor: 'intialize' stamp: 'minami 4/13/2006 14:35'!
setupCostume
	super setupCostume.

	self buildToolList.
! !

!SqAccessToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 14:34'!
toolList
	"Answer the toolList of the receiver"
	<bewareOf: #toolListChanged>
	^self propertyValueAt: #toolList! !

!SqAccessToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 14:34'!
toolList: aValue
	"Modify the receiver's toolList"
	^self propertyValueAt: #toolList put: aValue with: #toolListChanged! !

SqToolBar subclass: #SqBoardSettingToolBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI-ToolBar'!

SqBoardSettingToolBar defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="extentButton" toSet="extentButton:" changeEvent="extentButtonChanged">extentButton</field>
</fields>'!

!SqBoardSettingToolBar class methodsFor: 'accessing' stamp: 'minami 4/17/2006 16:30'!
extentImage
	^ self imageAt: #extent ifAbsentPut: [Form fromCompactBytes: self extentImageArray].! !

!SqBoardSettingToolBar class methodsFor: 'private' stamp: 'minami 4/17/2006 16:34'!
extentImageArray
	^  #(2 8 0 32 0 32 0 0 0 0 4 2 4 255 132 134 132 255 196 198 196 255 188 186 188 255 148 154 156 255 0 0 0 0 252 250 252 255 196 194 196 255 36 38 36 255 132 138 140 255 188 190 188 255 164 162 164 255 252 254 252 255 1 0 0 255 0 0 21 255 1 0 0 255 0 0 14 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 2 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 5 255 1 0 0 255 1 0 0 255 0 190 136 255 0 148 226 255 0 207 18 255 0 119 0 255 0 45 121 255 0 180 8 255 0 207 130 255 0 119 124 255 0 146 0 255 0 2 0 255 0 188 1 255 1 0 0 255 0 32 86 255 1 0 0 255 1 0 0 255 1 0 0 255 0 194 144 255 0 3 225 255 0 77 18 255 1 0 0 255 0 1 71 255 1 0 0 255 1 0 0 255 0 2 0 255 0 0 176 255 0 0 226 255 0 0 18 255 1 0 0 255 0 158 24 255 0 2 238 255 0 0 148 255 0 0 124 255 0 1 112 255 0 0 5 255 0 0 149 255 0 0 124 255 0 216 255 255 0 241 255 255 0 18 255 255 0 0 255 255 0 16 109 255 0 247 5 255 0 69 149 255 0 0 124 255 0 32 21 255 0 0 10 255 0 0 130 255 0 0 124 255 1 0 0 255 1 0 0 255 0 0 21 255 1 0 0 255 0 0 176 255 0 0 3 255 1 0 0 255 1 0 0 255 0 0 144 255 0 0 236 255 0 0 25 255 1 0 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 126 255 1 0 0 255 1 0 0 255 0 0 192 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 255 255 0 0 255 255 0 0 255 255 0 0 255 255 0 144 255 255 0 227 255 255 0 18 255 255 0 0 255 255 0 152 0 255 0 213 0 255 0 207 0 255 0 119 0 255 0 146 0 255 0 2 0 255 0 188 0 255 1 0 0 255 0 32 0 255 1 0 0 255 0 0 21 255 1 0 0 255 18 194 148 255 159 3 40 255 128 77 0 255 124 0 0 255 24 1 192 255 44 0 226 255 22 0 18 255 0 2 0 255 0 1 47 255 0 0 14 255 0 0 130 255 0 0 124 255 7 216 219 255 0 227 5 255 0 18 130 255 0 0 124 255 0 69 192 255 0 213 118 255 0 207 80 255 0 119 0 255 0 146 8 255 32 2 98 255 22 188 1 255 1 0 0 255 0 32 118 255 1 0 0 255 1 0 0 255 1 0 0 255 0 148 252 255 0 40 225 255 0 0 18 255 1 0 0 255 0 216 52 255 0 227 0 255 0 18 0 255 0 0 192 255 0 131 248 255 0 42 247 255 0 130 18 255 0 124 0 255 24 0 24 255 159 0 238 255 128 0 148 255 124 0 124 255 255 0 112 255 255 0 5 255 255 0 149 255 255 0 124 255 18 0 255 255 159 0 255 255 128 0 255 255 124 0 255 255 69 0 109 255 0 1 5 255 0 0 149 255 0 0 124 255 69 231 74 255 0 42 246 255 0 130 128 255 0 124 124 255 72 252 0 255 235 227 0 255 18 18 21 255 1 0 0 255 255 194 0 255 255 42 0 255 255 130 0 255 255 124 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 4 24 0 255 229 44 1 255 18 22 0 255 1 0 0 255 190 190 0 255 59 62 0 255 76 130 0 255 0 124 0 255 228 255 87 255 228 255 246 255 18 255 128 255 0 255 124 255 119 0 232 255 16 229 227 255 79 18 18 255 1 0 0 255 24 247 8 255 229 62 98 255 18 130 21 255 0 124 0 255 190 12 0 255 62 20 0 255 130 79 0 255 124 0 0 255 205 212 0 255 229 50 0 255 18 79 0 255 1 0 0 255 185 0 0 255 255 1 0 255 255 0 0 255 127 0 0 255 136 252 0 255 229 227 0 255 18 18 0 255 1 0 0 255 24 0 0 255 44 1 0 255 22 0 0 255 1 0 0 255 190 22 0 255 62 63 0 255 130 130 0 255 124 124 0 255 24 1 0 255 44 0 0 255 22 0 0 255 1 0 0 255 148 0 0 255 40 48 0 255 1 0 0 255 0 118 0 255 0 92 0 255 0 105 0 255 0 99 0 255 0 111 0 255 233 110 0 255 206 115 0 255 71 0 0 255 1 0 0 255 128 225 9 225 0 225 9 5 7 5 4 0 0 9 0 7 0 4 5 5 17 5 7 5 0 12 12 9 12 7 2 0 5 5 17 5 19 5 0 12 0 0 0 12 12 12 0 0 0 2 0 5 5 17 5 19 5 0 12 0 0 12 12 12 12 12 0 0 2 0 5 5 17 5 19 5 0 12 0 12 12 12 12 12 12 12 0 2 0 5 5 17 5 7 5 0 12 6 9 12 7 2 0 5 5 17 5 7 5 0 12 12 9 12 7 2 0 5 5 17 5 7 5 0 12 12 9 12 7 2 0 5 5 17 5 7 5 0 12 12 9 12 7 7 0 5 5 17 5 7 5 0 12 12 9 12 7 7 0 5 5 17 5 7 5 0 12 12 9 12 7 10 0 5 5 17 5 19 5 0 12 0 12 12 12 12 12 12 12 0 10 0 5 5 17 5 19 5 0 12 0 0 12 12 12 12 12 0 0 10 0 5 5 17 5 19 5 0 12 0 0 0 12 12 12 0 0 0 3 0 5 5 17 5 19 5 0 7 10 10 10 10 10 3 3 3 3 11 8 5 5 17 5 7 5 1 0 0 9 0 7 0 9 5 5 225 9 5) asByteArray! !

!SqBoardSettingToolBar methodsFor: 'accessing' stamp: 'minami 4/14/2006 13:47'!
extentButton
	"Answer the extentButton of the receiver"
	<bewareOf: #extentButtonChanged>
	^self propertyValueAt: #extentButton! !

!SqBoardSettingToolBar methodsFor: 'accessing' stamp: 'minami 4/14/2006 13:47'!
extentButton: aValue
	"Modify the receiver's extentButton"
	^self propertyValueAt: #extentButton put: aValue with: #extentButtonChanged! !

!SqBoardSettingToolBar methodsFor: 'intialize' stamp: 'minami 4/14/2006 13:47'!
initialize
	super initialize.
! !

!SqBoardSettingToolBar methodsFor: 'events' stamp: 'minami 4/14/2006 13:55'!
onRestartPlayersButtonFire

	<on: fire in: extentButton>

	self target ifNil: [^ self].
	self target openExtentMenu! !

!SqBoardSettingToolBar methodsFor: 'intialize' stamp: 'minami 4/17/2006 16:31'!
setupCostume
	super setupCostume.

	self extentButton: (self makeButtonLabelForm: self class extentImage description: 'Extent Setting').
	
	self add: self extentButton.
! !

SqToolBar subclass: #SqDebugToolBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI-ToolBar'!

SqDebugToolBar defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="restartPlayersButton" toSet="restartPlayersButton:" changeEvent="restartPlayersButtonChanged">restartPlayersButton</field>
</fields>'!

!SqDebugToolBar methodsFor: 'intialize' stamp: 'minami 4/13/2006 16:55'!
initialize
	super initialize.
! !

!SqDebugToolBar methodsFor: 'events' stamp: 'minami 4/14/2006 12:06'!
onRestartPlayersButtonFire

	<on: fire in: restartPlayersButton>

	self target ifNil: [^ self].
	self target restartPlayers! !

!SqDebugToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 16:56'!
restartPlayersButton
	"Answer the restartPlayersButton of the receiver"
	<bewareOf: #restartPlayersButtonChanged>
	^self propertyValueAt: #restartPlayersButton! !

!SqDebugToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 16:56'!
restartPlayersButton: aValue
	"Modify the receiver's restartPlayersButton"
	^self propertyValueAt: #restartPlayersButton put: aValue with: #restartPlayersButtonChanged! !

!SqDebugToolBar methodsFor: 'intialize' stamp: 'minami 4/13/2006 16:57'!
setupCostume
	super setupCostume.

	self restartPlayersButton: (self makeButtonLabel: 'R' description: 'Restart Players').
	
	self add: self restartPlayersButton.
! !

SqToolBar subclass: #SqLoginToolBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI-ToolBar'!

SqLoginToolBar defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="loginButton" toSet="loginButton:" changeEvent="loginButtonChanged">loginButton</field>
	<field toGet="boardSelectButton" toSet="boardSelectButton:" changeEvent="boardSelectButtonChanged">boardSelectButton</field>
	<field toGet="boardCreateButton" toSet="boardCreateButton:" changeEvent="boardCreateButtonChanged">boardCreateButton</field>
</fields>'!

!SqLoginToolBar class methodsFor: 'accessing' stamp: 'minami 4/17/2006 16:15'!
createBoardImage
	^ self imageAt: #createBoard ifAbsentPut: [Form fromCompactBytes: self createBoardImageArray].! !

!SqLoginToolBar class methodsFor: 'private' stamp: 'minami 4/17/2006 16:15'!
createBoardImageArray
	^  #(2 8 0 32 0 32 0 0 0 0 4 2 4 255 132 134 132 255 196 198 196 255 172 170 172 255 68 66 68 255 148 154 156 255 244 242 244 255 188 186 188 255 0 0 0 0 92 94 92 255 20 22 20 255 164 162 164 255 252 250 252 255 196 194 196 255 132 138 140 255 228 226 228 255 172 174 172 255 76 74 76 255 156 158 164 255 188 190 188 255 116 118 116 255 36 38 36 255 252 254 252 255 1 0 0 255 1 0 0 255 0 0 5 255 1 0 0 255 1 0 0 255 0 190 136 255 0 148 226 255 0 207 18 255 0 119 0 255 0 45 121 255 0 180 8 255 0 207 130 255 0 119 124 255 0 146 0 255 0 2 0 255 0 188 1 255 1 0 0 255 0 32 86 255 1 0 0 255 1 0 0 255 1 0 0 255 0 194 144 255 0 3 225 255 0 77 18 255 1 0 0 255 0 18 71 255 1 0 0 255 1 0 0 255 0 2 0 255 0 0 176 255 0 0 226 255 0 0 18 255 1 0 0 255 0 158 24 255 0 2 238 255 0 0 148 255 0 0 124 255 0 1 112 255 0 0 5 255 0 0 149 255 0 0 124 255 0 216 255 255 0 241 255 255 0 18 255 255 0 0 255 255 0 16 109 255 0 247 5 255 0 69 149 255 0 0 124 255 0 32 21 255 0 0 10 255 0 0 130 255 0 0 124 255 1 0 0 255 1 0 0 255 0 0 21 255 1 0 0 255 0 0 176 255 0 0 3 255 1 0 0 255 1 0 0 255 0 0 32 255 0 0 24 255 0 0 26 255 1 0 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 126 255 1 0 0 255 1 0 0 255 0 0 192 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 255 255 0 0 255 255 0 0 255 255 0 0 255 255 0 144 255 255 0 227 255 255 0 18 255 255 0 0 255 255 0 152 0 255 0 213 0 255 0 207 0 255 0 119 0 255 0 146 0 255 0 2 0 255 0 188 0 255 1 0 0 255 0 32 0 255 1 0 0 255 0 0 21 255 1 0 0 255 18 194 148 255 159 3 40 255 128 77 0 255 124 0 0 255 24 18 192 255 44 0 226 255 22 0 18 255 0 2 0 255 0 1 47 255 0 0 14 255 0 0 130 255 0 0 124 255 7 216 219 255 0 227 5 255 0 18 130 255 0 0 124 255 0 69 192 255 0 213 118 255 0 207 80 255 0 119 0 255 0 146 8 255 32 2 98 255 22 188 1 255 1 0 0 255 0 32 118 255 1 0 0 255 1 0 0 255 1 0 0 255 0 148 252 255 0 40 225 255 0 0 18 255 1 0 0 255 0 216 52 255 0 227 0 255 0 18 0 255 0 0 192 255 0 131 248 255 0 42 247 255 0 130 18 255 0 124 0 255 24 0 24 255 159 0 238 255 128 0 148 255 124 0 124 255 255 0 112 255 255 0 5 255 255 0 149 255 255 0 124 255 18 0 255 255 159 0 255 255 128 0 255 255 124 0 255 255 75 0 109 255 0 1 5 255 0 0 149 255 0 0 124 255 75 231 74 255 0 42 246 255 0 130 128 255 0 124 124 255 72 252 0 255 235 227 0 255 18 18 21 255 1 0 0 255 255 194 0 255 255 42 0 255 255 130 0 255 255 124 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 4 24 0 255 229 44 1 255 18 22 0 255 1 0 0 255 190 190 0 255 59 62 0 255 76 130 0 255 0 124 0 255 228 255 87 255 228 255 246 255 18 255 128 255 0 255 124 255 119 0 232 255 16 229 227 255 79 18 18 255 1 0 0 255 24 247 8 255 229 62 98 255 18 130 21 255 0 124 0 255 190 12 0 255 62 20 0 255 130 79 0 255 124 0 0 255 211 212 0 255 229 50 0 255 18 79 0 255 1 0 0 255 179 0 0 255 255 1 0 255 255 0 0 255 127 0 0 255 136 252 0 255 229 227 0 255 18 18 0 255 1 0 0 255 24 0 0 255 44 1 0 255 22 0 0 255 1 0 0 255 190 22 0 255 62 63 0 255 130 130 0 255 124 124 0 255 24 1 0 255 44 0 0 255 22 0 0 255 1 0 0 255 148 0 0 255 40 48 0 255 1 0 0 255 0 118 0 255 0 92 0 255 0 105 0 255 0 99 0 255 0 111 0 255 233 110 0 255 206 115 0 255 71 0 0 255 1 0 0 255 128 225 0 225 0 225 9 8 15 8 5 0 0 0 0 0 0 0 0 0 18 21 8 19 8 0 22 22 22 22 22 22 22 15 13 0 5 8 8 8 17 8 19 8 0 22 6 6 6 6 12 6 13 12 3 0 18 8 8 17 8 19 8 0 22 6 6 6 6 6 6 16 20 9 4 0 8 8 17 8 19 8 0 22 6 6 12 6 6 12 15 1 17 10 0 8 8 17 8 7 8 0 22 12 9 22 7 2 0 8 8 17 8 7 8 0 22 22 9 22 7 2 0 8 8 17 8 7 8 0 22 22 9 22 7 2 0 8 8 17 8 7 8 0 22 22 9 22 7 13 0 8 8 17 8 7 8 0 22 22 9 22 7 13 0 8 8 17 8 7 8 0 22 22 9 22 7 19 0 8 8 17 8 7 8 0 22 22 9 22 7 19 0 8 8 17 8 7 8 0 22 22 9 22 7 19 0 8 8 17 8 7 8 0 22 22 9 22 7 7 0 8 8 17 8 19 8 0 13 19 19 19 19 19 7 7 7 7 11 21 8 8 17 8 7 8 1 0 0 9 0 7 0 14 8 8 225 9 8) asByteArray! !

!SqLoginToolBar class methodsFor: 'accessing' stamp: 'minami 4/17/2006 16:09'!
loginImage
	^ self imageAt: #login ifAbsentPut: [Form fromCompactBytes: self loginImageArray].! !

!SqLoginToolBar class methodsFor: 'private' stamp: 'minami 4/17/2006 16:07'!
loginImageArray
	^  #(2 8 0 32 0 32 0 0 0 0 4 6 4 255 0 0 0 0 1 0 0 255 1 0 0 255 0 0 123 255 0 0 35 255 1 0 0 255 1 0 0 255 0 0 7 255 0 0 32 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 21 255 1 0 0 255 0 0 14 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 2 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 5 255 1 0 0 255 1 0 0 255 0 190 136 255 0 148 226 255 0 207 18 255 0 119 0 255 0 45 121 255 0 180 8 255 0 207 130 255 0 119 124 255 0 146 0 255 0 2 0 255 0 188 1 255 1 0 0 255 0 32 86 255 1 0 0 255 1 0 0 255 1 0 0 255 0 194 144 255 0 3 225 255 0 77 18 255 1 0 0 255 0 18 71 255 1 0 0 255 1 0 0 255 0 2 0 255 0 0 176 255 0 0 226 255 0 0 18 255 1 0 0 255 0 158 24 255 0 2 238 255 0 0 148 255 0 0 124 255 0 1 112 255 0 0 5 255 0 0 149 255 0 0 124 255 0 216 255 255 0 241 255 255 0 18 255 255 0 0 255 255 0 16 109 255 0 247 5 255 0 69 149 255 0 0 124 255 0 32 21 255 0 0 10 255 0 0 130 255 0 0 124 255 1 0 0 255 1 0 0 255 0 0 21 255 1 0 0 255 0 0 176 255 0 0 3 255 1 0 0 255 1 0 0 255 0 0 32 255 0 0 24 255 0 0 26 255 1 0 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 126 255 1 0 0 255 1 0 0 255 0 0 192 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 255 255 0 0 255 255 0 0 255 255 0 0 255 255 0 144 255 255 0 227 255 255 0 18 255 255 0 0 255 255 0 152 0 255 0 213 0 255 0 207 0 255 0 119 0 255 0 146 0 255 0 2 0 255 0 188 0 255 1 0 0 255 0 32 0 255 1 0 0 255 0 0 21 255 1 0 0 255 18 194 148 255 159 3 40 255 128 77 0 255 124 0 0 255 24 18 192 255 44 0 226 255 22 0 18 255 0 2 0 255 0 1 47 255 0 0 14 255 0 0 130 255 0 0 124 255 7 216 219 255 0 227 5 255 0 18 130 255 0 0 124 255 0 69 192 255 0 213 118 255 0 207 80 255 0 119 0 255 0 146 8 255 32 2 98 255 22 188 1 255 1 0 0 255 0 32 118 255 1 0 0 255 1 0 0 255 1 0 0 255 0 148 252 255 0 40 225 255 0 0 18 255 1 0 0 255 0 216 52 255 0 227 0 255 0 18 0 255 0 0 192 255 0 131 248 255 0 42 247 255 0 130 18 255 0 124 0 255 24 0 24 255 159 0 238 255 128 0 148 255 124 0 124 255 255 0 112 255 255 0 5 255 255 0 149 255 255 0 124 255 18 0 255 255 159 0 255 255 128 0 255 255 124 0 255 255 68 0 109 255 0 1 5 255 0 0 149 255 0 0 124 255 68 231 74 255 0 42 246 255 0 130 128 255 0 124 124 255 72 252 0 255 235 227 0 255 18 18 21 255 1 0 0 255 255 194 0 255 255 42 0 255 255 130 0 255 255 124 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 4 24 0 255 229 44 1 255 18 22 0 255 1 0 0 255 190 190 0 255 59 62 0 255 76 130 0 255 0 124 0 255 228 255 87 255 228 255 246 255 18 255 128 255 0 255 124 255 119 0 232 255 16 229 227 255 79 18 18 255 1 0 0 255 24 247 8 255 229 62 98 255 18 130 21 255 0 124 0 255 190 12 0 255 62 20 0 255 130 79 0 255 124 0 0 255 204 212 0 255 229 50 0 255 18 79 0 255 1 0 0 255 186 0 0 255 255 1 0 255 255 0 0 255 127 0 0 255 136 252 0 255 229 227 0 255 18 18 0 255 1 0 0 255 24 0 0 255 44 1 0 255 22 0 0 255 1 0 0 255 190 22 0 255 62 63 0 255 130 130 0 255 124 124 0 255 24 1 0 255 44 0 0 255 22 0 0 255 1 0 0 255 148 0 0 255 40 48 0 255 1 0 0 255 0 118 0 255 0 92 0 255 0 105 0 255 0 99 0 255 0 111 0 255 233 110 0 255 206 115 0 255 71 0 0 255 1 0 0 255 128 176 225 0 225 41 1 11 1 1 0 1 1 0 1 1 25 1 11 1 0 0 1 0 0 1 1 25 1 9 0 21 1 7 1 1 1 0 9 0 7 0 0 1 1 21 1 9 0 7 0 0 1 1 21 1 15 1 0 0 1 0 0 1 1 0 0 0 1 21 1 15 1 1 0 1 1 0 1 1 1 1 0 1 89 1 15 0 1 1 1 1 0 1 1 0 1 1 1 21 1 15 0 0 1 1 1 0 0 1 0 0 1 1 21 1 15 1 0 0 0 0 0 0 0 0 0 0 1 21 1 7 1 0 0 0 9 0 21 1 15 1 1 1 0 0 0 0 0 0 0 0 1 25 1 11 1 0 0 1 0 0 1 1 25 1 11 1 0 1 1 0 1 1 1 224 233 1) asByteArray! !

!SqLoginToolBar class methodsFor: 'accessing' stamp: 'minami 4/17/2006 16:16'!
selectBoardImage
	^ self imageAt: #selectBoard ifAbsentPut: [Form fromCompactBytes: self selectBoardImageArray].! !

!SqLoginToolBar class methodsFor: 'private' stamp: 'minami 4/17/2006 16:15'!
selectBoardImageArray
	^  #(2 8 0 32 0 32 0 0 0 0 4 2 4 255 132 134 140 255 204 206 204 255 252 254 252 255 108 110 108 255 220 218 220 255 156 158 156 255 124 126 132 255 220 226 228 255 0 0 0 0 148 154 156 255 204 210 212 255 108 110 116 255 220 222 228 255 172 174 172 255 1 0 0 255 0 0 14 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 2 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 5 255 1 0 0 255 1 0 0 255 0 190 136 255 0 148 226 255 0 207 18 255 0 119 0 255 0 45 121 255 0 180 8 255 0 207 130 255 0 119 124 255 0 146 0 255 0 2 0 255 0 188 1 255 1 0 0 255 0 32 86 255 1 0 0 255 1 0 0 255 1 0 0 255 0 194 144 255 0 3 225 255 0 77 18 255 1 0 0 255 0 18 71 255 1 0 0 255 1 0 0 255 0 2 0 255 0 0 176 255 0 0 226 255 0 0 18 255 1 0 0 255 0 158 24 255 0 2 238 255 0 0 148 255 0 0 124 255 0 1 112 255 0 0 5 255 0 0 149 255 0 0 124 255 0 216 255 255 0 241 255 255 0 18 255 255 0 0 255 255 0 16 109 255 0 247 5 255 0 69 149 255 0 0 124 255 0 32 21 255 0 0 10 255 0 0 130 255 0 0 124 255 1 0 0 255 1 0 0 255 0 0 21 255 1 0 0 255 0 0 176 255 0 0 3 255 1 0 0 255 1 0 0 255 0 0 32 255 0 0 24 255 0 0 26 255 1 0 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 126 255 1 0 0 255 1 0 0 255 0 0 192 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 255 255 0 0 255 255 0 0 255 255 0 0 255 255 0 144 255 255 0 227 255 255 0 18 255 255 0 0 255 255 0 152 0 255 0 213 0 255 0 207 0 255 0 119 0 255 0 146 0 255 0 2 0 255 0 188 0 255 1 0 0 255 0 32 0 255 1 0 0 255 0 0 21 255 1 0 0 255 18 194 148 255 159 3 40 255 128 77 0 255 124 0 0 255 24 18 192 255 44 0 226 255 22 0 18 255 0 2 0 255 0 1 47 255 0 0 14 255 0 0 130 255 0 0 124 255 7 216 219 255 0 227 5 255 0 18 130 255 0 0 124 255 0 69 192 255 0 213 118 255 0 207 80 255 0 119 0 255 0 146 8 255 32 2 98 255 22 188 1 255 1 0 0 255 0 32 118 255 1 0 0 255 1 0 0 255 1 0 0 255 0 148 252 255 0 40 225 255 0 0 18 255 1 0 0 255 0 216 52 255 0 227 0 255 0 18 0 255 0 0 192 255 0 131 248 255 0 42 247 255 0 130 18 255 0 124 0 255 24 0 24 255 159 0 238 255 128 0 148 255 124 0 124 255 255 0 112 255 255 0 5 255 255 0 149 255 255 0 124 255 18 0 255 255 159 0 255 255 128 0 255 255 124 0 255 255 75 0 109 255 0 1 5 255 0 0 149 255 0 0 124 255 75 231 74 255 0 42 246 255 0 130 128 255 0 124 124 255 72 252 0 255 235 227 0 255 18 18 21 255 1 0 0 255 255 194 0 255 255 42 0 255 255 130 0 255 255 124 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 4 24 0 255 229 44 1 255 18 22 0 255 1 0 0 255 190 190 0 255 59 62 0 255 76 130 0 255 0 124 0 255 228 255 87 255 228 255 246 255 18 255 128 255 0 255 124 255 119 0 232 255 16 229 227 255 79 18 18 255 1 0 0 255 24 247 8 255 229 62 98 255 18 130 21 255 0 124 0 255 190 12 0 255 62 20 0 255 130 79 0 255 124 0 0 255 211 212 0 255 229 50 0 255 18 79 0 255 1 0 0 255 179 0 0 255 255 1 0 255 255 0 0 255 127 0 0 255 136 252 0 255 229 227 0 255 18 18 0 255 1 0 0 255 24 0 0 255 44 1 0 255 22 0 0 255 1 0 0 255 190 22 0 255 62 63 0 255 130 130 0 255 124 124 0 255 24 1 0 255 44 0 0 255 22 0 0 255 1 0 0 255 148 0 0 255 40 48 0 255 1 0 0 255 0 118 0 255 0 92 0 255 0 105 0 255 0 99 0 255 0 111 0 255 233 110 0 255 206 115 0 255 71 0 0 255 1 0 0 255 128 225 1 225 0 225 41 9 7 9 9 6 0 9 0 7 0 0 0 9 17 9 7 9 6 0 3 9 3 7 3 2 0 9 17 9 7 6 0 3 3 9 3 7 2 0 6 9 13 9 23 9 9 9 6 0 3 3 3 3 3 3 3 3 3 3 2 0 6 9 9 13 9 7 9 9 9 0 9 5 11 5 5 2 0 0 0 0 9 13 9 7 9 9 9 0 9 0 11 0 0 0 14 3 2 0 9 13 9 11 9 9 9 8 6 0 3 3 9 3 7 2 0 6 9 13 9 23 9 9 9 6 0 3 3 3 3 3 3 3 3 3 3 2 0 10 13 9 13 9 7 9 9 9 0 9 5 11 5 5 2 0 0 0 0 9 13 9 7 9 9 9 0 9 0 11 0 0 0 14 3 2 0 9 13 9 11 9 9 9 11 1 0 3 3 9 3 7 2 0 7 9 13 9 23 9 9 9 1 0 3 3 3 3 3 3 3 3 3 3 2 0 12 9 9 13 9 7 9 9 9 0 9 5 11 5 5 2 0 4 9 9 9 13 9 7 9 9 9 0 9 0 7 0 0 0 12 225 45 9) asByteArray! !

!SqLoginToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 15:39'!
boardCreateButton
	"Answer the boardCreateButton of the receiver"
	<bewareOf: #boardCreateButtonChanged>
	^self propertyValueAt: #boardCreateButton! !

!SqLoginToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 15:39'!
boardCreateButton: aValue
	"Modify the receiver's boardCreateButton"
	^self propertyValueAt: #boardCreateButton put: aValue with: #boardCreateButtonChanged! !

!SqLoginToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 15:36'!
boardSelectButton
	"Answer the boardSelectButton of the receiver"
	<bewareOf: #boardSelectButtonChanged>
	^self propertyValueAt: #boardSelectButton! !

!SqLoginToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 15:36'!
boardSelectButton: aValue
	"Modify the receiver's boardSelectButton"
	^self propertyValueAt: #boardSelectButton put: aValue with: #boardSelectButtonChanged! !

!SqLoginToolBar methodsFor: 'intialize' stamp: 'minami 4/13/2006 15:35'!
initialize
	super initialize.
! !

!SqLoginToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 15:34'!
loginButton
	"Answer the loginButton of the receiver"
	<bewareOf: #loginButtonChanged>
	^self propertyValueAt: #loginButton! !

!SqLoginToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 15:34'!
loginButton: aValue
	"Modify the receiver's loginButton"
	^self propertyValueAt: #loginButton put: aValue with: #loginButtonChanged! !

!SqLoginToolBar methodsFor: 'events' stamp: 'minami 4/14/2006 12:06'!
onBoardCreateButtonFire

	<on: fire in: boardCreateButton>

	self target ifNil: [^ self].
	self target createBoard! !

!SqLoginToolBar methodsFor: 'events' stamp: 'minami 4/14/2006 12:06'!
onBoardSelectButtonFire

	<on: fire in: boardSelectButton>

	self target ifNil: [^ self].
	self target selectBoard ! !

!SqLoginToolBar methodsFor: 'events' stamp: 'minami 4/14/2006 12:06'!
onLoginButtonFire

	<on: fire in: loginButton>

	self target ifNil: [^ self].
	self target tryLogin! !

!SqLoginToolBar methodsFor: 'intialize' stamp: 'minami 4/17/2006 16:21'!
setupCostume
	super setupCostume.

	self loginButton: (self makeButtonLabelForm: self class loginImage description: 'Login').
	self boardCreateButton: (self makeButtonLabelForm: self class createBoardImage description: 'Create Board').
	self boardSelectButton: (self makeButtonLabelForm: self class selectBoardImage description: 'Select Board').

	self add: self loginButton.
	self add: self boardCreateButton.
	self add: self boardSelectButton.
! !

SqToolBar subclass: #SqZoomToolBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI-ToolBar'!

SqZoomToolBar defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="zoomInButton" toSet="zoomInButton:" changeEvent="zoomInButtonChanged">zoomInButton</field>
	<field toGet="zoomOutButton" toSet="zoomOutButton:" changeEvent="zoomOutButtonChanged">zoomOutButton</field>
	<field toGet="resetScaleButton" toSet="resetScaleButton:" changeEvent="resetScaleButtonChanged">resetScaleButton</field>
</fields>'!

!SqZoomToolBar class methodsFor: 'private' stamp: 'minami 4/17/2006 16:43'!
resetScaleArray
	^  #(2 8 0 32 0 32 0 0 0 0 4 2 4 255 132 134 140 255 68 66 68 255 0 0 0 0 36 34 36 255 100 98 100 255 52 50 52 255 84 82 84 255 20 18 20 255 116 114 116 255 196 198 204 255 44 42 44 255 52 58 60 255 84 90 92 255 12 10 12 255 76 74 76 255 108 106 108 255 60 58 60 255 156 162 164 255 28 30 28 255 124 122 124 255 44 46 44 255 92 90 92 255 60 62 60 255 4 6 4 255 68 70 68 255 36 38 36 255 100 102 100 255 84 86 84 255 20 22 20 255 116 118 116 255 252 254 252 255 12 14 12 255 76 78 76 255 108 110 108 255 180 182 188 255 44 46 52 255 92 94 92 255 60 62 68 255 1 0 0 255 0 32 86 255 1 0 0 255 1 0 0 255 1 0 0 255 0 194 144 255 0 3 225 255 0 77 18 255 1 0 0 255 0 18 71 255 1 0 0 255 1 0 0 255 0 2 0 255 0 0 176 255 0 0 226 255 0 0 18 255 1 0 0 255 0 158 24 255 0 2 238 255 0 0 148 255 0 0 124 255 0 1 112 255 0 0 5 255 0 0 149 255 0 0 124 255 0 216 255 255 0 241 255 255 0 18 255 255 0 0 255 255 0 16 109 255 0 247 5 255 0 69 149 255 0 0 124 255 0 32 21 255 0 0 10 255 0 0 130 255 0 0 124 255 1 0 0 255 1 0 0 255 0 0 21 255 1 0 0 255 0 0 176 255 0 0 3 255 1 0 0 255 1 0 0 255 0 0 32 255 0 0 24 255 0 0 26 255 1 0 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 126 255 1 0 0 255 1 0 0 255 0 0 192 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 255 255 0 0 255 255 0 0 255 255 0 0 255 255 0 144 255 255 0 227 255 255 0 18 255 255 0 0 255 255 0 152 0 255 0 213 0 255 0 207 0 255 0 119 0 255 0 146 0 255 0 2 0 255 0 188 0 255 1 0 0 255 0 32 0 255 1 0 0 255 0 0 21 255 1 0 0 255 18 194 148 255 159 3 40 255 128 77 0 255 124 0 0 255 24 18 192 255 44 0 226 255 22 0 18 255 0 2 0 255 0 1 47 255 0 0 14 255 0 0 130 255 0 0 124 255 7 216 219 255 0 227 5 255 0 18 130 255 0 0 124 255 0 69 192 255 0 213 118 255 0 207 80 255 0 119 0 255 0 146 8 255 32 2 98 255 22 188 1 255 1 0 0 255 0 32 118 255 1 0 0 255 1 0 0 255 1 0 0 255 0 148 252 255 0 40 225 255 0 0 18 255 1 0 0 255 0 216 52 255 0 227 0 255 0 18 0 255 0 0 192 255 0 131 248 255 0 42 247 255 0 130 18 255 0 124 0 255 24 0 24 255 159 0 238 255 128 0 148 255 124 0 124 255 255 0 112 255 255 0 5 255 255 0 149 255 255 0 124 255 18 0 255 255 159 0 255 255 128 0 255 255 124 0 255 255 68 0 109 255 0 1 5 255 0 0 149 255 0 0 124 255 68 231 74 255 0 42 246 255 0 130 128 255 0 124 124 255 72 252 0 255 235 227 0 255 18 18 21 255 1 0 0 255 255 194 0 255 255 42 0 255 255 130 0 255 255 124 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 4 24 0 255 229 44 1 255 18 22 0 255 1 0 0 255 190 190 0 255 59 62 0 255 76 130 0 255 0 124 0 255 228 255 87 255 228 255 246 255 18 255 128 255 0 255 124 255 119 0 232 255 16 229 227 255 79 18 18 255 1 0 0 255 24 247 8 255 229 62 98 255 18 130 21 255 0 124 0 255 190 12 0 255 62 20 0 255 130 79 0 255 124 0 0 255 204 212 0 255 229 50 0 255 18 79 0 255 1 0 0 255 186 0 0 255 255 1 0 255 255 0 0 255 127 0 0 255 136 252 0 255 229 227 0 255 18 18 0 255 1 0 0 255 24 0 0 255 44 1 0 255 22 0 0 255 1 0 0 255 190 22 0 255 62 63 0 255 130 130 0 255 124 124 0 255 24 1 0 255 44 0 0 255 22 0 0 255 1 0 0 255 148 0 0 255 40 48 0 255 1 0 0 255 0 118 0 255 0 92 0 255 0 105 0 255 0 99 0 255 0 111 0 255 233 110 0 255 206 115 0 255 71 0 0 255 1 0 0 255 128 225 130 225 0 141 3 11 9 25 21 11 38 16 3 3 21 3 15 3 3 22 6 9 31 31 31 31 27 4 33 21 3 19 3 11 5 31 31 31 31 31 31 31 31 33 32 3 3 3 17 3 7 4 30 31 31 9 31 7 37 29 3 3 13 3 23 3 3 3 7 22 31 2 15 7 7 31 31 7 7 33 15 31 2 38 3 13 3 23 3 3 3 29 31 31 33 7 7 7 31 31 7 7 33 33 31 31 32 3 13 3 23 3 3 5 34 31 31 7 7 31 31 31 31 31 31 7 33 31 31 28 13 13 3 23 3 3 11 31 31 31 7 7 31 31 31 31 31 31 7 33 31 31 31 4 13 3 7 3 3 29 31 13 31 7 31 31 31 24 13 3 7 3 3 32 31 13 31 7 31 31 31 14 13 3 23 3 3 11 31 31 31 33 33 31 31 31 31 31 31 33 15 31 31 31 19 13 3 23 3 3 28 13 31 31 15 25 31 31 31 31 31 31 15 15 31 31 33 33 13 3 23 3 3 3 14 31 31 15 15 15 15 31 31 15 15 25 25 31 31 0 3 13 3 23 3 3 3 12 17 31 25 25 25 15 31 31 25 25 25 2 31 21 6 3 17 3 7 24 7 31 31 9 31 7 25 0 18 3 17 3 19 3 0 36 31 31 31 31 31 31 31 31 26 0 32 32 1 17 3 23 3 3 12 0 2 20 31 31 30 12 0 12 35 19 24 14 29 3 3 3 17 3 19 33 29 24 0 29 7 3 3 3 10 11 11 24 14 3 3 25 3 11 3 3 32 16 12 32 24 3 25 3 11 3 3 3 24 20 12 14 24 29 3 7 24 16 19 24 29 3 7 3 32 0 3 197 3) asByteArray! !

!SqZoomToolBar class methodsFor: 'accessing' stamp: 'minami 4/17/2006 14:59'!
resetScaleImage
	^ self imageAt: #resetScale ifAbsentPut: [Form fromCompactBytes: self resetScaleArray].! !

!SqZoomToolBar class methodsFor: 'accessing' stamp: 'minami 4/17/2006 14:44'!
zoomInImage
	^ self imageAt: #zoomIn ifAbsentPut: [Form fromCompactBytes: self zoomInImageArray].! !

!SqZoomToolBar class methodsFor: 'private' stamp: 'minami 4/17/2006 16:43'!
zoomInImageArray
	^  #(2 8 0 32 0 32 0 0 0 0 4 2 4 255 132 134 140 255 68 66 68 255 0 0 0 0 36 34 36 255 100 98 100 255 52 50 52 255 84 82 84 255 20 18 20 255 116 114 116 255 196 198 204 255 44 42 44 255 52 58 60 255 84 90 92 255 12 10 12 255 108 106 108 255 60 58 60 255 156 162 164 255 76 78 76 255 28 30 28 255 124 122 124 255 44 46 44 255 92 90 92 255 60 62 60 255 4 6 4 255 68 70 68 255 36 38 36 255 100 102 100 255 84 86 84 255 20 22 20 255 116 118 116 255 252 254 252 255 12 14 12 255 108 110 108 255 180 182 188 255 44 46 52 255 92 94 92 255 60 62 68 255 0 188 1 255 1 0 0 255 0 32 86 255 1 0 0 255 1 0 0 255 1 0 0 255 0 194 144 255 0 3 225 255 0 77 18 255 1 0 0 255 0 1 71 255 1 0 0 255 1 0 0 255 0 2 0 255 0 0 176 255 0 0 226 255 0 0 18 255 1 0 0 255 0 158 24 255 0 2 238 255 0 0 148 255 0 0 124 255 0 1 112 255 0 0 5 255 0 0 149 255 0 0 124 255 0 216 255 255 0 241 255 255 0 18 255 255 0 0 255 255 0 16 109 255 0 247 5 255 0 69 149 255 0 0 124 255 0 32 21 255 0 0 10 255 0 0 130 255 0 0 124 255 1 0 0 255 1 0 0 255 0 0 21 255 1 0 0 255 0 0 176 255 0 0 3 255 1 0 0 255 1 0 0 255 0 0 32 255 0 0 24 255 0 0 26 255 1 0 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 126 255 1 0 0 255 1 0 0 255 0 0 192 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 255 255 0 0 255 255 0 0 255 255 0 0 255 255 0 144 255 255 0 227 255 255 0 18 255 255 0 0 255 255 0 152 0 255 0 213 0 255 0 207 0 255 0 119 0 255 0 146 0 255 0 2 0 255 0 188 0 255 1 0 0 255 0 32 0 255 1 0 0 255 0 0 21 255 1 0 0 255 18 194 148 255 159 3 40 255 128 77 0 255 124 0 0 255 24 1 192 255 44 0 226 255 22 0 18 255 0 2 0 255 0 1 47 255 0 0 14 255 0 0 130 255 0 0 124 255 7 216 219 255 0 227 5 255 0 18 130 255 0 0 124 255 0 69 192 255 0 213 118 255 0 207 80 255 0 119 0 255 0 146 8 255 32 2 98 255 22 188 1 255 1 0 0 255 0 32 118 255 1 0 0 255 1 0 0 255 1 0 0 255 0 148 252 255 0 40 225 255 0 0 18 255 1 0 0 255 0 216 52 255 0 227 0 255 0 18 0 255 0 0 192 255 0 131 248 255 0 42 247 255 0 130 18 255 0 124 0 255 24 0 24 255 159 0 238 255 128 0 148 255 124 0 124 255 255 0 112 255 255 0 5 255 255 0 149 255 255 0 124 255 18 0 255 255 159 0 255 255 128 0 255 255 124 0 255 255 65 0 109 255 0 1 5 255 0 0 149 255 0 0 124 255 65 231 74 255 0 42 246 255 0 130 128 255 0 124 124 255 72 252 0 255 235 227 0 255 18 18 21 255 1 0 0 255 255 194 0 255 255 42 0 255 255 130 0 255 255 124 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 4 24 0 255 229 44 1 255 18 22 0 255 1 0 0 255 190 190 0 255 59 62 0 255 76 130 0 255 0 124 0 255 228 255 87 255 228 255 246 255 18 255 128 255 0 255 124 255 119 0 232 255 16 229 227 255 79 18 18 255 1 0 0 255 24 247 8 255 229 62 98 255 18 130 21 255 0 124 0 255 190 12 0 255 62 20 0 255 130 79 0 255 124 0 0 255 201 212 0 255 229 50 0 255 18 79 0 255 1 0 0 255 189 0 0 255 255 1 0 255 255 0 0 255 127 0 0 255 136 252 0 255 229 227 0 255 18 18 0 255 1 0 0 255 24 0 0 255 44 1 0 255 22 0 0 255 1 0 0 255 190 22 0 255 62 63 0 255 130 130 0 255 124 124 0 255 24 1 0 255 44 0 0 255 22 0 0 255 1 0 0 255 148 0 0 255 40 48 0 255 1 0 0 255 0 118 0 255 0 92 0 255 0 105 0 255 0 99 0 255 0 111 0 255 233 110 0 255 206 115 0 255 71 0 0 255 1 0 0 255 128 225 138 225 0 141 3 11 9 25 21 11 37 15 3 3 21 3 15 3 3 22 6 9 31 31 31 31 27 4 18 21 3 19 3 11 5 31 31 31 31 31 31 31 31 18 32 3 3 3 17 3 7 4 30 31 31 9 31 7 36 29 3 3 13 3 11 3 3 3 7 22 31 31 31 9 31 7 31 2 37 3 13 3 23 3 3 3 29 31 31 31 31 31 31 25 25 31 31 31 31 31 31 32 3 13 3 23 3 3 5 33 31 31 31 31 31 31 25 25 31 31 31 31 31 31 28 13 13 3 23 3 3 11 31 31 31 31 31 31 31 25 25 31 31 31 31 31 31 31 4 13 3 23 3 3 29 31 31 31 31 25 25 23 25 25 23 2 2 31 31 31 31 24 13 3 23 3 3 32 31 31 31 31 2 25 25 25 25 2 2 2 31 31 31 31 14 13 3 23 3 3 11 31 31 31 31 31 31 31 2 2 31 31 31 31 31 31 31 19 13 3 23 3 3 28 13 31 31 31 31 31 31 2 2 31 31 31 31 31 31 18 18 13 3 23 3 3 3 14 31 31 31 31 31 31 23 23 31 31 31 31 31 31 0 3 13 3 11 3 3 3 12 16 31 31 31 9 31 7 31 21 6 3 17 3 7 24 7 31 31 9 31 7 25 0 17 3 17 3 19 3 0 35 31 31 31 31 31 31 31 31 26 0 32 32 1 17 3 23 3 3 12 0 2 20 31 31 30 12 0 12 34 19 24 14 29 3 3 3 17 3 19 18 29 24 0 29 7 3 3 3 10 11 11 24 14 3 3 25 3 11 3 3 32 15 12 32 24 3 25 3 11 3 3 3 24 20 12 14 24 29 3 7 24 15 19 24 29 3 7 3 32 0 3 197 3) asByteArray! !

!SqZoomToolBar class methodsFor: 'accessing' stamp: 'minami 4/17/2006 14:44'!
zoomOutImage
	^ self imageAt: #zoomOut ifAbsentPut: [Form fromCompactBytes: self zoomOutImageArray].! !

!SqZoomToolBar class methodsFor: 'private' stamp: 'minami 4/17/2006 16:42'!
zoomOutImageArray
	^ #(2 8 0 32 0 32 0 0 0 0 4 2 4 255 132 134 140 255 68 66 68 255 0 0 0 0 36 34 36 255 100 98 100 255 52 50 52 255 84 82 84 255 20 18 20 255 116 114 116 255 196 198 204 255 44 42 44 255 52 58 60 255 84 90 92 255 12 10 12 255 108 106 108 255 60 58 60 255 156 162 164 255 76 78 76 255 28 30 28 255 124 122 124 255 44 46 44 255 92 90 92 255 60 62 60 255 4 6 4 255 68 70 68 255 36 38 36 255 100 102 100 255 84 86 84 255 20 22 20 255 116 118 116 255 252 254 252 255 12 14 12 255 108 110 108 255 180 182 188 255 44 46 52 255 92 94 92 255 60 62 68 255 0 188 1 255 1 0 0 255 0 32 86 255 1 0 0 255 1 0 0 255 1 0 0 255 0 194 144 255 0 3 225 255 0 77 18 255 1 0 0 255 0 18 71 255 1 0 0 255 1 0 0 255 0 2 0 255 0 0 176 255 0 0 226 255 0 0 18 255 1 0 0 255 0 158 24 255 0 2 238 255 0 0 148 255 0 0 124 255 0 1 112 255 0 0 5 255 0 0 149 255 0 0 124 255 0 216 255 255 0 241 255 255 0 18 255 255 0 0 255 255 0 16 109 255 0 247 5 255 0 69 149 255 0 0 124 255 0 32 21 255 0 0 10 255 0 0 130 255 0 0 124 255 1 0 0 255 1 0 0 255 0 0 21 255 1 0 0 255 0 0 176 255 0 0 3 255 1 0 0 255 1 0 0 255 0 0 32 255 0 0 24 255 0 0 26 255 1 0 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 126 255 1 0 0 255 1 0 0 255 0 0 192 255 1 0 0 255 1 0 0 255 1 0 0 255 1 0 0 255 0 0 255 255 0 0 255 255 0 0 255 255 0 0 255 255 0 144 255 255 0 227 255 255 0 18 255 255 0 0 255 255 0 152 0 255 0 213 0 255 0 207 0 255 0 119 0 255 0 146 0 255 0 2 0 255 0 188 0 255 1 0 0 255 0 32 0 255 1 0 0 255 0 0 21 255 1 0 0 255 18 194 148 255 159 3 40 255 128 77 0 255 124 0 0 255 24 18 192 255 44 0 226 255 22 0 18 255 0 2 0 255 0 1 47 255 0 0 14 255 0 0 130 255 0 0 124 255 7 216 219 255 0 227 5 255 0 18 130 255 0 0 124 255 0 69 192 255 0 213 118 255 0 207 80 255 0 119 0 255 0 146 8 255 32 2 98 255 22 188 1 255 1 0 0 255 0 32 118 255 1 0 0 255 1 0 0 255 1 0 0 255 0 148 252 255 0 40 225 255 0 0 18 255 1 0 0 255 0 216 52 255 0 227 0 255 0 18 0 255 0 0 192 255 0 131 248 255 0 42 247 255 0 130 18 255 0 124 0 255 24 0 24 255 159 0 238 255 128 0 148 255 124 0 124 255 255 0 112 255 255 0 5 255 255 0 149 255 255 0 124 255 18 0 255 255 159 0 255 255 128 0 255 255 124 0 255 255 66 0 109 255 0 1 5 255 0 0 149 255 0 0 124 255 66 231 74 255 0 42 246 255 0 130 128 255 0 124 124 255 72 252 0 255 235 227 0 255 18 18 21 255 1 0 0 255 255 194 0 255 255 42 0 255 255 130 0 255 255 124 0 255 0 0 8 255 0 0 98 255 0 0 21 255 1 0 0 255 4 24 0 255 229 44 1 255 18 22 0 255 1 0 0 255 190 190 0 255 59 62 0 255 76 130 0 255 0 124 0 255 228 255 87 255 228 255 246 255 18 255 128 255 0 255 124 255 119 0 232 255 16 229 227 255 79 18 18 255 1 0 0 255 24 247 8 255 229 62 98 255 18 130 21 255 0 124 0 255 190 12 0 255 62 20 0 255 130 79 0 255 124 0 0 255 202 212 0 255 229 50 0 255 18 79 0 255 1 0 0 255 188 0 0 255 255 1 0 255 255 0 0 255 127 0 0 255 136 252 0 255 229 227 0 255 18 18 0 255 1 0 0 255 24 0 0 255 44 1 0 255 22 0 0 255 1 0 0 255 190 22 0 255 62 63 0 255 130 130 0 255 124 124 0 255 24 1 0 255 44 0 0 255 22 0 0 255 1 0 0 255 148 0 0 255 40 48 0 255 1 0 0 255 0 118 0 255 0 92 0 255 0 105 0 255 0 99 0 255 0 111 0 255 233 110 0 255 206 115 0 255 71 0 0 255 1 0 0 255 128 225 84 225 0 141 3 11 9 25 21 11 37 15 3 3 21 3 15 3 3 22 6 9 31 31 31 31 27 4 18 21 3 19 3 11 5 31 31 31 31 31 31 31 31 18 32 3 3 3 17 3 7 4 30 31 31 9 31 7 36 29 3 3 13 3 11 3 3 3 7 22 31 31 31 9 31 7 31 2 37 3 13 3 7 3 3 3 29 13 31 7 31 31 32 3 13 3 7 3 3 5 33 13 31 7 31 31 28 13 13 3 7 3 3 11 31 13 31 7 31 31 31 4 13 3 23 3 3 29 31 31 31 31 25 25 25 25 25 25 2 2 31 31 31 31 24 13 3 23 3 3 32 31 31 31 31 2 25 25 25 25 2 2 2 31 31 31 31 14 13 3 7 3 3 11 31 13 31 7 31 31 31 19 13 3 7 3 3 28 13 13 31 7 31 31 18 18 13 3 7 3 3 3 14 13 31 7 31 31 0 3 13 3 11 3 3 3 12 16 31 31 31 9 31 7 31 21 6 3 17 3 7 24 7 31 31 9 31 7 25 0 17 3 17 3 19 3 0 35 31 31 31 31 31 31 31 31 26 0 32 32 1 17 3 23 3 3 12 0 2 20 31 31 30 12 0 12 34 19 24 14 29 3 3 3 17 3 19 18 29 24 0 29 7 3 3 3 10 11 11 24 14 3 3 25 3 11 3 3 32 15 12 32 24 3 25 3 11 3 3 3 24 20 12 14 24 29 3 7 24 15 19 24 29 3 7 3 32 0 3 197 3) asByteArray! !

!SqZoomToolBar methodsFor: 'initialize' stamp: 'minami 4/13/2006 12:06'!
initialize
	super initialize.
! !

!SqZoomToolBar methodsFor: 'events' stamp: 'minami 4/14/2006 12:06'!
onResetScaleButtonFire

	<on: fire in: resetScaleButton>

	self target ifNil: [^ self].
	self target resetScale! !

!SqZoomToolBar methodsFor: 'events' stamp: 'minami 4/14/2006 12:06'!
onZoomInButtonFire
	<on: fire in: zoomInButton>

	self target ifNil: [^ self].
	self target zoomIn! !

!SqZoomToolBar methodsFor: 'events' stamp: 'minami 4/14/2006 12:06'!
onZoomOutButtonFire
	<on: fire in: zoomOutButton>

	self target ifNil: [^ self].
	self target zoomOut! !

!SqZoomToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 12:25'!
resetScaleButton
	"Answer the resetScaleButton of the receiver"
	<bewareOf: #resetScaleButtonChanged>
	^self propertyValueAt: #resetScaleButton! !

!SqZoomToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 12:25'!
resetScaleButton: aValue
	"Modify the receiver's resetScaleButton"
	^self propertyValueAt: #resetScaleButton put: aValue with: #resetScaleButtonChanged! !

!SqZoomToolBar methodsFor: 'initialize' stamp: 'minami 4/17/2006 14:59'!
setupCostume
	super setupCostume.

	self zoomInButton: (self makeButtonLabelForm: self class zoomInImage description: 'Zoom In').
	self zoomOutButton: (self makeButtonLabelForm: self class zoomOutImage description: 'Zoom Out').
	self resetScaleButton: (self makeButtonLabelForm: self class resetScaleImage description: 'Reset Scale').

	self add: self zoomInButton.
	self add: self zoomOutButton.
	self add: self resetScaleButton.! !

!SqZoomToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 12:00'!
zoomInButton
	"Answer the zoomInButton of the receiver"
	<bewareOf: #zoomInButtonChanged>
	^self propertyValueAt: #zoomInButton! !

!SqZoomToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 12:00'!
zoomInButton: aValue
	"Modify the receiver's zoomInButton"
	^self propertyValueAt: #zoomInButton put: aValue with: #zoomInButtonChanged! !

!SqZoomToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 12:00'!
zoomOutButton
	"Answer the zoomOutButton of the receiver"
	<bewareOf: #zoomOutButtonChanged>
	^self propertyValueAt: #zoomOutButton! !

!SqZoomToolBar methodsFor: 'accessing' stamp: 'minami 4/13/2006 12:00'!
zoomOutButton: aValue
	"Modify the receiver's zoomOutButton"
	^self propertyValueAt: #zoomOutButton put: aValue with: #zoomOutButtonChanged! !

!CHalo methodsFor: '*SqSquare-Client-override' stamp: 'minami 3/10/2006 12:04'!
handleSpecs
	"Answer specs defining the halo handles to use."

	^ Preferences debugHaloHandle
	 	ifFalse:
			[{{#haloDismiss. 	0.0.		0.0.		Color red muchLighter. 'x'. 'Remove'.}.
			{ #haloMenu. 	0.25.	0.0.		Color red. 'm'. 		'Menu'.}.
			{ #haloGrab. 	0.5.		0.0.		Color black. 'g'. 	'Pick up'		}.
			{ #haloDrag. 	0.75.	0.0.		Color brown. 'd'. 	'Move'			}.
			{ #haloDup. 	1.0.		0.0.		Color green. 'u'. 	'Duplicate'		}.
			{ #haloRecolor.	1.0.		0.5.		Color magenta. 'R'. 	'Open ColorTool'	}.
			{ #haloRepaint.	1.0.		0.5.		Color gray: 0.7. 'p'. 	'Repaint'		}.
			{ #haloSize.		1.0.		1.0.		Color yellow. 's'. 	'Change size'	}.
			{ #haloRotate. 	0.0.		1.0.		Color blue. 'r'. 		'Rotate'			}.
			{ #haloViewer. 	0.0.		0.5.		Color cyan. 'v'. 	'Open Viewer'	}}]
		ifTrue:
			[{{ #haloDismiss. 	0.0.		0.0.		Color red muchLighter. 'x'. 'Remove'.}.
			{ #haloMenu. 	0.25.	0.0.		Color red. 'm'. 		'Menu'.}.
			{ #haloGrab. 	0.5.		0.0.		Color black. 'g'. 	'Pick up'		}.
			{ #haloDrag. 	0.75.	0.0.		Color brown. 'd'. 	'Move'			}.
			{ #haloDup. 	1.0.		0.0.		Color green. 'u'. 	'Duplicate'		}.
			{ #haloRecolor.	1.0.		0.66667.		Color magenta. 'R'. 	'Open ColorTool'	}.
			{ #haloRepaint.	1.0.		0.66667.		Color gray: 0.7. 'p'. 	'Repaint'		}.
			{ #haloSize.		1.0.		1.0.		Color yellow. 's'. 	'Change size'	}.
			{ #haloDebug.  1.0.		0.33333.		Color cyan muchLighter. 'D'. 'Debug'}.
			{ #haloTile.      0.0.		0.25.	Color orange.	 't'.		'Tile'			}.
			{ #haloLink.     0.0.		0.5.		Color palePeach.	 'l'.		'Link'			}.
			{ #haloRotate. 	0.0.		1.0.		Color blue. 		 'r'.		'Rotate'			}.
			{ #haloViewer. 	0.0.		0.75.	Color cyan. 		 'v'. 	'Open Viewer'	}}]
	! !

!CHalo methodsFor: '*SqSquare-Client-override' stamp: 'minami 3/27/2006 07:38'!
onSelectTarget
	| index list cc aHand boardPos |
	aHand := self hand.
	list := aHand playersUnder: aHand world.
	list isEmpty ifTrue:[^self].
"list inspect."
	boardPos := list findLast: [:e | e player findPlayerOf: SqEventRecordBoard].
	boardPos >= 2 ifTrue: [
		list :=  (list allButFirst: boardPos), (list first: boardPos) reverse, {list last}.
	].
"list inspect."
	cc := self target ifNotNil:[self target asPrimCostume].
	index := list identityIndexOf: (cc ifNil:[self rootContext]).
	index = 0 ifTrue:[
		aHand shiftPressed 
			ifTrue:[index := 1]
			ifFalse:[index := list size - 1]
	] ifFalse:[
		aHand shiftPressed
			ifTrue:[index := index+1]
			ifFalse:[index := index-1].
	].
	"@@@@: Fix this. Later figure out how to wrap and ask guys for interest"
	self target: (list atWrap: index) asPlayer haloTarget! !

SqEventRecordHolder subclass: #SqClientEventRecordHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client'!

!SqClientEventRecordHolder methodsFor: 'adding' stamp: 'mu 4/28/2006 15:01'!
add: event
	super add: event.
	self changed: #eventAdded with: event

! !

!SqClientEventRecordHolder methodsFor: 'adding' stamp: 'mu 4/28/2006 15:16'!
processAddingEvent: event
	event isDisposable ifTrue: [^self]. "do not process disposable event"
	super processAddingEvent: event
! !

ApplicationService subclass: #SqEventSender
	instanceVariableNames: 'connection eventQueue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client'!

!SqEventSender class methodsFor: 'accessing' stamp: 'MU 3/1/2006 10:23'!
defaultPriority

	^Processor lowIOPriority! !

!SqEventSender class methodsFor: 'instance creation' stamp: 'minami 2/28/2006 15:58'!
on: aConnection
	^ self new connection: aConnection; yourself! !

!SqEventSender methodsFor: 'adding' stamp: 'minami 2/28/2006 16:39'!
add: aEvent
	self eventQueue nextPut: aEvent! !

!SqEventSender methodsFor: 'accessing' stamp: 'minami 2/28/2006 15:59'!
connection
	^ connection! !

!SqEventSender methodsFor: 'accessing' stamp: 'minami 2/28/2006 15:59'!
connection: aConnection
	connection := aConnection! !

!SqEventSender methodsFor: 'accessing' stamp: 'mu 4/27/2006 11:50'!
eventQueue
	^ eventQueue! !

!SqEventSender methodsFor: 'initialize-release' stamp: 'mu 3/7/2006 17:12'!
initialize
	super initialize.

	eventQueue := SharedQueue2 new: 100.

	! !

!SqEventSender methodsFor: 'testing' stamp: 'mu 3/8/2006 11:15'!
isValid
	self connection
		ifNil: [^ false].
	^ self connection isValid! !

!SqEventSender methodsFor: 'registration' stamp: 'mu 4/6/2006 12:11'!
register

	"do nothing"! !

!SqEventSender methodsFor: 'initialize-release' stamp: 'mu 3/10/2006 16:57'!
release
	self unregister.! !

!SqEventSender methodsFor: 'initialize-release' stamp: 'mu 3/10/2006 16:56'!
releaseQueue
	eventQueue ifNotNilDo: [:q | q release].
! !

!SqEventSender methodsFor: 'running' stamp: 'mu 3/8/2006 11:16'!
runWhile: aBlock
	[aBlock value and:[self isValid]] 
		whileTrue: [self send]! !

!SqEventSender methodsFor: 'actions' stamp: 'mu 4/27/2006 11:16'!
send
	| event |
	event _ self eventQueue next.
	event ifNil: [^ self].
	self eventQueue size = 0
		ifTrue: [self connection send: event]
		ifFalse: [self connection deferSend: event]! !

!SqEventSender methodsFor: 'running' stamp: 'mu 4/27/2006 11:17'!
stop
	super stop.
	self releaseQueue.

	self eventQueue nextPut: nil! !

!CProjectBuilder class methodsFor: '*SqSquare-Client-notes' stamp: 'minami 4/20/2006 16:15'!
sqSquareReleaseNotes 
"
	(Workspace new) contents: self sqSquareReleaseNotes; openLabel: ''
"


	^ '- How to start SqSquare -

*On server:
 "Create a board"
 SqExample createBoardOnServer.

*On client:
 SqBoardCompositePanel open.

If you do it, login dialog will open. You can enter ''user01'' from ''user10''. 
(password is the same as userId).

Select ''board1''. You can see two windows. One is a map for the whole screen,
and the other is your local view.


*Settings
 "To reset board''s contents:"
 SqServer forgetAll; deleteAll.

 "To show debug messages:"
 SqSettings isDebugging: true.

' ! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo-menu' stamp: 'MU 2/17/2006 13:23'!
getLinkForPlayer: target
	target linkForSelf openInHand.! !

!CProjectBuilder methodsFor: '*SqSquare-Client-override' stamp: 'mu 5/10/2006 15:44'!
initialize
	super initialize.
	projectShell := self projectShellClass new.
	topPanel := CPlayer new.
	worldMenu := CWidget new. "will be clobbered immediately"
	projectList := CProjectList new.
	self installNewNavigationPanel.
	self newProject.
	self startScript: #installWorldMenu.
	self startScript: ["After project is set" myHalo := self project halo].! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'minami 1/17/2006 16:21'!
onHaloDrag: aHandle
	| lastPt nextPt delta haloTarget oldPos |
	<on: haloDrag>
	"note: does not recompute transform every frame"
	lastPt := self hand position. "global!!"
	haloTarget := self halo target.
	haloTarget == projectShell myProject world ifTrue:[^self beep].
	oldPos := haloTarget position.
	self trackHaloHandle: aHandle in:[
		nextPt := self hand position. "global!!"
		haloTarget container 
			ifNil:[delta := nextPt - lastPt]
			ifNotNil:[delta := (haloTarget container globalToLocal: nextPt) - 
					(haloTarget container globalToLocal: lastPt)].
		haloTarget costume moveBy: delta.
		lastPt := nextPt.
	].
	haloTarget tweaked: #position from: oldPos to: haloTarget position.

	haloTarget signal: #haloDragFinished! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'minami 1/19/2006 17:01'!
onHaloEvent: aHandle
	| eventName |
	<on: haloEvent in: halo>
	eventName := aHandle value.
	self halo target ifNil:[^self].
	eventName ifNil:[^self].
	self signal: eventName with: aHandle.

	self halo target signal: eventName.! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'minami 1/19/2006 14:37'!
onHaloGrab: aHandle
	| haloTarget parent aHand |
	<on: haloGrab>
	haloTarget := self halo target.
	haloTarget == projectShell myProject world ifTrue:[^self beep].
	parent := haloTarget container.
	haloTarget transform: haloTarget localToWorld.

	self flag: #partsHack.
	"FIXME: This is an incredibly ugly hack to get the change notification right. I haven't quite thought about how to handle parts-change notification. So we will simply inform the costume about its contents change and this requires the following ugly hack. I NEED TO FIX THIS!!!!!!"
	parent asPrimCostume tweaked: #contents after:[
		haloTarget world add: haloTarget.
	].
	aHand := aHandle hand.
	halo elements do:[:each| each visible: each == aHandle].
	aHand releaseMouseFocus: aHandle.
	aHandle locked: true.
	haloTarget startScript: #onDrag.
	aHand waitUntil: #mouseUp.
	aHandle locked: false.
	halo elements do:[:each| each visible: true].

	haloTarget signal: #haloGrabFinished
! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'MU 2/13/2006 16:16'!
onHaloLink: aHandle
	"The user has clicked on the hand-me-a-tile halo handle of an object"

	<on: haloLink>
	self getLinkForPlayer: self halo target! !

!CProjectBuilder methodsFor: '*SqSquare-Client-halo' stamp: 'minami 2/8/2006 01:11'!
onHaloRepaint: aHandle
	| haloTarget painter aForm bForm |
	<on: haloRepaint>
	painter := self makeNewPainter: 32.
	haloTarget := self halo target.
	haloTarget visible: false.
	painter target: haloTarget.
	painter waitUntil: #close.
	projectShell tool: nil.
	haloTarget visible: true.

	aForm := haloTarget graphicForm.
	aForm ifNil: [^ self].

	aForm island == haloTarget island ifFalse:[
		bForm := haloTarget island new: Form 
			constructor: #extent:depth: 
			arguments:{aForm extent. aForm depth}.
		aForm displayOn: bForm.
		haloTarget graphicForm: bForm.
	].
! !

!CProjectBuilder methodsFor: '*SqSquare-Client-initializing' stamp: 'minami 1/20/2006 12:23'!
projectShellClass
	^ CProjectShell! !

!CProjectBuilder methodsFor: '*SqSquare-Client-override' stamp: 'minami 3/27/2006 11:17'!
showInitialStuff
	self waitTick; waitTick.

"
	self showLicense window moveBy: -10@-40.
	self showReleaseNotes window moveBy: 10@40.
"
	SqSettings showReleaseNotes ifTrue: [
		self showSqSquareReleaseNotes window moveBy: 40@0.
	]! !

!CProjectBuilder methodsFor: '*SqSquare-Client-initial window' stamp: 'mu 3/2/2006 10:34'!
showSqSquareReleaseNotes
	| ws |
	ws := projectShell myIsland new: CWorkspace.
	"tricky... need to create text in project's island"
	ws contents: (ws send: #sqSquareReleaseNotes to: self class).
	ws extent: 500@400.
	self waitTick.
	ws openCenteredIn: projectShell projectWorld.
	ws label: 'SqSquare'.
	^ws! !

SqTabbedPanel subclass: #SqBoardCompositePanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqBoardCompositePanel defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="facadeClient" toSet="facadeClient:" changeEvent="facadeClientChanged">facadeClient</field>
</fields>'!

!SqBoardCompositePanel methodsFor: 'accessing' stamp: 'mu 5/8/2006 12:15'!
activeBoard
	^ self activeContent
		ifNotNilDo: [:ac | ac board]! !

!SqBoardCompositePanel methodsFor: 'accessing' stamp: 'mu 4/10/2006 12:25'!
boards
	^self contents! !

!SqBoardCompositePanel methodsFor: 'initialize' stamp: 'mu 4/27/2006 11:52'!
close
	self release.
	myCostume ifNotNilDo: [:cos | cos release].
	Processor activeProject ifNotNilDo: [:proj | proj trashManager removeFromTrash: self].
	super close

	! !

!SqBoardCompositePanel methodsFor: 'actions' stamp: 'mu 4/20/2006 16:18'!
createBoard

	| newBoard boardClient tray existed bn |

	facadeClient ifNil: [^ self].

	bn _ UIManager default request: 'new board name?'.
	bn isEmptyOrNil ifTrue: [^ self].
	newBoard := facadeClient createNewBoard: bn.

	existed _ self costume tabButtons detect: [:each | each content boardId = newBoard boardId] ifNone: [].
	existed ifNotNilDo: [:button | ^ button onFired].

	"Create BoardClient"
	boardClient _ facadeClient enterIn: newBoard.

	"Tweak"
	tray _ SqUIBuilder default boardPanelFor: boardClient.

	self addContent: tray.
	self activeContent: tray.
! !

!SqBoardCompositePanel methodsFor: 'initialize' stamp: 'mu 4/20/2006 15:51'!
defaultCostume

	^ SqBoardCompositePanelCostume! !

!SqBoardCompositePanel methodsFor: 'accessing' stamp: 'mu 4/5/2006 11:18'!
facadeClient
	"Answer the facadeClient of the receiver"
	<bewareOf: #facadeClientChanged>
	^self propertyValueAt: #facadeClient! !

!SqBoardCompositePanel methodsFor: 'accessing' stamp: 'mu 4/5/2006 11:18'!
facadeClient: aValue
	"Modify the receiver's facadeClient"
	^self propertyValueAt: #facadeClient put: aValue with: #facadeClientChanged! !

!SqBoardCompositePanel methodsFor: 'testing' stamp: 'minami 4/6/2006 15:46'!
isDropAcceptable
	^ false! !

!SqBoardCompositePanel methodsFor: 'testing' stamp: 'mu 4/20/2006 16:49'!
isLoggedIn
	^facadeClient notNil! !

!SqBoardCompositePanel methodsFor: 'private' stamp: 'mu 4/26/2006 16:46'!
loggedIn
	self setGraphicalCursor.
	self inform: 'Welcome!!'

	! !

!SqBoardCompositePanel methodsFor: 'private' stamp: 'mu 4/26/2006 15:31'!
loggedOut
	self unsetGraphicalCursor! !

!SqBoardCompositePanel methodsFor: 'events' stamp: 'mu 5/8/2006 14:28'!
onMouseEnter
	<on: mouseEnter>
	self isLoggedIn
		ifTrue: [self setGraphicalCursor]! !

!SqBoardCompositePanel methodsFor: 'actions' stamp: 'mu 4/20/2006 16:18'!
openExtentMenu
	self activeContent ifNil: [^ self].
	self activeContent openExtentMenu! !

!SqBoardCompositePanel methodsFor: 'accessing' stamp: 'mu 4/26/2006 14:06'!
profile
	self facadeClient ifNil: [^nil].
	^self facadeClient profile
	! !

!SqBoardCompositePanel methodsFor: 'initialize' stamp: 'mu 4/27/2006 11:39'!
release
	self facadeClient
		ifNotNilDo: [:cli | 
			self loggedOut.
			cli logout.
			cli close].
	facadeClient _ nil.

	super release
! !

!SqBoardCompositePanel methodsFor: 'delegation' stamp: 'minami 4/14/2006 13:59'!
resetScale
	self activeContent ifNil: [^ self].
	self activeContent resetScale! !

!SqBoardCompositePanel methodsFor: 'actions' stamp: 'mu 4/20/2006 16:18'!
restartPlayers
	SqClient playAll.
	SqAudioChatUserList allInstancesDo: [:e | e startTileTicking]! !

!SqBoardCompositePanel methodsFor: 'actions' stamp: 'mu 4/20/2006 16:22'!
selectBoard

	| boards menuCol selectedUUID |

	facadeClient ifNil: [^ self].

	boards _ facadeClient boards.
	menuCol _ boards collect: [:e | Array with: e name with: e boardId].
	menuCol isEmptyOrNil ifTrue: [
		^ self createBoard.
	].

	selectedUUID _ (SelectionMenu fromArray: menuCol) startUp ifNil: [^ self].
	
	self selectBoard: selectedUUID! !

!SqBoardCompositePanel methodsFor: 'actions' stamp: 'mu 4/21/2006 16:56'!
selectBoard: boardIdString

	| newBoard boardClient panel existed |

	self isLoggedIn ifFalse: [self tryLogin].

	facadeClient ifNil: [^self inform: 'Please logon!!' translated].
	boardIdString ifNil: [^self inform: 'Please select board!!' translated].

	newBoard := facadeClient boardAt: boardIdString.

	existed _ self costume tabButtons detect: [:each | each content boardId = newBoard boardId] ifNone: [].
	existed ifNotNilDo: [:button | ^ button onFired].

	"Create BoardClient"
	boardClient _ facadeClient enterIn: newBoard.

	"Tweak"
	panel _ SqUIBuilder default boardPanelFor: boardClient.

	self addContent: panel.
	self activeContent: panel.! !

!SqBoardCompositePanel methodsFor: 'content access' stamp: 'minami 3/22/2006 20:18'!
setActiveContent: aPlayer
	
	| myExtent |

	myExtent := self extent.
	self activeContent: aPlayer.

	self waitTick.
	self extent: myExtent.! !

!SqBoardCompositePanel methodsFor: 'private' stamp: 'minami 5/10/2006 14:55'!
setGraphicalCursor
	| pHand aBehavior |

	SqSettings showCursors ifFalse: [^self].

	pHand _ self project primaryHand.
	pHand setUserProfile: self profile.
	
	aBehavior _ pHand cursorBehavior.
	aBehavior ifNil: [aBehavior _ SqCursorBehavior attachTo: self project primaryHand].
	
	aBehavior compositePanel: self.
	
! !

!SqBoardCompositePanel methodsFor: 'delegation' stamp: 'minami 4/14/2006 15:06'!
setSelectionMode: aSymbol
	self activeContent ifNil: [^ self].
	self activeContent setSelectionMode: aSymbol! !

!SqBoardCompositePanel methodsFor: 'actions' stamp: 'mu 4/20/2006 16:13'!
tryLogin
	self tryLogin: nil
! !

!SqBoardCompositePanel methodsFor: 'actions' stamp: 'mu 4/26/2006 14:08'!
tryLogin: userIdString
	| userId password |

	self isLoggedIn ifTrue: [^ UIManager default inform: 'already login'].
	SqConnectionKeeper default start.

	"RPC"
	userId := UIManager default request: 'UserId?', '@', SqSettings serverHost asString initialAnswer: userIdString.
	userId ifEmpty: [^ self inform: 'login failed'].
	password := UIManager default requestPassword: userId, '''s password?'.

	facadeClient := SqClient userId: userId.
	(facadeClient login: userId password: password) ifTrue: [self loggedIn] ifFalse: [
		facadeClient := nil.
		^ self inform: 'login failed'
	].

	! !

!SqBoardCompositePanel methodsFor: 'private' stamp: 'mu 4/27/2006 11:35'!
unsetGraphicalCursor
	
	self project ifNotNilDo: [:p | p primaryHand setUserProfile: nil].! !

!SqBoardCompositePanel methodsFor: 'delegation' stamp: 'minami 4/14/2006 13:59'!
zoomIn
	self activeContent ifNil: [^ self].
	self activeContent zoomIn! !

!SqBoardCompositePanel methodsFor: 'delegation' stamp: 'minami 4/14/2006 13:59'!
zoomOut
	self activeContent ifNil: [^ self].
	self activeContent zoomOut! !

!CHandPlayer methodsFor: '*SqSquare-Client-accessing-override' stamp: 'minami 5/10/2006 12:25'!
mouseCursor: aCursor
	| oldPosition newCursor oldCursor |
	newCursor := aCursor ifNil:[Cursor normal].
	oldCursor := self mouseCursor ifNil:[Cursor normal].
	oldCursor == newCursor ifTrue:[^aCursor].
	self invalidate.
	oldPosition := self position.
	super mouseCursor: newCursor.
	self extent: newCursor extent.
	self pivot: newCursor offset negated.
	self graphic: mouseCursor asForm.
	self position: oldPosition.
	self asPrimCostume invalidationSuppressed: (newCursor isCursor and:[showHardwareCursor]).
	self invalidate.

	self signal: #mouseCursorStyleChanged with: newCursor.

	^newCursor! !

!CHandPlayer methodsFor: '*SqSquare-Client-event' stamp: 'minami 5/10/2006 14:56'!
onMouseCursorStyleChanged: cursorForm
	<on: mouseCursorStyleChanged>
	userProfile ifNil: [^ self].
	self userInitials: userProfile initials color: userProfile color style: cursorForm
! !

!CHandPlayer methodsFor: '*SqSquare-Client-cursor' stamp: 'mu 4/28/2006 16:34'!
setUserProfile: profile
	
	self userProfile: profile.
	profile ifNil: [^self showHardwareCursor: true].
	self showHardwareCursor: false.
	self userInitials: userProfile initials color: userProfile color.

	! !

!CHandPlayer methodsFor: '*SqSquare-Client-cursor' stamp: 'mu 5/8/2006 16:48'!
style: aSymbol

	| cursorForm |
	cursorForm _ SqUtil cursorOfName: aSymbol.
	userProfile ifNil: [^ self].
	self userInitials: userProfile initials color: userProfile color style: cursorForm! !

!CHandPlayer methodsFor: '*SqSquare-Client-cursor' stamp: 'mu 4/25/2006 17:06'!
userInitials: userInitials color: cursorColor

	self userInitials: userInitials color: cursorColor style: Cursor normal
	! !

!CHandPlayer methodsFor: '*SqSquare-Client-cursor' stamp: 'mu 5/8/2006 16:55'!
userInitials: userInitials color: cursorColor style: orgCursorForm

	| cursorForm |
	cursorForm _ SqUtil cursorFormWithInitials: userInitials color: cursorColor style: orgCursorForm.

	self graphic: cursorForm.
	self extent: cursorForm boundingBox extent.
	! !

CHandPlayer subclass: #SqPassiveHandPlayer
	instanceVariableNames: 'lastPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqPassiveHandPlayer defineFields: '<?xml  version="1.0" ?>
<fields>
	<field instanceVariable="true" serializable="false" toGet="lastPosition" toSet="lastPosition:" color="FFFF00">lastPosition</field>
</fields>'!

!SqPassiveHandPlayer methodsFor: 'releasing' stamp: 'mu 4/28/2006 16:31'!
destroy
	self container ifNotNilDo: [:cont | cont cursors removeKey: self userId ifAbsent:[]].
	super destroy! !

!SqPassiveHandPlayer methodsFor: 'private events' stamp: 'mu 4/28/2006 16:07'!
dispatchEvent: anEvent
	"do nothing"! !

!SqPassiveHandPlayer methodsFor: 'initialize' stamp: 'mu 4/28/2006 17:04'!
initialize
	super initialize.
	lastPosition _ 0@0.
	self locked: true.

	"self startScript: [hand position printString displayAt: 0@200] when: {self. #geometryChanged}."! !

!SqPassiveHandPlayer methodsFor: 'accessing' stamp: 'mu 4/28/2006 16:08'!
lastPosition
	"Answer the lastPosition of the receiver"
	^lastPosition! !

!SqPassiveHandPlayer methodsFor: 'accessing' stamp: 'mu 4/28/2006 16:08'!
lastPosition: aValue
	"Modify the receiver's lastPosition"
	lastPosition := aValue! !

!SqPassiveHandPlayer methodsFor: 'ticking' stamp: 'mu 4/28/2006 16:41'!
onTick
	| curPosition |
	<ticking: 0.4>
	curPosition _ self position.
	lastPosition = curPosition
		ifTrue:[self destroy]
		ifFalse:[lastPosition _ curPosition].! !

!SqPassiveHandPlayer methodsFor: 'accessing' stamp: 'mu 4/28/2006 16:37'!
userId
	^self userProfile ifNotNilDo: [:prof | prof id]! !

!Form methodsFor: '*SqSquare-Client-clipping' stamp: 'mu 4/25/2006 15:41'!
contentsOfColor
	^ self contentsOfArea: (0@0 extent: self extentOfColor)! !

!Form methodsFor: '*SqSquare-Client-clipping' stamp: 'mu 4/25/2006 15:42'!
extentOfColor
	^ (self lastHIndexOfColor + 1) @ (self lastVIndexOfColor + 1)! !

!Form methodsFor: '*SqSquare-Client-clipping' stamp: 'mu 4/25/2006 15:38'!
lastHIndexOfColor

	self width to: 0 by: -1 do: [:wIndex |
		0 to: self height do: [:hIndex |
			((self colorAt: wIndex @ hIndex) == Color transparent) ifFalse: [^ wIndex].
		].
	].
	^ 0.! !

!Form methodsFor: '*SqSquare-Client-clipping' stamp: 'mu 4/25/2006 15:38'!
lastVIndexOfColor

	self height to: 0 by: -1 do: [:hIndex |
		0 to: self width do: [:wIndex |
			((self colorAt: wIndex @ hIndex) == Color transparent) ifFalse: [^ hIndex].
		].
	].
	^ 0.! !

ElCommandClient subclass: #SqAudioChatCommandClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat'!

CCostume subclass: #SqAudioChatPanelCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat'!

SqAudioChatPanelCostume class
	instanceVariableNames: 'images'!

SqAudioChatPanelCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="startButton" toSet="startButton:" changeEvent="startButtonChanged">startButton</field>
	<field toGet="talkButton" toSet="talkButton:" changeEvent="talkButtonChanged">talkButton</field>
	<field toGet="levelIndicator" toSet="levelIndicator:" changeEvent="levelIndicatorChanged">levelIndicator</field>
	<field toGet="listenToMyselfButton" toSet="listenToMyselfButton:" changeEvent="listenToMyselfButtonChanged">listenToMyselfButton</field>
	<field toGet="userList" toSet="userList:" changeEvent="userListChanged">userList</field>
</fields>'!

!SqAudioChatPanelCostume class methodsFor: 'class initialization' stamp: 'minami 3/27/2006 06:36'!
initialize
	images := Dictionary new! !

!SqAudioChatPanelCostume class methodsFor: 'private' stamp: 'minami 3/27/2006 06:43'!
talkButtonImage
	^ images
		at: #talkButtonImage
		ifAbsentPut: [Form fromCompactBytes: self talkButtonImageArray]! !

!SqAudioChatPanelCostume class methodsFor: 'private' stamp: 'minami 3/27/2006 06:44'!
talkButtonImageArray
	^ #(2 8 0 11 0 13 0 0 0 0 1 0 0 255 0 0 128 255 0 128 0 255 0 128 128 255 128 0 0 255 128 0 128 255 128 128 0 255 192 192 192 255 192 220 192 255 240 202 166 255 0 32 64 255 0 32 96 255 0 32 128 255 0 32 160 255 0 32 192 255 0 32 224 255 0 64 0 255 0 64 32 255 0 64 64 255 0 64 96 255 0 64 128 255 0 64 160 255 0 64 192 255 0 64 224 255 0 96 0 255 0 96 32 255 0 96 64 255 0 96 96 255 0 96 128 255 0 96 160 255 0 96 192 255 0 96 224 255 0 128 0 255 0 128 32 255 0 128 64 255 0 128 96 255 0 128 128 255 0 128 160 255 0 128 192 255 0 128 224 255 0 160 0 255 0 160 32 255 0 160 64 255 0 160 96 255 0 160 128 255 0 160 160 255 0 160 192 255 0 160 224 255 0 192 0 255 0 192 32 255 0 192 64 255 0 192 96 255 0 192 128 255 0 192 160 255 0 192 192 255 0 192 224 255 0 224 0 255 0 224 32 255 0 224 64 255 0 224 96 255 0 224 128 255 0 224 160 255 0 224 192 255 0 224 224 255 64 0 0 255 64 0 32 255 64 0 64 255 64 0 96 255 64 0 128 255 64 0 160 255 64 0 192 255 64 0 224 255 64 32 0 255 64 32 32 255 64 32 64 255 64 32 96 255 64 32 128 255 64 32 160 255 64 32 192 255 64 32 224 255 64 64 0 255 64 64 32 255 64 64 64 255 64 64 96 255 64 64 128 255 64 64 160 255 64 64 192 255 64 64 224 255 64 96 0 255 64 96 32 255 64 96 64 255 64 96 96 255 64 96 128 255 64 96 160 255 64 96 192 255 64 96 224 255 64 128 0 255 64 128 32 255 64 128 64 255 64 128 96 255 64 128 128 255 64 128 160 255 64 128 192 255 64 128 224 255 64 160 0 255 64 160 32 255 64 160 64 255 64 160 96 255 64 160 128 255 64 160 160 255 64 160 192 255 64 160 224 255 64 192 0 255 64 192 32 255 64 192 64 255 64 192 96 255 64 192 128 255 64 192 160 255 64 192 192 255 64 192 224 255 64 224 0 255 64 224 32 255 64 224 64 255 64 224 96 255 64 224 128 255 64 224 160 255 64 224 192 255 64 224 224 255 128 0 0 255 128 0 32 255 128 0 64 255 128 0 96 255 128 0 128 255 128 0 160 255 128 0 192 255 128 0 224 255 128 32 0 255 128 32 32 255 128 32 64 255 128 32 96 255 128 32 128 255 128 32 160 255 128 32 192 255 128 32 224 255 128 64 0 255 128 64 32 255 128 64 64 255 128 64 96 255 128 64 128 255 128 64 160 255 128 64 192 255 128 64 224 255 128 96 0 255 128 96 32 255 128 96 64 255 128 96 96 255 128 96 128 255 128 96 160 255 128 96 192 255 128 96 224 255 128 128 0 255 128 128 32 255 128 128 64 255 128 128 96 255 128 128 128 255 128 128 160 255 128 128 192 255 128 128 224 255 128 160 0 255 128 160 32 255 128 160 64 255 128 160 96 255 128 160 128 255 128 160 160 255 128 160 192 255 128 160 224 255 128 192 0 255 128 192 32 255 128 192 64 255 128 192 96 255 128 192 128 255 128 192 160 255 128 192 192 255 128 192 224 255 128 224 0 255 128 224 32 255 128 224 64 255 128 224 96 255 128 224 128 255 128 224 160 255 128 224 192 255 128 224 224 255 192 0 0 255 192 0 32 255 192 0 64 255 192 0 96 255 192 0 128 255 192 0 160 255 192 0 192 255 192 0 224 255 192 32 0 255 192 32 32 255 192 32 64 255 192 32 96 255 192 32 128 255 192 32 160 255 192 32 192 255 192 32 224 255 192 64 0 255 192 64 32 255 192 64 64 255 192 64 96 255 192 64 128 255 192 64 160 255 192 64 192 255 192 64 224 255 192 96 0 255 192 96 32 255 192 96 64 255 192 96 96 255 192 96 128 255 192 96 160 255 192 96 192 255 192 96 224 255 192 128 0 255 192 128 32 255 192 128 64 255 192 128 96 255 192 128 128 255 192 128 160 255 192 128 192 255 192 128 224 255 192 160 0 255 192 160 32 255 192 160 64 255 192 160 96 255 192 160 128 255 192 160 160 255 192 160 192 255 192 160 224 255 192 192 0 255 192 192 32 255 192 192 64 255 192 192 96 255 192 192 128 255 192 192 160 255 240 251 255 255 164 160 160 255 128 128 128 255 0 0 0 0 0 255 0 255 0 255 255 255 255 0 0 255 255 0 255 255 255 255 0 255 255 255 255 255 128 156 39 5 249 155 249 249 249 73 82 82 249 0 249 249 249 249 249 249 82 8 91 8 82 0 249 249 249 249 249 247 73 91 246 82 82 0 249 249 249 249 247 82 82 8 155 7 82 0 249 249 249 155 82 155 82 73 82 73 249 0 249 249 155 82 82 82 82 247 249 249 249 0 249 91 82 82 82 82 247 249 249 249 249 0 249 73 73 82 82 249 249 249 249 249 249 0 249 73 73 91 249 249 249 249 249 249 249 0 164 91 247 247 249 249 249 249 249 249 249 0 82 164 249 249 249 91 164 249 249 249 249 0 249 73 155 155 82 155 249 249 249 249 249 0 249 247 164 164 247 249 249 249 249 249 249 0) asByteArray! !

!SqAudioChatPanelCostume methodsFor: 'private' stamp: 'minami 3/7/2006 14:01'!
addSpacer: spacerExtent
	^ self addSpacer: spacerExtent color: Color transparent! !

!SqAudioChatPanelCostume methodsFor: 'private' stamp: 'minami 3/7/2006 14:01'!
addSpacer: spacerExtent color: spacerColor
	| aSpacer |
	aSpacer := CPlayer new.
	aSpacer borderWidth: 0.
	aSpacer extent: spacerExtent.
	aSpacer color: spacerColor.
	self add: aSpacer.
	^ aSpacer
	! !

!SqAudioChatPanelCostume methodsFor: 'private' stamp: 'minami 4/12/2006 12:18'!
audioChatControl
	^ self player audioChatControl! !

!SqAudioChatPanelCostume methodsFor: 'building' stamp: 'minami 3/10/2006 11:44'!
buildChatUserList
	^ SqAudioChatUserList new.! !

!SqAudioChatPanelCostume methodsFor: 'building' stamp: 'minami 3/10/2006 11:43'!
buildLevelIndicator
	| indicator |
	indicator := SqLevelIndicator new.
	indicator extent: self levelIndicatorExtent.
	^ indicator! !

!SqAudioChatPanelCostume methodsFor: 'building' stamp: 'minami 3/10/2006 11:40'!
buildRowPlayer
	| aRow |
	aRow := CPlayer new.
	aRow layout: CTableLayout new.
	aRow hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	aRow layout listDirection: #leftToRight.
	^ aRow! !

!SqAudioChatPanelCostume methodsFor: 'building' stamp: 'minami 3/27/2006 06:45'!
buildTalkButton
	| button |
	button :=  CButton new.
	button extent: self talkButtonExtent.
	button color: Color veryLightGray.
	button image: self class talkButtonImage.
	^ button! !

!SqAudioChatPanelCostume methodsFor: 'private' stamp: 'minami 3/9/2006 12:35'!
chatClient
	^ self player chatClient! !

!SqAudioChatPanelCostume methodsFor: 'initialize' stamp: 'mu 4/5/2006 14:23'!
close
	super close.

	startButton ifNotNilDo: [:c | c close].
	talkButton ifNotNilDo: [:c | c close] .
	levelIndicator ifNotNilDo: [:c | c close] .
	listenToMyselfButton ifNotNilDo: [:c | c close] .
	userList ifNotNilDo: [:c | c close] .

	! !

!SqAudioChatPanelCostume methodsFor: 'private' stamp: 'minami 3/9/2006 12:35'!
commandClient
	^ self player commandClient! !

!SqAudioChatPanelCostume methodsFor: 'initialize' stamp: 'minami 4/12/2006 11:58'!
defaultPlayer
	^ SqAudioChatPanel! !

!SqAudioChatPanelCostume methodsFor: 'private' stamp: 'mu 4/6/2006 11:22'!
facade
	^ self player facade! !

!SqAudioChatPanelCostume methodsFor: 'initialize' stamp: 'minami 3/7/2006 13:49'!
initialize
	super initialize! !

!SqAudioChatPanelCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 13:49'!
levelIndicator
	"Answer the levelIndicator of the receiver"
	<bewareOf: #levelIndicatorChanged>
	^self propertyValueAt: #levelIndicator! !

!SqAudioChatPanelCostume methodsFor: 'building' stamp: 'minami 3/10/2006 11:40'!
levelIndicatorExtent
	^ 64@20! !

!SqAudioChatPanelCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 13:49'!
levelIndicator: aValue
	"Modify the receiver's levelIndicator"
	^self propertyValueAt: #levelIndicator put: aValue with: #levelIndicatorChanged! !

!SqAudioChatPanelCostume methodsFor: 'accessing' stamp: 'minami 3/8/2006 15:18'!
listenToMyselfButton
	"Answer the listenToMyselfButton of the receiver"
	<bewareOf: #listenToMyselfButtonChanged>
	^self propertyValueAt: #listenToMyselfButton! !

!SqAudioChatPanelCostume methodsFor: 'accessing' stamp: 'minami 3/8/2006 15:18'!
listenToMyselfButton: aValue
	"Modify the receiver's listenToMyselfButton"
	^self propertyValueAt: #listenToMyselfButton put: aValue with: #listenToMyselfButtonChanged! !

!SqAudioChatPanelCostume methodsFor: 'events' stamp: 'minami 4/12/2006 15:16'!
onListenToMySelfButtonFired
	| aBoolean |

	<on: fire in: listenToMyselfButton>

	self chatClient ifNil: [^ self].
	aBoolean := PopUpMenu confirm: 'listen to yourself?'.
	self chatClient sendListenToMyselfCommand: aBoolean.
! !

!SqAudioChatPanelCostume methodsFor: 'events' stamp: 'minami 3/23/2006 08:00'!
onStartButtonFired
	<on: fire in: startButton>

	^ self player isRunning
		ifTrue: [self privStop]
		ifFalse: [self privStart]! !

!SqAudioChatPanelCostume methodsFor: 'events' stamp: 'minami 3/7/2006 18:56'!
onTalkButtonFired
	<on: fire in: talkButton>

	self player chatClient ifNotNilDo: [:cc |
		cc isSpeaking 
			ifTrue: [cc stopSpeaking.
					self levelIndicator reset] 
			ifFalse: [cc sendWantsToSpeakCommand].
	].
! !

!SqAudioChatPanelCostume methodsFor: 'private' stamp: 'minami 3/23/2006 08:00'!
privStart
	self player start! !

!SqAudioChatPanelCostume methodsFor: 'private' stamp: 'minami 3/23/2006 08:00'!
privStop
	self player stop.
	self userList removeAll! !

!SqAudioChatPanelCostume methodsFor: 'initialize' stamp: 'minami 4/21/2006 19:08'!
setupCostume
	| controllerRow debugRow |

	super setupCostume.

	self layout: CTableLayout new.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self layout listDirection: #topToBottom.


"	SqSettings isDebugging ifTrue: ["
		debugRow := self buildRowPlayer.
		self add: debugRow.

		self startButton: CButton new.
		self startButton extent: self levelIndicatorExtent.
		self startButton label: 'start/stop'.
		debugRow add: self startButton.

		self listenToMyselfButton: CButton new.
		self listenToMyselfButton extent: self talkButtonExtent.
		self listenToMyselfButton label: '@'.
		debugRow add: self listenToMyselfButton.
"	]."

	controllerRow := self buildRowPlayer.
	self add: controllerRow.

	self talkButton: self buildTalkButton.
	self chatClient ifNotNilDo: [:cc | cc talkButton: self talkButton].
	controllerRow add: self talkButton.

	self levelIndicator: self buildLevelIndicator.
	self chatClient ifNotNilDo: [:cc | cc levelIndicator: self levelIndicator].
	controllerRow add: self levelIndicator.

	self userList: self buildChatUserList.
	self audioChatControl ifNotNilDo: [:c | c userList: self userList].
	self chatClient ifNotNilDo: [:c | c userList: self userList].
	self add: self userList.

! !

!SqAudioChatPanelCostume methodsFor: 'building' stamp: 'minami 3/10/2006 11:40'!
spacerExtent
	^ 3@20! !

!SqAudioChatPanelCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 14:30'!
startButton
	"Answer the startButton of the receiver"
	<bewareOf: #startButtonChanged>
	^self propertyValueAt: #startButton! !

!SqAudioChatPanelCostume methodsFor: 'private' stamp: 'minami 3/7/2006 19:03'!
startButtonLabel
	^ 'start/stop'! !

!SqAudioChatPanelCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 14:30'!
startButton: aValue
	"Modify the receiver's startButton"
	^self propertyValueAt: #startButton put: aValue with: #startButtonChanged! !

!SqAudioChatPanelCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 13:49'!
talkButton
	"Answer the talkButton of the receiver"
	<bewareOf: #talkButtonChanged>
	^self propertyValueAt: #talkButton! !

!SqAudioChatPanelCostume methodsFor: 'building' stamp: 'minami 3/10/2006 11:40'!
talkButtonExtent
	^ 32@20! !

!SqAudioChatPanelCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 13:49'!
talkButton: aValue
	"Modify the receiver's talkButton"
	^self propertyValueAt: #talkButton put: aValue with: #talkButtonChanged! !

!SqAudioChatPanelCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 19:15'!
userList
	"Answer the userList of the receiver"
	<bewareOf: #userListChanged>
	^self propertyValueAt: #userList! !

!SqAudioChatPanelCostume methodsFor: 'accessing' stamp: 'minami 3/7/2006 19:15'!
userList: aValue
	"Modify the receiver's userList"
	^self propertyValueAt: #userList put: aValue with: #userListChanged! !

CCostume subclass: #SqBoardCompositePanelCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqBoardCompositePanelCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="activeContent" toSet="activeContent:" changeEvent="activeContentChanged">activeContent</field>
	<field toGet="toolBarPanal" toSet="toolBarPanal:" changeEvent="toolBarPanalChanged">toolBarPanal</field>
	<field toGet="tabPanel" toSet="tabPanel:" changeEvent="tabPanelChanged">tabPanel</field>
	<field toGet="contentHolder" toSet="contentHolder:" changeEvent="contentHolderChanged">contentHolder</field>
	<field toGet="loginToolBar" toSet="loginToolBar:" changeEvent="loginToolBarChanged">loginToolBar</field>
	<field toGet="accessToolBar" toSet="accessToolBar:" changeEvent="accessToolBarChanged">accessToolBar</field>
	<field toGet="zoomToolBar" toSet="zoomToolBar:" changeEvent="zoomToolBarChanged">zoomToolBar</field>
	<field toGet="debutToolBar" toSet="debutToolBar:" changeEvent="debutToolBarChanged">debutToolBar</field>
	<field toGet="boardSettingToolBar" toSet="boardSettingToolBar:" changeEvent="boardSettingToolBarChanged">boardSettingToolBar</field>
</fields>'!

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 4/13/2006 15:54'!
accessToolBar
	"Answer the accessToolBar of the receiver"
	<bewareOf: #accessToolBarChanged>
	^self propertyValueAt: #accessToolBar! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 4/13/2006 15:54'!
accessToolBar: aValue
	"Modify the receiver's accessToolBar"
	^self propertyValueAt: #accessToolBar put: aValue with: #accessToolBarChanged! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:20'!
activeContent
	"Answer the activeContent of the receiver"
	<bewareOf: #activeContentChanged>
	^self propertyValueAt: #activeContent! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 3/20/2006 11:20'!
activeContent: aValue
	"Modify the receiver's activeContent"
	^self propertyValueAt: #activeContent put: aValue with: #activeContentChanged! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 4/14/2006 13:56'!
boardSettingToolBar
	"Answer the boardSettingToolBar of the receiver"
	<bewareOf: #boardSettingToolBarChanged>
	^self propertyValueAt: #boardSettingToolBar! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 4/14/2006 13:56'!
boardSettingToolBar: aValue
	"Modify the receiver's boardSettingToolBar"
	^self propertyValueAt: #boardSettingToolBar put: aValue with: #boardSettingToolBarChanged! !

!SqBoardCompositePanelCostume methodsFor: 'private' stamp: 'minami 4/14/2006 12:15'!
buildAccessToolBar
	| tb |
	tb := SqAccessToolBar on: self player.
	tb 
		startScript: [self activeContent ifNotNilDo: 
						[:cont | tb toolList value: cont selectionMode]] 
		when: {self. #activeContentChanged}.
	^ tb! !

!SqBoardCompositePanelCostume methodsFor: 'private' stamp: 'minami 4/14/2006 13:56'!
buildBoardSettingToolBar
	^ SqBoardSettingToolBar on: self player! !

!SqBoardCompositePanelCostume methodsFor: 'private' stamp: 'minami 3/17/2006 15:45'!
buildContentHolder
	| aHolder |
	aHolder := CPlayer new.

	aHolder hResizing: #spaceFill; vResizing: #shrinkWrap.
	aHolder color: self defaultContentHolderColor.


	^ aHolder
! !

!SqBoardCompositePanelCostume methodsFor: 'private' stamp: 'minami 4/13/2006 17:01'!
buildDebugToolBar
	^ SqDebugToolBar on: self player! !

!SqBoardCompositePanelCostume methodsFor: 'private' stamp: 'minami 4/13/2006 16:08'!
buildLoginToolBar
	^ SqLoginToolBar on: self player! !

!SqBoardCompositePanelCostume methodsFor: 'private' stamp: 'mu 4/20/2006 15:45'!
buildRowPanel: anInteger
	| aPane |
	aPane := CPlayer new.

	aPane hResizing: #spaceFill.
	aPane height: anInteger.
	aPane layout: CTableLayout new.
	aPane layout listDirection: #leftToRight.

	aPane color: self defaultRowColor.

	^ aPane
! !

!SqBoardCompositePanelCostume methodsFor: 'private' stamp: 'minami 3/29/2006 15:41'!
buildSpacer
	^ self buildSpacer: 2@1! !

!SqBoardCompositePanelCostume methodsFor: 'private' stamp: 'minami 3/29/2006 15:40'!
buildSpacer: specerExtent
	| aPlayer |
	aPlayer := CPlayer new.
	aPlayer extent: specerExtent.
	aPlayer color: Color transparent.
	^ aPlayer
! !

!SqBoardCompositePanelCostume methodsFor: 'private' stamp: 'mu 4/20/2006 15:45'!
buildTabPanel
	^ self buildRowPanel: 20! !

!SqBoardCompositePanelCostume methodsFor: 'private' stamp: 'mu 4/20/2006 15:45'!
buildToolBarPanel
	^ self buildRowPanel: 42! !

!SqBoardCompositePanelCostume methodsFor: 'private' stamp: 'minami 4/14/2006 11:35'!
buildZoomToolBar
	^ SqZoomToolBar on: self player! !

!SqBoardCompositePanelCostume methodsFor: 'private' stamp: 'mu 4/20/2006 15:44'!
contentExtent
	^ self extent x @ (self extent y - self tabPanel extent y - self toolBarPanal extent y).
! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 14:55'!
contentHolder
	"Answer the contentHolder of the receiver"
	<bewareOf: #contentHolderChanged>
	^self propertyValueAt: #contentHolder! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 3/17/2006 14:55'!
contentHolder: aValue
	"Modify the receiver's contentHolder"
	^self propertyValueAt: #contentHolder put: aValue with: #contentHolderChanged! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 4/13/2006 16:59'!
debugToolBar
	"Answer the debugToolBar of the receiver"
	<bewareOf: #debugToolBarChanged>
	^self propertyValueAt: #debugToolBar! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 4/13/2006 16:59'!
debugToolBar: aValue
	"Modify the receiver's debugToolBar"
	^self propertyValueAt: #debugToolBar put: aValue with: #debugToolBarChanged! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 4/13/2006 16:57'!
debutToolBar
	"Answer the debutToolBar of the receiver"
	<bewareOf: #debutToolBarChanged>
	^self propertyValueAt: #debutToolBar! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 4/13/2006 16:57'!
debutToolBar: aValue
	"Modify the receiver's debutToolBar"
	^self propertyValueAt: #debutToolBar put: aValue with: #debutToolBarChanged! !

!SqBoardCompositePanelCostume methodsFor: 'defaults' stamp: 'minami 3/17/2006 14:55'!
defaultContentHolderColor
	^ Color lightGray! !

!SqBoardCompositePanelCostume methodsFor: 'initialize' stamp: 'mu 4/20/2006 15:49'!
defaultPlayer

	^ SqBoardCompositePanel! !

!SqBoardCompositePanelCostume methodsFor: 'defaults' stamp: 'mu 5/10/2006 17:44'!
defaultRowColor

	^ self project widgetLibrary baseColor! !

!SqBoardCompositePanelCostume methodsFor: 'initialize' stamp: 'minami 4/20/2006 16:09'!
initialize
	super initialize.

	self define: #toolBarPanal as: self buildToolBarPanel.
	self define: #loginToolBar as: self buildLoginToolBar.
	self define: #accessToolBar as: self buildAccessToolBar.
	self define: #zoomToolBar as: self buildZoomToolBar.
	self define: #boardSettingToolBar as: self buildBoardSettingToolBar.
	self define: #debugToolBar as: self buildDebugToolBar.

	self define: #contentHolder as: self buildContentHolder.
	self define: #tabPanel as: self buildTabPanel.

! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 4/13/2006 15:54'!
loginToolBar
	"Answer the loginToolBar of the receiver"
	<bewareOf: #loginToolBarChanged>
	^self propertyValueAt: #loginToolBar! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 4/13/2006 15:54'!
loginToolBar: aValue
	"Modify the receiver's loginToolBar"
	^self propertyValueAt: #loginToolBar put: aValue with: #loginToolBarChanged! !

!SqBoardCompositePanelCostume methodsFor: 'events' stamp: 'minami 3/23/2006 08:04'!
onActiveContentChanged
	| activeButton |
	<on: activeContentChanged in: player>

	self activeContent == player activeContent ifTrue: [^ self].

	self activeContent ifNotNil: [
		self contentHolder remove: self activeContent.
	].
	self activeContent: player activeContent.
	self contentHolder addLast: self activeContent.

	self player contents do: [:each | each beBackground].
	self tabButtons do: [:each | each setNormalState].


	activeButton := self tabButtons detect: [:each | each content == self activeContent] ifNone: [^ self].
	activeButton setActiveState.

	self activeContent beActive! !

!SqBoardCompositePanelCostume methodsFor: 'events' stamp: 'minami 3/22/2006 20:30'!
onExtentChanged
	<on: extentChanged>

	self activeContent ifNil: [^ self].
	self activeContent extent: self contentExtent.! !

!SqBoardCompositePanelCostume methodsFor: 'events' stamp: 'minami 4/20/2006 16:11'!
onPlayerContentAdded: addedPlayer
	| aButton |
	<on: contentAdded in: player>

	aButton := SqBoardTabButton new 
				content: addedPlayer;
				holder: player;
				label: addedPlayer title;
				yourself.

	self activeContent ifNotNil: [addedPlayer extent: self contentExtent].

	self tabPanel add: aButton! !

!SqBoardCompositePanelCostume methodsFor: 'initialize' stamp: 'mu 4/6/2006 10:37'!
release
	self activeContent ifNotNilDo: [:con | con close].
	self activeContent: nil.

	! !

!SqBoardCompositePanelCostume methodsFor: 'initialize' stamp: 'minami 4/20/2006 16:12'!
setupCostume
	super setupCostume.

	self asPrimCostume localCache: CFormCache new.

	self layout: CTableLayout new.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self layout listDirection: #topToBottom.
	self layout wrapDirection: #none.

	self addLast: self toolBarPanal.
	self toolBarPanal add: self loginToolBar.
	self toolBarPanal add: self accessToolBar.
	self toolBarPanal add: self zoomToolBar.
	self toolBarPanal add: self boardSettingToolBar.
	self toolBarPanal add: self debugToolBar.

	self addLast: self tabPanel.
	self addLast: self contentHolder.
! !

!SqBoardCompositePanelCostume methodsFor: 'private' stamp: 'mu 4/20/2006 15:44'!
tabButtons
	^ self tabPanel elements! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'mu 4/20/2006 15:44'!
tabPanel
	"Answer the tabPanel of the receiver"
	<bewareOf: #tabPanelChanged>
	^self propertyValueAt: #tabPanel! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'mu 4/20/2006 15:44'!
tabPanel: aValue
	"Modify the receiver's tabPanel"
	^self propertyValueAt: #tabPanel put: aValue with: #tabPanelChanged! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'mu 4/20/2006 15:42'!
toolBarPanal
	"Answer the toolBarPanal of the receiver"
	<bewareOf: #toolBarPanalChanged>
	^self propertyValueAt: #toolBarPanal! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'mu 4/20/2006 15:42'!
toolBarPanal: aValue
	"Modify the receiver's toolBarPanal"
	^self propertyValueAt: #toolBarPanal put: aValue with: #toolBarPanalChanged! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 4/13/2006 15:54'!
zoomToolBar
	"Answer the zoomToolBar of the receiver"
	<bewareOf: #zoomToolBarChanged>
	^self propertyValueAt: #zoomToolBar! !

!SqBoardCompositePanelCostume methodsFor: 'accessing' stamp: 'minami 4/13/2006 15:54'!
zoomToolBar: aValue
	"Modify the receiver's zoomToolBar"
	^self propertyValueAt: #zoomToolBar put: aValue with: #zoomToolBarChanged! !

CPanel subclass: #SqBoardWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqBoardWindow defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="board" toSet="board:" changeEvent="boardChanged">board</field>
	<field toGet="contents" toSet="contents:" changeEvent="contentsChanged">contents</field>
	<field toGet="hBar" toSet="hBar:" changeEvent="hBarChanged">hBar</field>
	<field toGet="vBar" toSet="vBar:" changeEvent="vBarChanged">vBar</field>
</fields>'!

!SqBoardWindow class methodsFor: 'instance creation' stamp: 'MU 2/9/2006 15:20'!
on: board 
	^ self new board: board; setDefaultLabel;
		 yourself! !

!SqBoardWindow class methodsFor: 'instance creation' stamp: 'MU 2/9/2006 15:20'!
on: board named: boardName
	^ self new board: board; setLabel: boardName;
		 yourself! !

!SqBoardWindow class methodsFor: 'instance creation' stamp: 'minami 2/8/2006 14:45'!
openOn: board named: boardName 
	^ self new board: board;
		 setLabel: boardName;
		 open;
		 yourself! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'MU 2/9/2006 15:24'!
accessId
	^self board ifNotNilDo: [:b | b accessId]! !

!SqBoardWindow methodsFor: 'scrolling' stamp: 'minami 1/16/2006 15:46'!
autoScroll
	| pt |
	pt := self contents globalToLocal: self hand position.
	pt x < 20 ifTrue: [ self scrollLeft].
	((self contents width - 20) < pt x and: [pt x < self contents width]) ifTrue: [self scrollRight].

	pt y < 20 ifTrue: [self scrollUp].
	((self contents height - 20) < pt y and: [pt y < self contents height]) ifTrue: [self scrollDown].! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/27/2005 17:03'!
board
	"Answer the board of the receiver"
	<bewareOf: #boardChanged>
	^self propertyValueAt: #board! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 15:20'!
boardExtent
	^ self board extent! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'MU 2/9/2006 15:18'!
boardId
	^self board ifNotNilDo: [:b | b boardId]! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/27/2005 17:03'!
board: aValue
	"Modify the receiver's board"
	^self propertyValueAt: #board put: aValue with: #boardChanged! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/28/2005 12:32'!
contents
	"Answer the contents of the receiver"
	<bewareOf: #contentsChanged>
	^self propertyValueAt: #contents! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/28/2005 12:32'!
contents: aValue
	"Modify the receiver's contents"
	^self propertyValueAt: #contents put: aValue with: #contentsChanged! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 2/15/2006 14:15'!
currentPos
	^ self horizontalPos @ self verticalPos! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 2/15/2006 14:15'!
currentPos: pos
	self horizontalPos: pos x.
	self verticalPos: pos y.! !

!SqBoardWindow methodsFor: 'initialize' stamp: 'MU 2/10/2006 17:29'!
destroy
	super destroy.
	board ifNotNilDo: [:b | b destroy].
	! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/28/2005 12:33'!
hBar
	"Answer the hBar of the receiver"
	<bewareOf: #hBarChanged>
	^self propertyValueAt: #hBar! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/28/2005 12:33'!
hBar: aValue
	"Modify the receiver's hBar"
	^self propertyValueAt: #hBar put: aValue with: #hBarChanged! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 15:59'!
horizontalPos
	^ self hBar value! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 15:59'!
horizontalPos: int
	self hBar value: int! !

!SqBoardWindow methodsFor: 'initialize' stamp: 'minami 12/28/2005 12:33'!
initialize
	super initialize.

	self define: #contents as: CScrollPane new.
	self hBar: contents costume hScrollBar.
	self vBar: contents costume vScrollBar.
	! !

!SqBoardWindow methodsFor: 'events' stamp: 'MU 2/10/2006 15:21'!
onWindowCloseRequest
	<on: closeRequest>
	self destroy. "bye, bye"! !

!SqBoardWindow methodsFor: 'copying' stamp: 'minami 1/16/2006 11:44'!
postCopy
	super postCopy.
	self board ifNotNilDo: [:b | b postCopy].! !

!SqBoardWindow methodsFor: 'scrolling' stamp: 'minami 12/28/2005 20:00'!
scrollDown
	self verticalPos: (self verticalPos + 5)! !

!SqBoardWindow methodsFor: 'scrolling' stamp: 'minami 12/28/2005 20:00'!
scrollLeft
	self horizontalPos: (self horizontalPos - 5)! !

!SqBoardWindow methodsFor: 'scrolling' stamp: 'minami 12/28/2005 20:01'!
scrollRight
	self horizontalPos: (self horizontalPos + 5)! !

!SqBoardWindow methodsFor: 'scrolling' stamp: 'minami 12/28/2005 20:00'!
scrollUp
	self verticalPos: (self verticalPos - 5)! !

!SqBoardWindow methodsFor: 'scaling' stamp: 'mu 4/10/2006 16:57'!
setBoardExtent: aPoint

	self board ifNotNilDo: [:b |
		b setExtent: aPoint
	]! !

!SqBoardWindow methodsFor: 'scaling' stamp: 'mu 4/3/2006 15:44'!
setBoardScale: aValue

	self board ifNotNilDo: [:b |
		b scale: aValue.
		b globalPosition: b container globalPosition
	]! !

!SqBoardWindow methodsFor: 'initialize' stamp: 'MU 2/9/2006 15:24'!
setDefaultLabel
	self setLabel: self accessId! !

!SqBoardWindow methodsFor: 'initialize' stamp: 'minami 2/23/2006 13:59'!
setLabel: boardName
	self label: ('SqBoard - ' , (boardName asString contractTo: 20))! !

!SqBoardWindow methodsFor: 'initialize' stamp: 'minami 2/22/2006 11:56'!
setupCostume
	super setupCostume.

	self extent: self board extent.
	self layout := CProportionalLayout new.

	contents layoutFrame: (0@0 corner: 1@1).
	contents hResizing: #spaceFill; vResizing: #spaceFill.
	contents hScrollable: true; vScrollable: true.

	self contents add: board.
	self add: contents.

	self extent: 400@300.! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 15:14'!
smallForm
	^ self board smallForm! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 2/23/2006 11:55'!
smallForm: reduction
	^ self board smallForm: reduction! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/28/2005 12:33'!
vBar
	"Answer the vBar of the receiver"
	<bewareOf: #vBarChanged>
	^self propertyValueAt: #vBar! !

!SqBoardWindow methodsFor: 'accessing' stamp: 'minami 12/28/2005 12:33'!
vBar: aValue
	"Modify the receiver's vBar"
	^self propertyValueAt: #vBar put: aValue with: #vBarChanged! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 16:00'!
verticalPos
	^ self vBar value! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 16:00'!
verticalPos: int
	self vBar value: int! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 15:17'!
viewableExtent
	^ self contents extent - (self vBar width @ self hBar height)! !

!SqBoardWindow methodsFor: 'contents access' stamp: 'minami 12/28/2005 15:51'!
viewingPos
	^ self hBar value @ self vBar value! !

SqTabButton subclass: #SqBoardTabButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqBoardTabButton defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!SqBoardTabButton methodsFor: 'defaults' stamp: 'minami 4/20/2006 12:01'!
dropAcceptableColor
	^ Color lightYellow! !

!SqBoardTabButton methodsFor: 'events' stamp: 'minami 4/21/2006 00:59'!
onDragDrop: aPlayer
	| clone |
	<on: dragDrop>

	self holder activeContent == self content ifTrue: [^ aPlayer signal: #dropReject].

	clone := aPlayer copy detachBoardProperties; yourself.

	self hand shiftPressed 
		ifFalse: [aPlayer signal: #dropReject.
				self content addToBoard: clone at: 100@100.
				aPlayer asForm asPlayer 
					direction: (aPlayer direction);
					bounds: (aPlayer bounds); 
					open;
					zoomOutBy: 25]
		ifTrue: [self halt].
! !

!SqBoardTabButton methodsFor: 'events' stamp: 'minami 4/20/2006 12:12'!
onDragEnter: evt
	<on: dragEnter>

	evt hand dragContents isDropAcceptable ifFalse: [^ self].

	self holder activeContent == self content 
		ifFalse: [self setDropAcceptable].! !

!SqBoardTabButton methodsFor: 'events' stamp: 'minami 4/20/2006 12:05'!
onDragLeave: evt
	<on: dragLeave>

	self holder activeContent == self content 
		ifTrue: [self setActiveState]
		ifFalse: [self setNormalState]
! !

!SqBoardTabButton methodsFor: 'private' stamp: 'minami 4/20/2006 12:17'!
openMap! !

!SqBoardTabButton methodsFor: 'private' stamp: 'minami 4/20/2006 12:07'!
setDropAcceptable
	self color: self dropAcceptableColor! !

ElAudioChatClient subclass: #SqAudioChatClient
	instanceVariableNames: 'levelIndicator talkButton userList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat'!

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/7/2006 15:19'!
levelIndicator
	^ levelIndicator! !

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/7/2006 15:19'!
levelIndicator: aPlayer
	levelIndicator := aPlayer! !

!SqAudioChatClient methodsFor: 'initialize-release' stamp: 'mu 4/6/2006 11:49'!
release
	levelIndicator _ talkButton _ userList _ nil.
	super release.
	! !

!SqAudioChatClient methodsFor: 'action common' stamp: 'minami 3/7/2006 16:37'!
startSpeaking
	talkButton
		ifNotNilDo: [:button | button color: Color red].
	super startSpeaking! !

!SqAudioChatClient methodsFor: 'running' stamp: 'minami 3/7/2006 16:39'!
stop
	super stop.
	talkButton
		ifNotNilDo: [:button | button color: Color gray].! !

!SqAudioChatClient methodsFor: 'action common' stamp: 'minami 3/7/2006 16:37'!
stopSpeaking
	super stopSpeaking.
	talkButton
		ifNotNilDo: [:button | button color: Color gray].! !

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:36'!
talkButton
	^ talkButton! !

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:36'!
talkButton: aButton
	talkButton := aButton! !

!SqAudioChatClient methodsFor: 'private ui' stamp: 'minami 3/15/2006 19:22'!
uiUpdateLevel: anInteger
	levelIndicator ifNil: [^ self].
	levelIndicator level: (anInteger / 16r8000) asFloat! !

!SqAudioChatClient methodsFor: 'private ui' stamp: 'minami 3/15/2006 19:22'!
uiUpdateSpeakers: speakers listeners: listeners
	self userList ifNotNilDo: [ :ul | ul speakers: speakers listeners: listeners ].
! !

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/8/2006 12:03'!
userList
	^ userList! !

!SqAudioChatClient methodsFor: 'accessing' stamp: 'minami 3/8/2006 12:03'!
userList: aList
	userList := aList! !

CEventBehavior subclass: #SqCursorBehavior
	instanceVariableNames: 'pointChangedLastSend cursorChangedLastSend waitTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqCursorBehavior class
	instanceVariableNames: 'ignorableCursors'!

SqCursorBehavior defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="compositePanel" toSet="compositePanel:" changeEvent="compositePanelChanged">compositePanel</field>
	<field toGet="style" toSet="style:" changeEvent="styleChanged">style</field>
	<field instanceVariable="true" toGet="pointChangedLastSend" toSet="pointChangedLastSend:">pointChangedLastSend</field>
	<field instanceVariable="true" serializable="false" toGet="cursorChangedLastSend" toSet="cursorChangedLastSend:">cursorChangedLastSend</field>
	<field instanceVariable="true" toGet="waitTime" toSet="waitTime:">waitTime</field>
</fields>'!

!SqCursorBehavior class methodsFor: 'defaults' stamp: 'mu 5/8/2006 17:27'!
defaultIgnorableCursors
	^ #(
			"from CCursorLibrary"			
			#fistCursor 
			#handCursor

			"from Cursor"
			#read
			#wait
			#write
		)! !

!SqCursorBehavior class methodsFor: 'defaults' stamp: 'mu 5/8/2006 17:27'!
ignorableCursors
	^ ignorableCursors
		ifNil: [ignorableCursors _ self defaultIgnorableCursors]! !

!SqCursorBehavior methodsFor: 'accessing' stamp: 'mu 5/8/2006 11:01'!
compositePanel
	"Answer the compositePanel of the receiver"
	<bewareOf: #compositePanelChanged>
	^self propertyValueAt: #compositePanel! !

!SqCursorBehavior methodsFor: 'accessing' stamp: 'mu 5/8/2006 11:01'!
compositePanel: aValue
	"Modify the receiver's compositePanel"
	^self propertyValueAt: #compositePanel put: aValue with: #compositePanelChanged! !

!SqCursorBehavior methodsFor: 'accessing' stamp: 'minami 5/10/2006 10:51'!
cursorChangedLastSend
	"Answer the cursorChangedLastSend of the receiver"
	^ cursorChangedLastSend
		ifNil: [cursorChangedLastSend _ Time millisecondClockValue]! !

!SqCursorBehavior methodsFor: 'accessing' stamp: 'minami 5/10/2006 10:50'!
cursorChangedLastSend: aValue
	"Modify the receiver's cursorChangedLastSend"
	cursorChangedLastSend := aValue! !

!SqCursorBehavior methodsFor: 'initialize' stamp: 'minami 5/10/2006 10:55'!
initialize
	super initialize.

	pointChangedLastSend _ cursorChangedLastSend _ waitTime _ nil.! !

!SqCursorBehavior methodsFor: 'testing' stamp: 'minami 5/10/2006 11:27'!
isCursorBehavior
	^ true! !

!SqCursorBehavior methodsFor: 'private' stamp: 'mu 5/8/2006 17:44'!
isIgnorableCursor: styleSymbol
	styleSymbol ifNil: [^true].
	^ self class ignorableCursors includes: styleSymbol! !

!SqCursorBehavior methodsFor: 'events' stamp: 'minami 5/10/2006 11:08'!
onGeometryChanged	
	| currentTime activeBoard cursorPosition viewPort |
	<on: geometryChanged in: target>

	currentTime _ Time millisecondClockValue.
	(currentTime - self pointChangedLastSend) abs > self waitTime ifFalse: [^self].

	(self isIgnorableCursor: self style) ifTrue: [^ self].

	activeBoard _ self compositePanel activeBoard.
	activeBoard ifNil: [^ nil].
	cursorPosition _ activeBoard globalToLocal: target globalPosition.
	viewPort _ activeBoard viewPort.
	
	(viewPort containsPoint: cursorPosition) ifFalse: [^ self].

	activeBoard sendCursorPointChanged: cursorPosition.
	self pointChangedLastSend: currentTime.
	! !

!SqCursorBehavior methodsFor: 'events' stamp: 'minami 5/10/2006 15:03'!
onMouseCursorStyleChanged: cursorForm
	| currentTime activeBoard cursorPosition viewPort |
	<on: mouseCursorStyleChanged in: target>

	currentTime _ Time millisecondClockValue.
	(currentTime - self cursorChangedLastSend) abs > self waitTime ifFalse: [^self].



	activeBoard _ self compositePanel activeBoard.
	activeBoard ifNil: [^ nil].
	cursorPosition _ activeBoard globalToLocal: target globalPosition.
	viewPort _ activeBoard viewPort.
	
	(viewPort containsPoint: cursorPosition) ifFalse: [^ self].

	style _ SqUtil nameOfCursor: cursorForm.

	(self isIgnorableCursor: self style) ifTrue: [^ self].

	activeBoard sendMouseCursorStyleChanged: style.
	self cursorChangedLastSend: currentTime.
! !

!SqCursorBehavior methodsFor: 'accessing' stamp: 'minami 5/10/2006 10:51'!
pointChangedLastSend
	"Answer the pointChangedLastSend of the receiver"
	^ pointChangedLastSend
		ifNil: [pointChangedLastSend _ Time millisecondClockValue]! !

!SqCursorBehavior methodsFor: 'accessing' stamp: 'minami 5/10/2006 10:49'!
pointChangedLastSend: aValue
	"Modify the receiver's pointChangedLastSend"
	pointChangedLastSend := aValue! !

!SqCursorBehavior methodsFor: 'accessing' stamp: 'mu 5/8/2006 17:14'!
style
	"Answer the style of the receiver"
	<bewareOf: #styleChanged>
	^self propertyValueAt: #style! !

!SqCursorBehavior methodsFor: 'accessing' stamp: 'mu 5/8/2006 17:14'!
style: aValue
	"Modify the receiver's style"
	^self propertyValueAt: #style put: aValue with: #styleChanged! !

!SqCursorBehavior methodsFor: 'accessing' stamp: 'minami 5/10/2006 10:55'!
waitTime
	"Answer the waitTime of the receiver"
	waitTime ifNil: [waitTime :=  500].
	^ waitTime! !

!SqCursorBehavior methodsFor: 'accessing' stamp: 'minami 5/10/2006 10:54'!
waitTime: aValue
	"Modify the receiver's waitTime"
	waitTime := aValue! !

ElClient subclass: #SqAudioChatController
	instanceVariableNames: 'userList board'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat'!

SqAudioChatController class
	instanceVariableNames: 'default'!

!SqAudioChatController class methodsFor: 'instance creation' stamp: 'minami 4/12/2006 14:34'!
on: board 


	(SqClient hasOtherLoggedInClient: board userId) 
		ifTrue: [^ SqOtherUserLoggedIn signal].

	^ self new board: board;
		 yourself! !

!SqAudioChatController class methodsFor: 'defaults' stamp: 'minami 3/16/2006 17:14'!
serverAddress
	^ NetNameResolver addressForName: SqSettings audioChatServerHost.
! !

!SqAudioChatController methodsFor: 'defaults' stamp: 'minami 4/12/2006 12:21'!
audioChatClientClass
	^ SqAudioChatClient! !

!SqAudioChatController methodsFor: 'accessing' stamp: 'minami 3/9/2006 14:33'!
board
	^ board! !

!SqAudioChatController methodsFor: 'accessing' stamp: 'minami 3/9/2006 14:33'!
board: aBoard
	board := aBoard! !

!SqAudioChatController methodsFor: 'defaults' stamp: 'minami 4/12/2006 11:56'!
commandClientClass
	^ SqAudioChatCommandClient ! !

!SqAudioChatController methodsFor: 'initialize' stamp: 'minami 3/9/2006 10:43'!
initialize
	id := SqImageId current.
	monitor := Monitor new.
	self isRunning: false.
	logOnOk := false.
	dictionary := Dictionary new.
	dictionaryMutex := Semaphore forMutualExclusion.
	commandClient := self commandClientClass
		on: self
		id: id
		address: self class serverAddress
		port: self class commandPort.
	chatClient := self audioChatClientClass
		on: self
		id: id
		address: self class serverAddress
		port: self class chatPort.
! !

!SqAudioChatController methodsFor: 'private' stamp: 'minami 3/7/2006 19:01'!
isRunning: bool
	isRunning := bool.
	self signal: #isRunningChanged with: bool! !

!SqAudioChatController methodsFor: 'initialize' stamp: 'mu 4/6/2006 11:58'!
release
	self stop.
	commandClient ifNotNilDo: [:c | c release].
	chatClient ifNotNilDo: [:c | c release].
	board _ commandClient _ chatClient _ nil.
! !

!SqAudioChatController methodsFor: 'running' stamp: 'minami 5/11/2006 12:30'!
start
	monitor critical: [
		self isRunning ifTrue: [ ^ self ].
		[
			logOnOk := false.

			uname := self board userId.
			(uname isNil or: [ uname isEmpty ]) ifTrue: [ self isRunning: false. ^ self ].
			commandClient start.
			self tryLoggingOn ifFalse: [ PopUpMenu inform: 'Cannot login'. ^ self stop. ].
			chatClient start.
			self isRunning: true.
		] ifCurtailed: [
			self stop.
		].
	].
! !

!SqAudioChatController methodsFor: 'running' stamp: 'mu 4/4/2006 16:50'!
stop
	monitor critical: [
		self isRunning ifFalse: [ ^ self ].
		self isRunning: false.
		logOnOk := false.
		commandClient stop.
		chatClient stop.
	].
! !

!SqAudioChatController methodsFor: 'private' stamp: 'minami 5/11/2006 14:15'!
tryLoggingOn
	self sendLogOnCommandGroup: self board boardId.
	monitor waitFor: #LogOnOk maxSeconds: 5.
	^ logOnOk.
! !

!SqAudioChatController methodsFor: 'ui common' stamp: 'minami 3/16/2006 07:25'!
uiAddUserId: userId name: nickname
	userList ifNil: [^ nil].
	userList addUserId: userId nickname: nickname.
! !

!SqAudioChatController methodsFor: 'accessing' stamp: 'minami 3/7/2006 19:25'!
userList
	^ userList! !

!SqAudioChatController methodsFor: 'accessing' stamp: 'minami 3/7/2006 19:25'!
userList: aUserList
	userList := aUserList! !

TdTimer subclass: #SqSquareDiscovery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-Discovery'!

!SqSquareDiscovery class methodsFor: 'constants' stamp: 'mu 3/27/2006 12:03'!
defaultIntervalSeconds
	^ 15! !

!SqSquareDiscovery class methodsFor: 'constants' stamp: 'mu 3/27/2006 12:03'!
defaultPriority
	^ Processor userBackgroundPriority! !

!SqSquareDiscovery class methodsFor: 'class initialization' stamp: 'mu 3/27/2006 14:37'!
initialize
	"SqSquareDiscovery initialize"
	self default start! !

!SqSquareDiscovery class methodsFor: 'constants' stamp: 'mu 3/27/2006 12:32'!
serviceType
	^'SqSquare'! !

!SqSquareDiscovery methodsFor: 'actions' stamp: 'mu 3/31/2006 11:41'!
perform
	SqSettings useDiscovery ifFalse: [^self].
	self setServerLocations! !

!SqSquareDiscovery methodsFor: 'actions' stamp: 'mu 3/27/2006 15:17'!
setServerLocations
	| locator boardServices chatServices  |
	locator _ DsLocator defaultForBroadcast.
	boardServices := (locator
				servicesMatches: [:ent | ent type = self class serviceType
						and: [ent name = 'BoardService']]) asSortedCollection.
	boardServices
		ifNotEmptyDo: [:services | SqSettings serverHost: services first host].

	
	chatServices := (locator
				servicesMatches: [:ent | ent type = self class serviceType
						and: [ent name = 'ChatService']]) asSortedCollection.
	chatServices
		ifNotEmptyDo: [:services | SqSettings audioChatServerHost: services first host]! !

CPlayer subclass: #SqAudioChatPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat'!

SqAudioChatPanel defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="audioChatControl" toSet="audioChatControl:" changeEvent="audioChatControlChanged">audioChatControl</field>
</fields>'!

!SqAudioChatPanel class methodsFor: 'instance creation' stamp: 'minami 4/12/2006 12:16'!
control: audioChatControl
	^ super new audioChatControl: audioChatControl; yourself! !

!SqAudioChatPanel methodsFor: 'accessing' stamp: 'minami 4/12/2006 12:15'!
audioChatControl
	"Answer the audioChatControl of the receiver"
	<bewareOf: #audioChatControlChanged>
	^self propertyValueAt: #audioChatControl! !

!SqAudioChatPanel methodsFor: 'accessing' stamp: 'minami 4/12/2006 12:15'!
audioChatControl: aValue
	"Modify the receiver's audioChatControl"
	^self propertyValueAt: #audioChatControl put: aValue with: #audioChatControlChanged! !

!SqAudioChatPanel methodsFor: 'private accessing' stamp: 'minami 4/12/2006 12:17'!
chatClient
	self audioChatControl ifNil: [^ nil].
	^ self audioChatControl chatClient! !

!SqAudioChatPanel methodsFor: 'initialize' stamp: 'mu 4/5/2006 14:10'!
close
	costume ifNotNilDo: [:cos | cos close].
	self release.
	super close.! !

!SqAudioChatPanel methodsFor: 'private accessing' stamp: 'minami 4/12/2006 12:17'!
commandClient
	self audioChatControl ifNil: [^ nil].
	^ self audioChatControl commandClient! !

!SqAudioChatPanel methodsFor: 'initialize' stamp: 'minami 4/12/2006 11:58'!
defaultCostume
	^ SqAudioChatPanelCostume! !

!SqAudioChatPanel methodsFor: 'testing' stamp: 'minami 4/12/2006 12:17'!
isRunning
	self audioChatControl ifNil: [^ false].
	^ self audioChatControl isRunning! !

!SqAudioChatPanel methodsFor: 'initialize' stamp: 'minami 4/12/2006 14:47'!
release
	self audioChatControl ifNil: [^ self].

	self stop.
	self audioChatControl release.
	self audioChatControl: nil.! !

!SqAudioChatPanel methodsFor: 'running' stamp: 'minami 4/12/2006 12:17'!
start
	self audioChatControl ifNil: [^ self].
	self audioChatControl start! !

!SqAudioChatPanel methodsFor: 'running' stamp: 'minami 4/12/2006 14:53'!
stop
	self audioChatControl ifNotNilDo: [:cli | cli stop].
	self costume userList ifNotNilDo: [:list | list removeAll]! !

CPlayer subclass: #SqAudioChatUserList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat'!

SqAudioChatUserList defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!SqAudioChatUserList methodsFor: 'list' stamp: 'minami 3/16/2006 07:36'!
addUserId: id nickname: nickname
	| detected |
	detected := self costume contents detect: [:each | each player id = id] ifNone: [].
	detected ifNotNil: [^ self].
	self add: (SqAudioChatUserTile id: id nickname: nickname).
! !

!SqAudioChatUserList methodsFor: 'initialize' stamp: 'minami 3/7/2006 16:42'!
initialize
	super initialize! !

!SqAudioChatUserList methodsFor: 'list' stamp: 'minami 3/15/2006 19:18'!
removeAll
	[self userTiles size > 0]
		whileTrue: [self removeLast].
	self extent: 0@0.! !

!SqAudioChatUserList methodsFor: 'list' stamp: 'minami 3/7/2006 17:14'!
removeId: id
	| detected |
	detected := self costume contents detect: [:tile | tile id = id] ifNone: [].
	detected ifNotNil: [self remove: detected].
	! !

!SqAudioChatUserList methodsFor: 'initialize' stamp: 'minami 3/8/2006 11:13'!
setupCostume
	super setupCostume.
	self extent: 0@0.
	self layout: CTableLayout new.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self layout listDirection: #topToBottom.
! !

!SqAudioChatUserList methodsFor: 'list' stamp: 'minami 3/16/2006 07:30'!
speakers: speakers listeners: listeners
	self userTiles do: [ :tile |
		tile speaking: (speakers includes: tile id).
		tile listening: (listeners includes: tile id).
	].
! !

!SqAudioChatUserList methodsFor: 'running' stamp: 'minami 3/15/2006 19:22'!
startTileTicking
	self userTiles do: [:each | each start].! !

!SqAudioChatUserList methodsFor: 'running' stamp: 'minami 3/15/2006 19:18'!
stopTileTicking
	self userTiles do: [:each | each stop].! !

!SqAudioChatUserList methodsFor: 'private' stamp: 'mu 4/4/2006 17:26'!
userTiles
	^ self elements! !

CPlayer subclass: #SqAudioChatUserTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-AudioChat'!

SqAudioChatUserTile defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="id" toSet="id:" changeEvent="idChanged">id</field>
	<field toGet="nickname" toSet="nickname:" changeEvent="nicknameChanged">nickname</field>
	<field toGet="speaking" toSet="speaking:" changeEvent="speakingChanged">speaking</field>
	<field toGet="listening" toSet="listening:" changeEvent="listeningChanged">listening</field>
	<field toGet="speakingLamp" toSet="speakingLamp:" changeEvent="speakingLampChanged">speakingLamp</field>
	<field toGet="listeningLamp" toSet="listeningLamp:" changeEvent="listeningLampChanged">listeningLamp</field>
	<field toGet="nameLabel" toSet="nameLabel:" changeEvent="nameLabelChanged">nameLabel</field>
</fields>'!

!SqAudioChatUserTile class methodsFor: 'instance creation' stamp: 'minami 3/8/2006 16:20'!
id: id 
	^ self id: id nickname: id! !

!SqAudioChatUserTile class methodsFor: 'instance creation' stamp: 'minami 3/7/2006 17:02'!
id: id nickname: nickname 
	^ self new id: id;
		 nickname: nickname;
		 yourself! !

!SqAudioChatUserTile methodsFor: 'private' stamp: 'minami 3/7/2006 16:54'!
addSpacer: spacerExtent
	^ self addSpacer: spacerExtent color: Color transparent! !

!SqAudioChatUserTile methodsFor: 'private' stamp: 'minami 3/7/2006 16:54'!
addSpacer: spacerExtent color: spacerColor
	| aSpacer |
	aSpacer := CPlayer new.
	aSpacer borderWidth: 0.
	aSpacer extent: spacerExtent.
	aSpacer color: spacerColor.
	self add: aSpacer.
	^ aSpacer
	! !

!SqAudioChatUserTile methodsFor: 'private' stamp: 'minami 3/8/2006 11:35'!
colorOf: aBoolean 
	^ aBoolean
		ifTrue: [Color red]
		ifFalse: [Color gray]! !

!SqAudioChatUserTile methodsFor: 'private' stamp: 'minami 3/7/2006 16:51'!
createNewLamp
	^ CPlayer new color: Color lightGray;
		 extent: 8 @ 8;
		 yourself! !

!SqAudioChatUserTile methodsFor: 'defaults' stamp: 'minami 3/7/2006 19:30'!
defaultBackgroundColor
	^ Color white! !

!SqAudioChatUserTile methodsFor: 'defaults' stamp: 'minami 3/7/2006 16:58'!
defaultExtent
	^ 120@16! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 17:00'!
id
	"Answer the id of the receiver"
	<bewareOf: #idChanged>
	^self propertyValueAt: #id! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 17:00'!
id: aValue
	"Modify the receiver's id"
	^self propertyValueAt: #id put: aValue with: #idChanged! !

!SqAudioChatUserTile methodsFor: 'initialize' stamp: 'minami 3/15/2006 19:25'!
initialize
	super initialize.

	speaking := listening := false.
! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/8/2006 11:33'!
listening
	"Answer the listening of the receiver"
	<bewareOf: #listeningChanged>
	^self propertyValueAt: #listening! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:45'!
listeningLamp
	"Answer the listeningLamp of the receiver"
	<bewareOf: #listeningLampChanged>
	^self propertyValueAt: #listeningLamp! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:45'!
listeningLamp: aValue
	"Modify the receiver's listeningLamp"
	^self propertyValueAt: #listeningLamp put: aValue with: #listeningLampChanged! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/8/2006 11:33'!
listening: aValue
	"Modify the receiver's listening"
	^self propertyValueAt: #listening put: aValue with: #listeningChanged! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:52'!
nameLabel
	"Answer the nameLabel of the receiver"
	<bewareOf: #nameLabelChanged>
	^self propertyValueAt: #nameLabel! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:52'!
nameLabel: aValue
	"Modify the receiver's nameLabel"
	^self propertyValueAt: #nameLabel put: aValue with: #nameLabelChanged! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 17:00'!
nickname
	"Answer the nickname of the receiver"
	<bewareOf: #nicknameChanged>
	^self propertyValueAt: #nickname! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 17:00'!
nickname: aValue
	"Modify the receiver's nickname"
	^self propertyValueAt: #nickname put: aValue with: #nicknameChanged! !

!SqAudioChatUserTile methodsFor: 'events' stamp: 'minami 3/8/2006 12:14'!
onTick
	speakingLamp color: (self colorOf: self speaking).
	listeningLamp color: (self colorOf: self listening).
	speaking := false.
	listening := false.
! !

!SqAudioChatUserTile methodsFor: 'openning' stamp: 'minami 3/8/2006 15:09'!
open
	super open.
	self postOpen.! !

!SqAudioChatUserTile methodsFor: 'openning' stamp: 'minami 3/8/2006 15:09'!
postOpen
	self start! !

!SqAudioChatUserTile methodsFor: 'initialize' stamp: 'minami 3/8/2006 11:53'!
setupCostume
	super setupCostume.

	self layout: CTableLayout new.
	self hResizing: #spaceFill; vResizing: #shrinkWrap.
	self layout listDirection: #leftToRight.

	self extent: self defaultExtent.
	self color: self defaultBackgroundColor.
	self borderWidth: 1.
	self borderColor: Color black.	

	self listeningLamp: self createNewLamp.
	self add: self listeningLamp.

	self addSpacer: 2@8.

	self speakingLamp: self createNewLamp.
	self add: self speakingLamp.

	self addSpacer: 2@8.

	self nameLabel: (CLabel new label: self nickname; yourself).
	self add: self nameLabel.
! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/8/2006 11:33'!
speaking
	"Answer the speaking of the receiver"
	<bewareOf: #speakingChanged>
	^self propertyValueAt: #speaking! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:45'!
speakingLamp
	"Answer the speakingLamp of the receiver"
	<bewareOf: #speakingLampChanged>
	^self propertyValueAt: #speakingLamp! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/7/2006 16:45'!
speakingLamp: aValue
	"Modify the receiver's speakingLamp"
	^self propertyValueAt: #speakingLamp put: aValue with: #speakingLampChanged! !

!SqAudioChatUserTile methodsFor: 'accessing' stamp: 'minami 3/8/2006 11:33'!
speaking: aValue
	"Modify the receiver's speaking"
	^self propertyValueAt: #speaking put: aValue with: #speakingChanged! !

!SqAudioChatUserTile methodsFor: 'running' stamp: 'minami 3/15/2006 19:27'!
start
	self stop.
	self startTicking: #onTick at: 2! !

!SqAudioChatUserTile methodsFor: 'running' stamp: 'minami 3/8/2006 12:22'!
stop
	self stopScript: #onTick! !

CPlayer subclass: #SqBoardMap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqBoardMap defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="boardImage" toSet="boardImage:" changeEvent="boardImageChanged">boardImage</field>
	<field toGet="clientBoard" toSet="clientBoard:" changeEvent="clientBoardChanged">clientBoard</field>
	<field toGet="cursorPos" toSet="cursorPos:" changeEvent="cursorPosChanged">cursorPos</field>
	<field toGet="cursorExtent" toSet="cursorExtent:" changeEvent="cursorExtentChanged">cursorExtent</field>
	<field toGet="hBar" toSet="hBar:" changeEvent="hBarChanged">hBar</field>
	<field toGet="vBar" toSet="vBar:" changeEvent="vBarChanged">vBar</field>
	<field toGet="reductionRatio" toSet="reductionRatio:" changeEvent="reductionRatioChanged">reductionRatio</field>
	<field toGet="clientBoardScale" toSet="clientBoardScale:" changeEvent="clientBoardScaleChanged">clientBoardScale</field>
</fields>'!

!SqBoardMap class methodsFor: 'instance creation' stamp: 'minami 4/18/2006 16:47'!
for: clientBoard 
	^ self new
		 clientBoard: clientBoard;
		 hBar: clientBoard scroller hBar;
		 vBar: clientBoard scroller vBar;
		 onClientBoardGeometryChanged;
		 onVBarValueChanged;
		 onHBarValueChanged;
		 yourself! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 3/17/2006 16:13'!
boardImage
	"Answer the boardImage of the receiver"
	<bewareOf: #boardImageChanged>
	^self propertyValueAt: #boardImage! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 3/17/2006 16:13'!
boardImage: aValue
	"Modify the receiver's boardImage"
	^self propertyValueAt: #boardImage put: aValue with: #boardImageChanged! !

!SqBoardMap methodsFor: 'private' stamp: 'mu 3/16/2006 17:17'!
calculateReductionRatio: boardExtent
	| newRatio |
	newRatio := (boardExtent x max: boardExtent y) // self maxLength.
	self reductionRatio = newRatio ifTrue: [^ self].
	newRatio = 0 ifTrue: [newRatio := 1].
	^ self reductionRatio: newRatio! !

!SqBoardMap methodsFor: 'private' stamp: 'mu 4/11/2006 12:02'!
clearBoardImage
	self boardImage: nil.! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/27/2005 16:43'!
clientBoard
	"Answer the clientBoard of the receiver"
	<bewareOf: #clientBoardChanged>
	^self propertyValueAt: #clientBoard! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 4/19/2006 16:24'!
clientBoardScale
	"Answer the clientBoardScale of the receiver"
	<bewareOf: #clientBoardScaleChanged>
	^self propertyValueAt: #clientBoardScale! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 4/19/2006 16:24'!
clientBoardScale: aValue
	"Modify the receiver's clientBoardScale"
	^self propertyValueAt: #clientBoardScale put: aValue with: #clientBoardScaleChanged! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/27/2005 16:43'!
clientBoard: aValue
	"Modify the receiver's clientBoard"
	^self propertyValueAt: #clientBoard put: aValue with: #clientBoardChanged! !

!SqBoardMap methodsFor: 'defaults' stamp: 'minami 12/27/2005 16:02'!
cursorColor
	^ Color red! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/27/2005 16:44'!
cursorExtent
	"Answer the cursorExtent of the receiver"
	<bewareOf: #cursorExtentChanged>
	^self propertyValueAt: #cursorExtent! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/27/2005 16:44'!
cursorExtent: aValue
	"Modify the receiver's cursorExtent"
	^self propertyValueAt: #cursorExtent put: aValue with: #cursorExtentChanged! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/27/2005 15:58'!
cursorPos
	"Answer the cursorPos of the receiver"
	<bewareOf: #cursorPosChanged>
	^self propertyValueAt: #cursorPos! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/27/2005 15:58'!
cursorPos: aValue
	"Modify the receiver's cursorPos"
	^self propertyValueAt: #cursorPos put: aValue with: #cursorPosChanged! !

!SqBoardMap methodsFor: 'defaults' stamp: 'minami 2/23/2006 11:57'!
defaultWidth
	^ 150! !

!SqBoardMap methodsFor: 'drawing' stamp: 'minami 4/19/2006 16:25'!
drawOn: aCanvas in: drawingBounds
	aCanvas drawImage: self latestBoardImage at: 0@0.
	aCanvas frameRectangle: ((cursorPos / clientBoardScale) asIntegerPoint extent: cursorExtent) color: self cursorColor.
! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/28/2005 16:01'!
hBar
	"Answer the hBar of the receiver"
	<bewareOf: #hBarChanged>
	^self propertyValueAt: #hBar! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/28/2005 16:01'!
hBar: aValue
	"Modify the receiver's hBar"
	^self propertyValueAt: #hBar put: aValue with: #hBarChanged! !

!SqBoardMap methodsFor: 'drawing' stamp: 'minami 3/17/2006 16:21'!
hide
	self visible: false.
	self clearBoardImage! !

!SqBoardMap methodsFor: 'initialize' stamp: 'minami 4/19/2006 16:24'!
initialize
	super initialize.
	cursorPos := 0@0.
	cursorExtent := 0@0.
	
	reductionRatio := 5.
	clientBoardScale := 1.
	self setupCostume.

! !

!SqBoardMap methodsFor: 'testing' stamp: 'minami 3/9/2006 15:39'!
isDropAcceptable
	^ false.! !

!SqBoardMap methodsFor: 'private' stamp: 'minami 3/17/2006 16:16'!
latestBoardImage
	self boardImage ifNil: [self boardImage: (self clientBoard smallForm: self reductionRatio)].
	^ self boardImage! !

!SqBoardMap methodsFor: 'defaults' stamp: 'minami 2/23/2006 12:06'!
maxLength
	^ 150! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 4/19/2006 16:26'!
moveBoardView
	clientBoard scroller horizontalPos: (self cursorPos x * self reductionRatio * clientBoardScale) asInteger.
	clientBoard scroller verticalPos: (self cursorPos y * self reductionRatio * clientBoardScale) asInteger.! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 4/19/2006 16:28'!
onClientBoardChanged
	<on: clientBoardChanged>

	self clientBoard ifNil: [^ self].

	self clientBoardScale: self clientBoard scale! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 2/23/2006 12:17'!
onClientBoardDestroyed
	<on: destroy in: clientBoard>

	self destroy.! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 4/18/2006 16:51'!
onClientBoardGeometryChanged
	<on: geometryChanged in: clientBoard>

	self updateImage! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 4/18/2006 16:51'!
onClientBoardLayoutChanged
	<on: layoutChanged in: clientBoard>

	self updateImage! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 4/19/2006 16:42'!
onHBarValueChanged
	<on: valueChanged in: hBar>
	
	self onScrollBarValueChanged! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 3/17/2006 16:26'!
onMouseEnter
	<on: mouseEnter>

	self mouseCursor: CCursorLibrary handCursor.! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 3/29/2006 19:41'!
onRedButtonDown
	<on: redButtonDown>

	self clearBoardImage.

	self trailBoardView! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 3/29/2006 19:41'!
onRedButtonMove
	<on: redButtonMove>
	self trailBoardView! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 3/17/2006 16:24'!
onRedButtonUp
	<on: redButtonUp>

	self clearBoardImage.

	self mouseCursor: CCursorLibrary handCursor.! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 4/19/2006 16:42'!
onScrollBarValueChanged

	self cursorPos: ((hBar value / self reductionRatio) @ (vBar value / self reductionRatio))asIntegerPoint.
	self invalidate.! !

!SqBoardMap methodsFor: 'events' stamp: 'minami 4/19/2006 16:42'!
onVBarValueChanged
	<on: valueChanged in: vBar>
	
	self onScrollBarValueChanged! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 2/22/2006 17:02'!
reductionRatio
	"Answer the reductionRatio of the receiver"
	<bewareOf: #reductionRatioChanged>
	^self propertyValueAt: #reductionRatio! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 2/22/2006 17:02'!
reductionRatio: aValue
	"Modify the receiver's reductionRatio"
	^self propertyValueAt: #reductionRatio put: aValue with: #reductionRatioChanged! !

!SqBoardMap methodsFor: 'initialize' stamp: 'minami 12/27/2005 15:10'!
setupCostume
	self userDraw: true.
! !

!SqBoardMap methodsFor: 'drawing' stamp: 'minami 3/9/2006 17:04'!
show
	self visible: true! !

!SqBoardMap methodsFor: 'private' stamp: 'minami 4/19/2006 16:20'!
trailBoardView
	| topLeftPos newPos |
	self mouseCursor: CCursorLibrary fistCursor.

	topLeftPos := self globalToLocal: self hand position.
	newPos := topLeftPos - (self cursorExtent / 2).
	self cursorPos: newPos asIntegerPoint.
	self moveBoardView.
	self invalidate! !

!SqBoardMap methodsFor: 'private' stamp: 'minami 4/19/2006 16:25'!
updateImage
	self clearBoardImage.

	self clientBoardScale: clientBoard scale.
	self calculateReductionRatio: clientBoard extent.

	self extent: (clientBoard extent / self reductionRatio) asIntegerPoint.
	self cursorExtent: (clientBoard viewPort extent / self reductionRatio / clientBoard scale) asIntegerPoint.
	self invalidate.! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/28/2005 16:01'!
vBar
	"Answer the vBar of the receiver"
	<bewareOf: #vBarChanged>
	^self propertyValueAt: #vBar! !

!SqBoardMap methodsFor: 'accessing' stamp: 'minami 12/28/2005 16:01'!
vBar: aValue
	"Modify the receiver's vBar"
	^self propertyValueAt: #vBar put: aValue with: #vBarChanged! !

CPlayer subclass: #SqBoardPanel
	instanceVariableNames: 'board'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqSquare-Client-UI'!

SqBoardPanel defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="boardScrollPane" toSet="boardScrollPane:" changeEvent="boardScrollPaneChanged">boardScrollPane</field>
	<field toGet="audioChatPanel" toSet="audioChatPanel:" changeEvent="audioChatPanelChanged">audioChatPanel</field>
	<field toGet="controllerPane" toSet="controllerPane:" changeEvent="controllerPaneChanged">controllerPane</field>
	<field instanceVariable="true" toGet="board" toSet="board:">board</field>
</fields>'!

!SqBoardPanel class methodsFor: 'debug' stamp: 'minami 4/28/2006 15:07'!
closeAll
"
SqBoardPanel closeAll.
"
	self allInstancesDo: [:e | e close].
	Smalltalk garbageCollect.! !

!SqBoardPanel class methodsFor: 'instance creation' stamp: 'minami 4/12/2006 14:34'!
on: aBoard 
	^ self new setBoard: aBoard;
		 yourself! !

!SqBoardPanel methodsFor: 'menu' stamp: 'mu 4/10/2006 12:32'!
addExtentMenuOn: aMenu
	| menu |
	menu := CMenu new.
	menu add: '800x600' target: self action: #setBoardExtent: argument: 800@600.
	menu add: '1600x1200' target: self action: #setBoardExtent: argument: 1600@1200.
	menu add: '2400x1800' target: self action: #setBoardExtent: argument: 2400@1800.
	menu add: '3200x2400' target: self action: #setBoardExtent: argument: 3200@2400.
	menu add: '4000x3000' target: self action: #setBoardExtent: argument: 4000@3000.	
	menu add: 'other...' action: [self setBoardExtent: (Point readFrom: (FillInTheBlank request: 'extent? x@y'))].	
	aMenu add: 'Extent' subMenu: menu.
	^aMenu! !

!SqBoardPanel methodsFor: 'actions' stamp: 'mu 5/12/2006 14:23'!
addPainter
	| painter painted |
	painter _ CPainter new.
	painter hResizing: #spaceFill; vResizing: #spaceFill.
	painter layoutFrame: self rightFrame.
	self add: painter.

	painter board painting: (Form extent: ((400@400) max: self boardScrollPane extent) depth: 32).

	painted _ painter board croppedPaintingPlayer.
	painter target: painted.

	self waitTick.
	self startScript: [ 
		| pos |
		pos _ self board container globalBounds topLeft - self board globalBounds topLeft.
		self board addPlayer: painted.
		self waitTick.
		painted topLeft: pos + painter newPlayer topLeft.
	] when: {painter palette. #ok}.

	^painter! !

!SqBoardPanel methodsFor: 'menu' stamp: 'mu 4/10/2006 12:40'!
addScaleMenuOn: aMenu
	| menu |
	menu := CMenu new.
	#(0.2 0.4 0.6 0.8 1.0 1.2 1.6 2.0 3.0 4.0) do: [:each | 
		menu add: each asString target: self action: #setBoardScale: argument: each.
	].
	menu add: 'other...' action: [self setBoardScale: (Number readFrom: (FillInTheBlank request: 'scale?'))].	
	aMenu add: 'Scale' subMenu: menu.
	^aMenu! !

!SqBoardPanel methodsFor: 'board access' stamp: 'minami 4/20/2006 17:00'!
addToBoard: aPlayer at: aPoint
	self board addPlayer: aPlayer.
	aPlayer position: aPoint.! !

!SqBoardPanel methodsFor: 'accessing' stamp: 'minami 4/12/2006 12:13'!
audioChatPanel
	"Answer the audioChatPanel of the receiver"
	<bewareOf: #audioChatPanelChanged>
	^self propertyValueAt: #audioChatPanel! !

!SqBoardPanel methodsFor: 'accessing' stamp: 'minami 4/12/2006 12:13'!
audioChatPanel: aValue
	"Modify the receiver's audioChatPanel"
	^self propertyValueAt: #audioChatPanel put: aValue with: #audioChatPanelChanged! !

!SqBoardPanel methodsFor: 'actions' stamp: 'minami 4/14/2006 12:18'!
beActive
"
	self startAudioChat
"! !

!SqBoardPanel methodsFor: 'actions' stamp: 'minami 3/23/2006 07:56'!
beBackground
	self stopAudioChat! !

!SqBoardPanel methodsFor: 'accessing' stamp: 'mu 4/5/2006 13:52'!
board
	"Answer the board of the receiver"
	^board! !

!SqBoardPanel methodsFor: 'board access' stamp: 'minami 3/22/2006 20:26'!
boardId
	^ self board boardId! !

!SqBoardPanel methodsFor: 'accessing' stamp: 'mu 4/5/2006 14:42'!
boardScrollPane
	"Answer the boardScrollPane of the receiver"
	<bewareOf: #boardScrollPaneChanged>
	^self propertyValueAt: #boardScrollPane! !

!SqBoardPanel methodsFor: 'accessing' stamp: 'mu 4/5/2006 14:42'!
boardScrollPane: aValue
	"Modify the receiver's boardScrollPane"
	^self propertyValueAt: #boardScrollPane put: aValue with: #boardScrollPaneChanged! !

!SqBoardPanel methodsFor: 'accessing' stamp: 'mu 4/5/2006 13:52'!
board: aValue
	"Modify the receiver's board"
	board := aValue! !

!SqBoardPanel methodsFor: 'building' stamp: 'minami 4/12/2006 12:14'!
buildAudioChatPanel
	^ SqAudioChatPanel new.! !

!SqBoardPanel methodsFor: 'building' stamp: 'mu 4/5/2006 14:41'!
buildBoardScrollPane
	| holder |
	holder := CScrollPane new.

	holder hResizing: #spaceFill; vResizing: #spaceFill.
	holder hScrollable: true; vScrollable: true.
	holder color: self defaultBackgroundColor.

	holder costume: SqScrollPaneCostume new.

	^ holder
! !

!SqBoardPanel methodsFor: 'building' stamp: 'minami 4/12/2006 15:08'!
buildControllerPane
	| aPane |
	aPane := CPlayer new.

	aPane layout: CTableLayout new.
	aPane hResizing: #rigit; vResizing: #spaceFill.
	aPane layout listDirection: #topToBottom.
	aPane color: self defaultBackgroundColor.
	aPane width: self controllerPaneWidth.

	^ aPane
! !

!SqBoardPanel methodsFor: 'building' stamp: 'minami 4/12/2006 15:08'!
buildSettingsButton
	^ CButton new label: 'settings';
		 hResizing: #rigit;
		 vResizing: #shrinkWrap;
		 width: self controllerPaneWidth;
		 yourself
! !

!SqBoardPanel methodsFor: 'initialize' stamp: 'mu 4/11/2006 11:21'!
close
	super close.
	self components do: [:each | each ifNotNilDo: [:c | c close]]. "for fast gc"
	Processor activeProject ifNotNilDo: [:proj | proj trashManager removeFromTrash: self].
	self release.
! !

!SqBoardPanel methodsFor: 'accessing' stamp: 'minami 3/9/2006 12:17'!
controllerPane
	"Answer the controllerPane of the receiver"
	<bewareOf: #controllerPaneChanged>
	^self propertyValueAt: #controllerPane! !

!SqBoardPanel methodsFor: 'defaults' stamp: 'minami 4/12/2006 15:10'!
controllerPaneWidth
	^ 96! !

!SqBoardPanel methodsFor: 'accessing' stamp: 'minami 3/9/2006 12:17'!
controllerPane: aValue
	"Modify the receiver's controllerPane"
	^self propertyValueAt: #controllerPane put: aValue with: #controllerPaneChanged! !

!SqBoardPanel methodsFor: 'board access' stamp: 'minami 3/22/2006 18:46'!
currentPos
	^ self horizontalPos @ self verticalPos! !

!SqBoardPanel methodsFor: 'board access' stamp: 'minami 3/22/2006 18:49'!
currentPos: pos
	self horizontalPos: pos x.
	self verticalPos: pos y.! !

!SqBoardPanel methodsFor: 'defaults' stamp: 'minami 3/9/2006 14:19'!
defaultBackgroundColor
	^ Color lightGray! !

!SqBoardPanel methodsFor: 'board access' stamp: 'mu 4/5/2006 14:43'!
hBar
	^ self boardScrollPane costume hScrollBar! !

!SqBoardPanel methodsFor: 'board access' stamp: 'minami 3/9/2006 15:31'!
horizontalPos
	^ self hBar value! !

!SqBoardPanel methodsFor: 'board access' stamp: 'minami 3/9/2006 15:32'!
horizontalPos: int
	self hBar value: int! !

!SqBoardPanel methodsFor: 'initialize' stamp: 'minami 4/14/2006 14:02'!
initialize
	super initialize.

	self define: #controllerPane as: self buildControllerPane.
	self define: #audioChatPanel as: self buildAudioChatPanel.
	self define: #boardScrollPane as: self buildBoardScrollPane.
	! !

!SqBoardPanel methodsFor: 'testing' stamp: 'minami 3/9/2006 15:43'!
isDropAcceptable
	^ false.! !

!SqBoardPanel methodsFor: 'layout' stamp: 'mu 5/12/2006 14:14'!
leftFrame
	| aFrame |
	aFrame _ CLayoutFrame new.
	aFrame leftFraction: 0.0;
		 topFraction: 0.0;
		 bottomFraction: 1.0.
	^ aFrame! !

!SqBoardPanel methodsFor: 'events' stamp: 'mu 3/17/2006 14:58'!
onSettingsButtonFired
	<on: fire in: settingsButton>

	self board ifNil: [^ self].
	self openSettingsMenu! !

!SqBoardPanel methodsFor: 'menu' stamp: 'minami 4/14/2006 13:54'!
openExtentMenu
	| menu |
	menu := CMenu new.
	menu add: '800x600' target: self action: #setBoardExtent: argument: 800@600.
	menu add: '1600x1200' target: self action: #setBoardExtent: argument: 1600@1200.
	menu add: '2400x1800' target: self action: #setBoardExtent: argument: 2400@1800.
	menu add: '3200x2400' target: self action: #setBoardExtent: argument: 3200@2400.
	menu add: '4000x3000' target: self action: #setBoardExtent: argument: 4000@3000.	
	menu add: 'other...' action: [self setBoardExtent: (Point readFrom: (FillInTheBlank request: 'extent? x@y'))].	
	
	^ menu open! !

!SqBoardPanel methodsFor: 'menu' stamp: 'mu 4/10/2006 12:38'!
openSettingsMenu
	| menu |
	menu := CMenu new.
	self addExtentMenuOn: menu.
	self addScaleMenuOn: menu.
	menu add: 'TEST' target: CDialog action: #inform: argument: 'The last item was selected'.
	menu label: 'Settings'.
	^menu open! !

!SqBoardPanel methodsFor: 'initialize' stamp: 'mu 5/8/2006 12:26'!
release
	self board release.
	boardScrollPane _ audioChatPanel _ controllerPane _ nil.
	board _ nil.
! !

!SqBoardPanel methodsFor: 'zoom' stamp: 'minami 4/13/2006 12:27'!
resetScale
	self board ifNil: [^ self].

	self setBoardScale: 1! !

!SqBoardPanel methodsFor: 'layout' stamp: 'mu 5/12/2006 14:13'!
rightFrame
	| aFrame |
	aFrame _ CLayoutFrame new.
	aFrame leftFraction: 0;
		 leftOffset: self controllerPane width;
		 topFraction: 0.0;
		 bottomFraction: 1.0;
		 rightFraction: 1.0.
	^ aFrame! !

!SqBoardPanel methodsFor: 'board access' stamp: 'minami 4/13/2006 14:42'!
selectionMode
	^ self board selectionMode! !

!SqBoardPanel methodsFor: 'scaling/extent' stamp: 'mu 4/10/2006 12:31'!
setBoardExtent: aPoint

	self board ifNotNilDo: [:b |
		b setExtent: aPoint
	]! !

!SqBoardPanel methodsFor: 'scaling/extent' stamp: 'minami 4/18/2006 17:10'!
setBoardScale: aValue

	self board ifNotNilDo: [:b |
		b scale: aValue.
		b topLeft: b container topLeft.
	]! !

!SqBoardPanel methodsFor: 'actions' stamp: 'minami 4/12/2006 14:46'!
setBoard: aBoard
	self board: aBoard.
	self boardScrollPane addLast: aBoard.

	[
		self audioChatPanel 
			audioChatControl: (SqAudioChatController on: aBoard).
	] on: SqOtherUserLoggedIn do: [ :ex |
		self audioChatPanel close.
		self audioChatPanel audioChatControl: nil.
	]! !

!SqBoardPanel methodsFor: 'actions' stamp: 'minami 4/14/2006 15:09'!
setSelectionMode: aSymbol
	self board setSelectionMode: aSymbol! !

!SqBoardPanel methodsFor: 'initialize' stamp: 'mu 5/12/2006 14:14'!
setupCostume
	super setupCostume.
	self layout: CProportionalLayout new.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self extent: 400@300.

	self controllerPane addLast: audioChatPanel.

	self controllerPane hResizing: #spaceFill; vResizing: #spaceFill.
	self controllerPane layoutFrame: self leftFrame.
	self add: self controllerPane.

	self boardScrollPane hResizing: #spaceFill; vResizing: #spaceFill.
	self boardScrollPane layoutFrame: self rightFrame.
	self add: self boardScrollPane.

	
! !

!SqBoardPanel methodsFor: 'actions' stamp: 'minami 4/12/2006 14:43'!
startAudioChat
	self audioChatPanel ifNotNilDo: [:panel | panel start]! !

!SqBoardPanel methodsFor: 'actions' stamp: 'minami 4/12/2006 12:13'!
stopAudioChat
	self audioChatPanel ifNotNilDo: [:cha | cha stop]! !

!SqBoardPanel methodsFor: 'accessing' stamp: 'minami 3/17/2006 14:30'!
title
	^ self board
		ifNil: ['not login']
		ifNotNil: [self board boardName]! !

!SqBoardPanel methodsFor: 'board access' stamp: 'mu 4/5/2006 14:43'!
vBar
	^ self boardScrollPane costume vScrollBar! !

!SqBoardPanel methodsFor: 'board access' stamp: 'minami 3/9/2006 15:31'!
verticalPos
	^ self vBar value! !

!SqBoardPanel methodsFor: 'board access' stamp: 'minami 3/9/2006 15:32'!
verticalPos: int
	self vBar value: int! !

!SqBoardPanel methodsFor: 'zoom' stamp: 'minami 4/13/2006 12:27'!
zoomIn
	| currentScale |
	self board ifNil: [^ self].
	
	currentScale := self board scale.

	currentScale < 2 ifTrue: [
		self setBoardScale: (currentScale + 0.1) 
	].

	! !

!SqBoardPanel methodsFor: 'zoom' stamp: 'minami 4/13/2006 12:28'!
zoomOut
	| currentScale |
	self board ifNil: [^ self].
	
	currentScale := self board scale.

	currentScale >= 0.2 ifTrue: [
		self setBoardScale: (currentScale - 0.1) 
	].

	! !
SqClient initialize!
SqAudioChatPanelCostume initialize!
SqSquareDiscovery initialize!
